CCC   #################################################################
CCC   bdy0read()
CCC   for reading data table of the zero temperature boudary in SPheRIO \(^^)
CCC   #################################################################
CCC   last updated 08092006
CCC    
CCC   inherited and modified from bdyread()
CCC   #################################################################
      SUBROUTINE bdy0read() 

      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.bdy0.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'
      
      INTEGER itt
      CHARACTER filename1*108, filename2*108
      CHARACTER chtemp*200
      DOUBLE PRECISION dptemp

CCC   == DATA READING == //////////////////////////////////////
c     outputs come from "diagram"
      

      filename1= fneos(1:nfneos)//eosdatapath2//zerof1
      filename2= fneos(1:nfneos)//eosdatapath2//zerof2

      open(10,FILE=filename1,status='old')
      read(10,*) ittx0
      read(10,'(a49)')chtemp
      lpqittqgp0: do itt=1,ittx0
      	read(10,'(7d30.20)')dptemp,dptemp,dptemp,bdyeedstqgp0(itt),
     &    bdytpdstqgp0(itt),bdybbdstqgp0(itt),dptemp	!input
      enddo lpqittqgp0
      close(10)
      open(10,FILE=filename2,status='old')
      read(10,*) ittx0
      read(10,'(a49)')chtemp
      lpqitthrg0: do itt=1,ittx0
      	read(10,'(7d30.20)')dptemp,dptemp,dptemp,bdyeedsthrg0(itt),
     &    bdytpdsthrg0(itt),bdybbdsthrg0(itt),dptemp	!input
      enddo lpqitthrg0
      close(10)

c      write(*,*)'bdybbdsthrg0(ittx0)=',bdybbdsthrg0(ittx0)

      RETURN
      STOP
      END 



CCC   #################################################################
CCC   bdyread()
CCC   for reading data table of the phase boudary in SPheRIO \(^^) 
CCC   #################################################################
CCC   last updated 08092006
CCC    
CCC   inherited and modified from digread()
CCC   #################################################################
      SUBROUTINE bdyread() 

      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.bdy.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'
      
      INTEGER itt
      CHARACTER filename1*108, filename2*108
      CHARACTER chtemp*200
      DOUBLE PRECISION dptemp

CCC   == DATA READING == //////////////////////////////////////
c     outputs come from "diagram"
      

      filename1= fneos(1:nfneos)//eosdatapath2//bdyf1
      filename2= fneos(1:nfneos)//eosdatapath2//bdyf2


      open(10,FILE=filename1,status='old')
      read(10,*) ittx
      read(10,'(a117)')chtemp
      lpqittqgp: do itt=1,ittx
        read(10,'(15d19.10)')bdytt(itt),bdymbdstqgp(itt),
     &    bdymsdstqgp(itt),bdyeedstqgp(itt),
     &    bdytpdstqgp(itt),bdybbdstqgp(itt),dptemp,dptemp,dptemp,
     &    dptemp,dptemp,dptemp,dptemp,dptemp,dptemp	!input
      enddo lpqittqgp
      close(10)
      open(10,FILE=filename2,status='old')
      read(10,*) ittx
      read(10,'(a117)')chtemp
      lpqitthrg: do itt=1,ittx
      	read(10,'(15d19.10)')bdytt(itt),bdymbdsthrg(itt),
     &    bdymsdsthrg(itt),dptemp,dptemp,
     &    dptemp,dptemp,dptemp,dptemp,bdyeedsthrg(itt),bdytpdsthrg(itt),
     &    bdybbdsthrg(itt),dptemp,dptemp,dptemp	!input
      enddo lpqitthrg
      close(10)

c      write(*,*)'bdybbdsthrg(ittx)=',bdybbdsthrg(ittx)

      RETURN
      STOP
      END 



CCC   #################################################################
CCC   for reading data table of the phase diagram in SPheRIO \(^^) 
CCC   
CCC   last updated 04302006
CCC    
CCC   spherio.mixph.inc is included
CCC   containing information of the COMMON data blocks
CCC   as a first step, the subroutine do not read from the file,
CCC   but assign the new data for strangeness chemical potential
CCC   to be zero
CCC   the following array has been changed in COMMON block mix1
CCC   rgh(1:5,150)->rgh(1:6,150)
CCC   qgh(1:5,150)->qgh(1:6,150)
CCC   2 new variable musq and musr
CCC   the strangeness chemical potentials are added in mix2
CCC
CCC   spherio.fnames.inc is included
CCC   where the SPheRIO root path and input filenames are stored
CCC
CCC   spherio.const.inc is included
CCC   which stores some constant numbers
CCC   #################################################################
      SUBROUTINE digread() 

      IMPLICIT NONE 
      include 'spherio.mixph.inc'
      include 'epos.incsf'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'
      
      INTEGER nn,mm
      CHARACTER filename1*108, filename2*108

CCC   == DATA READING == //////////////////////////////////////
c     outputs come from "diagram"
      

      filename1= fneos(1:nfneos)//eosdatapath1//mixphf1
      filename2= fneos(1:nfneos)//eosdatapath1//mixphf2

      nn=0 
      open(10,file=filename1,status='old')
 11   continue 
      nn=nn+1 
      read(10,'(5d16.8)',end=13) 
     &     rgh(1,nn),rgh(2,nn),rgh(3,nn),rgh(4,nn),rgh(5,nn)

CCC   temporary setting for debug purpose only
           rgh(6,nn)=zero
CCC   temporary setting for debug purpose only

      goto 11
 13   continue
      close(10) 
      nn=0
      open(10,file=filename2,status='old')
 15   continue 
      nn=nn+1 
      read(10,'(5d16.8)',end=17) 
     &     qgh(1,nn),qgh(2,nn),qgh(3,nn),qgh(4,nn),qgh(5,nn)
      goto 15

CCC   temporary setting for debug purpose only
           qgh(6,nn)=zero
CCC   temporary setting for debug purpose only

 17   continue
      close(10) 
      
      mbinx=nn-1 
      if(mbinx.gt.150) stop' = mbinx exceeds 150 in eosmain.f = ' 
CCC   ///////////////////////////== DATA READING END == ///////
      eqmax= zero 
      sqmax=zero
      ermax= zero 
      srmax=zero
      eqmin= 9.99d+99
      ermin= 9.99d+99
      do mm=1,mbinx
         eq(mm)=qgh(3,mm)
         sq(mm)=qgh(4,mm)
         nq(mm)=qgh(5,mm)
         er(mm)=rgh(3,mm)
         sr(mm)=rgh(4,mm)
         nr(mm)=rgh(5,mm)
CCC   #################################################################
CCC   settings to incorporate strangeness
         musr(mm)=rgh(6,nn)
         musq(mm)=qgh(6,nn)
CCC   #################################################################

         if(eqmax.lt.eq(mm)) eqmax=eq(mm)
         if(eqmin.gt.eq(mm)) eqmin=eq(mm)
         if(sqmax.lt.sq(mm)) sqmax=sq(mm)
         if(srmax.lt.sr(mm)) srmax=sr(mm)
         if(ermax.lt.er(mm)) ermax=er(mm)
         if(ermin.gt.er(mm)) ermin=er(mm)
      end do
      RETURN
      STOP 234
      END 



CCC   #################################################################
CCC   eosoutput()
CCC   EoS information output subroutine
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 09162013
CCC   built based on eosphtrial
CCC   #################################################################
      SUBROUTINE eosoutput()
      IMPLICIT NONE
      include 'spherio.eos.inc'
      include 'spherio.debug.inc'
      include 'spherio.bdy.inc'
      include 'spherio.mixph.inc'
      include 'spherio.mixdata.inc'
      include 'spherio.evgen3.inc'
      include 'epos.incsf'
      integer itt,ittmax,iplot
      double precision rtemp,rmub
      double precision rmubmin,rmubmax,rtempmin,rtempmax
      integer m1,m2,k1,k2
      double precision xx(1:200),yy(1:200)
      integer phsflg,ijustdoit
      double precision x0,x1,y0,y1,pp,yint
      double precision esq(1:5,0:2),esr(1:5,0:2),es(1:5,0:2)
      double precision xfactor
      double precision eed,eedmin,eedmax
CCC   ################################################################
      iplot=3 !(1) phase boundary (2) p vs. rho_b (3) e/T^4 vs. T
      ittmax=100
      write(*,*)'iplot=',iplot
      write(*,*)'ieosmode=',ieosmode
CCC   #################################################################
      select case (iplot)
      case (1)
CCC   #################################################################
      select case (ieosmode)
      case (1)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'rhobqgp tempqpg1 mubq rhobrg temprg1 mubrg'
        close(70)
       do itt=1,mbinx
         open(70,file=fneoe(1:nfneoe),access='append')
         write(70,'(6d20.10)')qgh(5,itt),qgh(1,itt),qgh(2,itt),
     &    rgh(5,itt),rgh(1,itt),rgh(2,itt)
         close(70)
       enddo
CCC   #################################################################
      case (2)
         open(70,file=fneoe(1:nfneoe),status='replace')
         write(70,'(a)') 'temp2 rhobqgp mubq musq rhobrg mubrg musrg'
         close(70)
       do itt=1,ittx
         open(70,file=fneoe(1:nfneoe),access='append')
         write(70,'(7d20.10)')bdytt(itt),
     &   bdybbdstqgp(itt),bdymbdstqgp(itt),bdymsdstqgp(itt),
     &   bdybbdsthrg(itt),bdymbdsthrg(itt),bdymsdsthrg(itt)
         close(70)
       enddo
CCC   #################################################################
      case default
       continue
      end select
CCC   #################################################################
      case (2)
CCC   #################################################################
      select case (ieosmode)
      case (1)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'rhob pressure energydensity entropydensity mub'
        close(70)
        rtemp=0.15d0
!since there is no phsjdg can be used here, if any, the implemented one as in phsjdg_eos01_tmu(), which checks the boundary dynamically from the table of mixed event, is not efficient. so we deal it manually by the known phase structure
!hadron phase
        phsflg=0       !! hadrons
        rmubmin=0.d0
        do m1=1,mbinx
           xx(m1)= rgh(1,m1) !temperature
           yy(m1)= rgh(2,m1) !baryonic chemical potential
        end do
        call locate(xx,mbinx,rtemp,m2)
        write(*,*)'m2, mbinx: ',m2,mbinx
        if(m2.eq.0) then
           k1=1
           k2=2
           ijustdoit=0
        else if(m2.eq.mbinx) then
           k1=mbinx-1
           k2=mbinx
           ijustdoit=1
        else
           k1=m2
           k2=m2+1
           ijustdoit=1
        end if
        if (ijustdoit.eq.1) then
           x0=xx(k1)
           x1=xx(k2)
           y0=yy(k1)
           y1=yy(k2)
           pp=(rtemp-x0)/(x1-x0)
           yint=(1.d0-pp)*y0+pp*y1
           write(*,*)'the temperature and interpolated mub: ',rtemp,yint
           write(*,*)'y0,y1,pp: ',y0,y1,pp
           rmubmax=yint
           do itt=1,ittmax
              rmub=rmubmin+(rmubmax-rmubmin)*(itt-1.d0)/(ittmax-1.d0)
              call thintp(phsflg,rtemp,rmub,es)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(5d20.10)')es(3,0),es(4,0),es(1,0),es(2,0),rmub
              close(70)
           enddo
        endif
!mixed phase
        phsflg=1       !! mixed
        rmub=yint
        if (ijustdoit.eq.1) then
           do itt=1,ittmax
              xfactor=0.d0+(1.d0-0.d0)*(itt-1.d0)/(ittmax-1.d0)
              call thintp(0,rtemp,rmub,esr)
              call thintp(2,rtemp,rmub,esq)
              es(1,0)= esr(1,0)*(1.d0-xfactor) + esq(1,0)*(xfactor)
              es(2,0)= esr(2,0)*(1.d0-xfactor) + esq(2,0)*(xfactor)
              es(3,0)= esr(3,0)*(1.d0-xfactor) + esq(3,0)*(xfactor)
              es(4,0)= esq(4,0)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(5d20.10)')es(3,0),es(4,0),es(1,0),es(2,0),rmub
              close(70)
           enddo
        endif
!QGP phase
        phsflg=2       !! plasma
        rmubmin=yint
        rmubmax=1.5* rgh(2,mbinx)
        ijustdoit=1 !alway enters QGP phase via T=const
        if (ijustdoit.eq.1) then
           do itt=1,ittmax
              rmub=rmubmin+(rmubmax-rmubmin)*(itt-1.d0)/(ittmax-1.d0)
              call thintp(phsflg,rtemp,rmub,es)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(5d20.10)')es(3,0),es(4,0),es(1,0),es(2,0),rmub
              close(70)
           enddo
        endif
CCC   #################################################################
      case (2)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'rhob pressure energydensity entropydensity mub'
        close(70)
        rtemp=0.15d0
        phsflg=0       !! hadrons
!        rmubmin=0.2d0                                !interpolation problem below this point, note that xx_ub(1,1) cannot be used since table has adopted dynamic lower boundary
        rmubmin=0.1d0
        do m1=1,ittx
           xx(m1)= bdytt(m1)		!temperature
           yy(m1)= bdymbdsthrg(m1)	!baryonic chemical potential
        end do
        call locate(xx,ittx,rtemp,m2)
        write(*,*)'m2, ittx: ',m2,ittx
        if(m2.eq.0) then
           k1=1
           k2=2
           ijustdoit=0
        else if(m2.eq.ittx) then
           k1=ittx-1
           k2=ittx
           ijustdoit=1
        else
           k1=m2
           k2=m2+1
           ijustdoit=1
        end if
        if (ijustdoit.eq.1) then
           x0=xx(k1)
           x1=xx(k2)
           y0=yy(k1)
           y1=yy(k2)
           pp=(rtemp-x0)/(x1-x0)
           yint=(1.d0-pp)*y0+pp*y1
           write(*,*)'the temperature and interpolated mub: ',rtemp,yint
           write(*,*)'y0,y1,pp: ',y0,y1,pp
           rmubmax=yint
           write(*,*)'HG phase rmubmin,rmubmax=',rmubmin,rmubmax
           do itt=1,ittmax
              rmub=rmubmin+(rmubmax-rmubmin)*(itt-1.d0)/(ittmax-1.d0)
              call geteosesx_tmub(eos,rtemp,rmub,phsflg)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(5d20.10)')eos(3),eos(4),eos(1),eos(2),rmub
              close(70)
           enddo
        endif
!mixed phase
        phsflg=1       !! mixed
        rmubmin=rmubmax
        do m1=1,ittx
           xx(m1)= bdytt(m1)		!temperature
           yy(m1)= bdymbdstqgp(m1)	!baryonic chemical potential
        end do
        call locate(xx,ittx,rtemp,m2)
        write(*,*)'m2, ittx: ',m2,ittx
        if(m2.eq.0) then
           k1=1
           k2=2
           ijustdoit=0
        else if(m2.eq.ittx) then
           k1=ittx-1
           k2=ittx
           ijustdoit=1
        else
           k1=m2
           k2=m2+1
           ijustdoit=1
        end if
        if (ijustdoit.eq.1) then
           x0=xx(k1)
           x1=xx(k2)
           y0=yy(k1)
           y1=yy(k2)
           pp=(rtemp-x0)/(x1-x0)
           yint=(1.d0-pp)*y0+pp*y1
           write(*,*)'the temperature and interpolated mub: ',rtemp,yint
           write(*,*)'y0,y1,pp: ',y0,y1,pp
           rmubmax=yint
           write(*,*)'mixed phase rmubmin,rmubmax=',rmubmin,rmubmax
           do itt=1,ittmax
              rmub=rmubmin+(rmubmax-rmubmin)*(itt-1.d0)/(ittmax-1.d0)
              call geteosesx_tmub(eos,rtemp,rmub,phsflg)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(5d20.10)')eos(3),eos(4),eos(1),eos(2),rmub
              close(70)
           enddo
        endif
!QGP phase
        phsflg=2       !! plasma
        rmubmin=yint
        rmubmax=1.5* bdymbdstqgp(ittx)
        write(*,*)'QGP phase rmubmin,rmubmax=',rmubmin,rmubmax
        ijustdoit=1 !alway enters QGP phase via T=const
        if (ijustdoit.eq.1) then
           do itt=1,ittmax
              rmub=rmubmin+(rmubmax-rmubmin)*(itt-1.d0)/(ittmax-1.d0)
              call geteosesx_tmub(eos,rtemp,rmub,phsflg)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(5d20.10)')eos(3),eos(4),eos(1),eos(2),rmub
              close(70)
           enddo
        endif
CCC   #################################################################
      case (7)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'rhob pressure energydensity entropydensity mub'
        close(70)
        rtemp=0.15d0
        rmubmin=0.d0
        rmubmax=1.8d0 !according to phase diagram
        do itt=1,ittmax
            rmub=rmubmin+(rmubmax-rmubmin)*(itt-1.d0)/(ittmax-1.d0)
            call thintp_crossover(rtemp,rmub,es)
            open(70,file=fneoe(1:nfneoe),access='append')
            write(70,'(5d20.10)')es(3,0),es(4,0),es(1,0),es(2,0),rmub
            close(70)
        enddo
      end select
CCC   #################################################################
      case (3)
CCC   #################################################################
      select case (ieosmode)
      case (1)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'T 3pdT4 eddT4 sddT3 rhoB edd'
        close(70)
        rmub=0.5d0
!hadron phase
        phsflg=0       !! hadrons
        rtempmin=0.05d0
        do m1=1,mbinx
           xx(m1)= rgh(2,m1) !baryonic chemical potential
           yy(m1)= rgh(1,m1) !temperature
        end do
        call locate(xx,mbinx,rmub,m2)
        write(*,*)'m2, ittx: ',m2,ittx
        if(m2.eq.0) then
           k1=1
           k2=2
           ijustdoit=0
        else if(m2.eq.mbinx) then
           k1=mbinx-1
           k2=mbinx
           ijustdoit=1
        else
           k1=m2
           k2=m2+1
           ijustdoit=1
        end if
        if (ijustdoit.eq.1) then
           x0=xx(k1)
           x1=xx(k2)
           y0=yy(k1)
           y1=yy(k2)
           pp=(rmub-x0)/(x1-x0)
           yint=(1.d0-pp)*y0+pp*y1
           write(*,*)'the mub and interpolated temperature: ',rmub,yint
           write(*,*)'y0,y1,pp: ',y0,y1,pp
           rtempmax=yint
           do itt=1,ittmax
             rtemp=rtempmin+(rtempmax-rtempmin)*(itt-1.d0)/(ittmax-1.d0)
              call thintp(phsflg,rtemp,rmub,es)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(6d20.10)')
     &        rtemp,3.d0*es(4,0)/rtemp**4,es(1,0)/rtemp**4,
     &        es(2,0)/rtemp**3,es(3,0),es(1,0)
              close(70)
           enddo
        endif
!mixed phase
        phsflg=1       !! mixed
        rtemp=yint
        if (ijustdoit.eq.1) then
           do itt=1,ittmax
              xfactor=0.d0+(1.d0-0.d0)*(itt-1.d0)/(ittmax-1.d0)
              call thintp(0,rtemp,rmub,esr)
              call thintp(2,rtemp,rmub,esq)
              es(1,0)= esr(1,0)*(1.d0-xfactor) + esq(1,0)*(xfactor)
              es(2,0)= esr(2,0)*(1.d0-xfactor) + esq(2,0)*(xfactor)
              es(3,0)= esr(3,0)*(1.d0-xfactor) + esq(3,0)*(xfactor)
              es(4,0)= esq(4,0)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(6d20.10)')
     &        rtemp,3.d0*es(4,0)/rtemp**4,es(1,0)/rtemp**4,
     &        es(2,0)/rtemp**3,es(3,0),es(1,0)
              close(70)
           enddo
        endif
!QGP phase
        phsflg=2       !! plasma
        rtempmin=yint
        rtempmax=0.6d0
        ijustdoit=1 !alway enters QGP phase via T=const
        if (ijustdoit.eq.1) then
           do itt=1,ittmax
             rtemp=rtempmin+(rtempmax-rtempmin)*(itt-1.d0)/(ittmax-1.d0)
              call thintp(phsflg,rtemp,rmub,es)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(6d20.10)')
     &        rtemp,3.d0*es(4,0)/rtemp**4,es(1,0)/rtemp**4,
     &        es(2,0)/rtemp**3,es(3,0),es(1,0)
              close(70)
           enddo
        endif
CCC   #################################################################
      case (2)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'T 3pdT4 eddT4 sddT3 rhoB edd'
        close(70)
        rmub=0.5d0
        phsflg=0       !! hadrons
        rtempmin=0.05d0
        do m1=1,ittx
           xx(m1)= bdymbdsthrg(m1)	!baryonic chemical potential
           yy(m1)= bdytt(m1)		!temperature
        end do
        call locate(xx,ittx,rmub,m2)
        write(*,*)'m2, ittx: ',m2,ittx
        if(m2.eq.0) then
           k1=1
           k2=2
           ijustdoit=0
        else if(m2.eq.ittx) then
           k1=ittx-1
           k2=ittx
           ijustdoit=1
        else
           k1=m2
           k2=m2+1
           ijustdoit=1
        end if
        if (ijustdoit.eq.1) then
           x0=xx(k1)
           x1=xx(k2)
           y0=yy(k1)
           y1=yy(k2)
           pp=(rmub-x0)/(x1-x0)
           yint=(1.d0-pp)*y0+pp*y1
           write(*,*)'the mub and interpolated temperature: ',rmub,yint
           write(*,*)'y0,y1,pp: ',y0,y1,pp
           rtempmax=yint
           write(*,*)'HG phase rtempmin,rtempmax=',rtempmin,rtempmax
           do itt=1,ittmax
             rtemp=rtempmin+(rtempmax-rtempmin)*(itt-1.d0)/(ittmax-1.d0)
             call geteosesx_tmub(eos,rtemp,rmub,phsflg)
             open(70,file=fneoe(1:nfneoe),access='append')
             write(70,'(6d20.10)')
     &        rtemp,3.d0*eos(4)/rtemp**4,eos(1)/rtemp**4,
     &        eos(2)/rtemp**3,eos(3),eos(1)
           enddo
        endif
!mixed phase
        phsflg=1       !! mixed
        rtempmin=rtempmax
        do m1=1,ittx
           xx(m1)= bdymbdstqgp(m1)	!baryonic chemical potential
           yy(m1)= bdytt(m1)		!temperature
        end do
        call locate(xx,ittx,rmub,m2)
        write(*,*)'m2, ittx: ',m2,ittx
        if(m2.eq.0) then
           k1=1
           k2=2
           ijustdoit=0
        else if(m2.eq.ittx) then
           k1=ittx-1
           k2=ittx
           ijustdoit=1
        else
           k1=m2
           k2=m2+1
           ijustdoit=1
        end if
        if (ijustdoit.eq.1) then
           x0=xx(k1)
           x1=xx(k2)
           y0=yy(k1)
           y1=yy(k2)
           pp=(rmub-x0)/(x1-x0)
           yint=(1.d0-pp)*y0+pp*y1
           write(*,*)'the mub and interpolated temperature: ',rmub,yint
           write(*,*)'y0,y1,pp: ',y0,y1,pp
           rtempmax=yint
           write(*,*)'mixed phase rtempmin,rtempmax=',rtempmin,rtempmax
           do itt=1,ittmax
             rtemp=rtempmin+(rtempmax-rtempmin)*(itt-1.d0)/(ittmax-1.d0)
             call geteosesx_tmub(eos,rtemp,rmub,phsflg)
             open(70,file=fneoe(1:nfneoe),access='append')
             write(70,'(6d20.10)')
     &        rtemp,3.d0*eos(4)/rtemp**4,eos(1)/rtemp**4,
     &        eos(2)/rtemp**3,eos(3),eos(1)
           enddo
        endif
!QGP phase
        phsflg=2       !! plasma
        rtempmin=yint
        rtempmax=0.6d0
        write(*,*)'QGP phase rtempmin,rtempmax=',rtempmin,rtempmax
        ijustdoit=1 !alway enters QGP phase via T=const
        if (ijustdoit.eq.1) then
           do itt=1,ittmax
             rtemp=rtempmin+(rtempmax-rtempmin)*(itt-1.d0)/(ittmax-1.d0)
             call geteosesx_tmub(eos,rtemp,rmub,phsflg)
             open(70,file=fneoe(1:nfneoe),access='append')
             write(70,'(6d20.10)')
     &        rtemp,3.d0*eos(4)/rtemp**4,eos(1)/rtemp**4,
     &        eos(2)/rtemp**3,eos(3),eos(1)
           enddo
        endif
CCC   #################################################################
      case (7)
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'T 3pdT4 eddT4 sddT3 rhoB edd'
        close(70)
        rmub=0.5d0
        rtempmin=0.05d0
        rtempmax=0.6d0
        do itt=1,ittmax
             rtemp=rtempmin+(rtempmax-rtempmin)*(itt-1.d0)/(ittmax-1.d0)
              call thintp_crossover(rtemp,rmub,es)
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,'(6d20.10)')
     &        rtemp,3.d0*es(4,0)/rtemp**4,es(1,0)/rtemp**4,
     &        es(2,0)/rtemp**3,es(3,0),es(1,0)
              close(70)
        enddo
CCC   #################################################################
      case default
        write(*,*)'ieosmode: ',ieosmode
        open(70,file=fneoe(1:nfneoe),status='replace')
        write(70,'(a)') 'T 3pdT4 eddT4 sddT3 edd'
        close(70)
        eos(3)=0.15d0
        eedmin=0.003d0
        eedmax=4.d0
        do itt=1,ittmax
          eos(1)=eedmin+(eedmax-eedmin)*(itt-1.d0)/(ittmax-1.d0)
          call eosph(eos,1)
          open(70,FILE=fneoe(1:nfneoe),access='append')
          write(70,'(5d20.10)')eos(5),3.d0*eos(4)/eos(5)**4,
     &        eos(1)/eos(5)**4,eos(2)/eos(5)/eos(5)**3,eos(1)
          close(70)
        enddo
        do itt=1,ittmax
          eos(3)=0.d0
          eos(1)=eed+(eedmax-eed)*(itt-1.d0)/(ittmax-1.d0)
          call eosph(eos,1)
          open(70,FILE=fneoe(1:nfneoe),access='append')
          write(70,'(5d20.10)')eos(5),3.d0*eos(4)/eos(5)**4,
     &        eos(1)/eos(5)**4,eos(2)/eos(5)/eos(5)**3,eos(1)
          close(70)
        enddo
CCC   #################################################################
      end select
CCC   #################################################################
      end select
      write(*,*)'eos output done, program halt!'
      stop
      return
      end


CCC   #################################################################
CCC   eosph.f control of everything for EoS in  SPheRIO \(^^) 
CCC   gf: 1-> energy density, 2-> entropy density
CCC   phsflg: 0-> RG, 1-> Mixed, 2-> QGP phase 
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 05072006
CCC   esq, esr, es is expend from (1:4,0:2) --> (1:5,0:2) to adopt
CCC   the modification in thintp()
CCC   however, the output esqr(5,0) has not been used anywhere
CCC   since the code obtain this value using tmintp() and mixdphs()
CCC   
CCC   last updated 05052006
CCC   include 'spherio.mixdphs.inc' to incorporate strangessness from
CCC   the output of mixdphs()
CCC   for the time being mixdphs() is not implemented
CCC   us is defined to incorporate the strangeness
CCC
CCC   last updated 05042006
CCC   include 'spherio.const.inc'  
CCC   include 'spherio.eos.inc' to include strangeness
CCC   however at present stage strangeness is not fully implemented
CCC   #################################################################
      SUBROUTINE eosph_original(eos,gf) 

      IMPLICIT NONE 
      
      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      include 'spherio.mixdphs.inc'
      include 'spherio.debug.inc'

      INTEGER phsflg
c      DOUBLE PRECISION BAGCNST,Pex,R0
      INTEGER gf
      DOUBLE PRECISION given(3)
      DOUBLE PRECISION Tm,ub,us
      DOUBLE PRECISION esq(1:5,0:2),esr(1:5,0:2),es(1:5,0:2)
      DOUBLE PRECISION edgvn,sdgvn,ndgvn

c      COMMON/BAGCNST/BAGCNST
c      COMMON/HARDCORE/R0
c      COMMON/PEX/Pex

c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$ EMISSAO CONTINUA $$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
      double precision lambda
      common/cemixphs/lambda
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

      if(gf.eq.1) then 
         edgvn= eos(1) 
         eos(2)=zero 
      else if(gf.eq.2) then 
         sdgvn= eos(2)
         eos(1)= zero 
      end if
      ndgvn= eos(3)
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
CCC   incorporate strangeness here
      eos(7)=zero
CCC   incorporate strangeness here
      given(gf)=eos(gf) 
      given(3)= eos(3)
ccc   #########################################################
ccc   call pdtable()         !!         move to spherio 201.f. 
c     BAGCNST= 0.380d+00     !!         move to spherio 201.f.
c     R0= 0.700d+00          !!         hard core radius [fm]
ccc   #########################################################
CCC   #########################################################
c     determine of phase for given energy and baryon density 
      if(gf.eq.1) then
         call phsjdg1(given(gf),given(3),phsflg)
         if(phsflg.lt.0) return
      endif
      if(gf.eq.2) call phsjdg2(given(gf),given(3),phsflg)
ccc   ##########################################################
      if(phsflg.eq.1) then 
         call mixdphs(gf,given,Tmix,Ubmix,Xmix,phsflg)
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$ EMISSAO CONTINUA $$$$$$$$$$$$$$$$$$$$$$$$$$$$
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
         lambda=Xmix
c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
         Tm=Tmix
         ub=Ubmix(1)
CCC   to incorporate the strangeness
         us=Ubmix(2)
CCC   to incorporate the strangeness
         if(phsflg.ne.1) then   !! for change phsflg in mixdphs
            call tmintp(gf,given,Tm,ub,us,phsflg)
         end if
      else
         call tmintp(gf,given,Tm,ub,us,phsflg)
      end if      
ccc   ###########################################################
      if(Tm.gt.zero.and.phsflg.ne.1) then 
         call thintp(phsflg,Tm,ub,es)
         if(gf.eq.1) then
c           eos(1)= edgvn 
            eos(2)= es(2,0) 
c           eos(3)= ndgvn 
            eos(4)= es(4,0)
         else if(gf.eq.2) then 
            eos(1)= es(1,0) 
c           eos(2)= sdgvn 
c           eos(3)= ndgvn 
            eos(4)= es(4,0)
         end if
      else if(Tm.gt.zero.and.phsflg.eq.1) then 
         call thintp(0,Tm,ub,esr)
         call thintp(2,Tm,ub,esq)
         if(gf.eq.1) then 
c     eos(1)= edgvn
            eos(2)= esr(2,0)*(uni-Xmix) + esq(2,0)*(Xmix)
c     eos(3)= ndgvn 
            eos(4)= esq(4,0)    !! should be same esr(4,0) [OK,checked]
         else if(gf.eq.2) then 
            eos(1)= esr(1,0)*(uni-Xmix) + esq(1,0)*(Xmix)
c     eos(2)= sdgvn 
c     eos(3)= ndgvn 
            eos(4)= esq(4,0)    !! should be same esr(4,0) [OK,checked] 
         end if
      end if
            eos(5)= Tm 
            eos(6)= ub 
CCC   incorporate strangeness here
            eos(7)= us
CCC   incorporate strangeness here

ccc   ############################################################
      RETURN 
      STOP 234
      END




CCC   #################################################################
CCC   eosphdbg2.f control of everything for EoS in  SPheRIO \(^^) 
CCC   gf: 1-> energy density, 2-> entropy density
CCC   phsflg: 0-> RG, 1-> Mixed, 2-> QGP phase 
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 08142006
CCC   inherited and modified from eosphdbg()
CCC   getesx() is replaced with a general version subroutine geteosesx()
CCC   a new subroutine geteosmix() is built to deal with mixed phase
CCC
CCC   last updated 06092006
CCC   gf check added, include 'spherio.esx.inc' and evoke 
CCC   getesx(2,given,phsflg,esxrg) to extract the info of eos
CCC
CCC   last updated 06072006
CCC   it is inherited from eosph()
CCC
CCC   last updated 05072006
CCC   esq, esr, es is expend from (1:4,0:2) --> (1:5,0:2) to adopt
CCC   the modification in thintp()
CCC   however, the output esqr(5,0) has not been used anywhere
CCC   since the code obtain this value using tmintp() and mixdphs()
CCC   
CCC   last updated 05052006
CCC   include 'spherio.mixdphs.inc' to incorporate strangessness from
CCC   the output of mixdphs()
CCC   for the time being mixdphs() is not implemented
CCC   us is defined to incorporate the strangeness
CCC
CCC   last updated 05042006
CCC   include 'spherio.const.inc'  
CCC   include 'spherio.eos.inc' to include strangeness
CCC   however at present stage strangeness is not fully implemented
CCC   #################################################################
      SUBROUTINE eosph_strangeness(eos,gf) 

      IMPLICIT NONE 
      
      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      include 'spherio.eosdbg.inc'
      include 'spherio.debug.inc'
      include 'epos.incsf'

      INTEGER phsflg,gf
      DOUBLE PRECISION eositp(1:7),eosold(1:7)

      icalledtime=icalledtime+1.d0

      eositp(gf)=eos(gf)	                !!given density
      eositp(3)=eos(3)	                                !!baryon density

      eos(3-gf)=zero
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
      eos(7)=zero


      if(gf.eq.1) then	                                !!energy input
      call phsjdg1dbg(eositp(gf),eositp(3),phsflg)
      select case (phsflg)
        case (1)                                            !!mixed phase
          call geteosmix(eositp,gf,phsflg)
        case (0,2)                                         !!hadron phase or qgp
          call geteosesx(eositp,gf,phsflg)
        case (-1)
          if (iauxi.ge.10) then
           OPEN(70,FILE=fneoe(1:nfneoe),access='append')
           write(70,*)' '
           write(70,*)'out of phase boundary spotted!'
           write(70,*)'in energy input'
           write(70,*)'eos(gf,3)=',eos(gf),eos(3)
          close(70)
          endif
          return
        case default
          write(*,*)'phsflg error from eosphdbg2, phsflg=',phsflg
          stop 'phsflg error from eosphdbg2'
      end select

      else if(gf.eq.2) then                            !!entropy input
      call phsjdg2dbg(eositp(gf),eositp(3),phsflg)
      select case (phsflg)
        case (1)                                            !!mixed phase
          call geteosmix(eositp,gf,phsflg)
        case (0,2)                                         !!hadron phase or qgp
          call geteosesx(eositp,gf,phsflg)
        case (-1)
          if (iauxi.ge.10) then
           OPEN(70,FILE=fneoe(1:nfneoe),access='append')
           write(70,*)' '
           write(70,*)'out of phase boundary spotted!'
           write(70,*)'in entropy input'
           write(70,*)'eos(gf,3)=',eos(gf),eos(3)
           close(70)
          endif
          return
        case default
          write(*,*)'phsflg error from eosphdbg2, phsflg=',phsflg
          stop 'phsflg error from eosphdbg2'
        end select

      else
      write(*,*)'gf error from eosphdbg2, gf=',gf
      stop 'gf error from eosphdbg2'
      end if

CCC   ###########################################################
CCC	output
      if (eositp(5).le.zero) then
          if (iauxi.ge.20) then
           OPEN(70,FILE=fneoe(1:nfneoe),access='append')
           write(70,*)' '
           write(70,*)'negative temperature spotted!'
           write(70,*)'gf,phsflg=',gf,phsflg
           write(70,*)'eos(1-4)=',eositp(1),eositp(2),eositp(3)
     &       ,eositp(4)
           write(70,*)'eos(5-7)=',eositp(5),eositp(6),eositp(7)
           close(70)
          endif
          return
        endif

      if ((eositp(5).le.zero).or.(eositp(5).ge.zero)) then
        continue
      else
        open(11,file=fnnan(1:nfnnan),access='append')
        write(11,'(a)')'NaN detected in eosphdbg2'
        write(11,*)'gf,phsflg=',gf,phsflg
        write(11,*)'eos(1-4)=',eositp(1),eositp(2),eositp(3)
     &     ,eositp(4)
        write(11,*)'eos(5-7)=',eositp(5),eositp(6),eositp(7)
        close(11)
!		stop 'NaN detected in eosphdbg2'
      endif

      eos(3-gf)= eositp(3-gf)		! --> the other density
      eos(4)   = eositp(4)		! --> pressure
      eos(5)   = eositp(5)		! --> temperature
      eos(6)   = eositp(6)		! --> baryon chemical potential
      eos(7)   = eositp(7)		! --> strangeness chemical potential

CCC   #################################################################
CCC   comparing the two eos datas
      if (iauxi.ge.20) then
        eosold(gf)=eos(gf)
        eosold(3)=eos(3)
        call eosph_original(eosold,gf)
        if((dabs(eosold(1)-eos(1)).gt.dabs(eosold(1)*0.1d0)).or.
     &    (dabs(eosold(2)-eos(2)).gt.dabs(eosold(2)*0.1d0)).or.
     &    (dabs(eosold(3)-eos(3)).gt.dabs(eosold(3)*0.1d0)).or.
     &    (dabs(eosold(4)-eos(4)).gt.dabs(eosold(4)*0.1d0)).or.
     &    (dabs(eosold(5)-eos(5)).gt.dabs(eosold(5)*0.1d0))) then
        ifailtime=ifailtime+1.d0
        if((dabs(eosold(1)/eos(1)).gt.8.00d-1).or.
     &   (dabs(eosold(1)/eos(1)).lt.1.25d-1).or.
     &   (dabs(eosold(2)/eos(2)).gt.8.00d-1).or.
     &   (dabs(eosold(2)/eos(2)).lt.1.25d-1).or.
     &   (dabs(eosold(3)/eos(3)).gt.8.00d-1).or.
     &   (dabs(eosold(3)/eos(4)).lt.1.25d-1).or.
     &   (dabs(eosold(4)/eos(4)).gt.9.00d-1).or.
     &   (dabs(eosold(4)/eos(4)).lt.1.25d-1).or.
     &   (dabs(eosold(5)/eos(5)).gt.8.00d-1).or.
     &   (dabs(eosold(5)/eos(5)).le.1.25d-1)) then
        OPEN(70,FILE=fneoe(1:nfneoe),access='append')
        write(70,*)' '
        write(70,'(a,f16.8,a,f16.8,a)')'ifailtime/icalledtime=',
     &  ifailtime,'/',icalledtime,'difference > 10%'
        write(70,*)'the following one has a difference > 80%'
        write(70,*)' '
        write(70,*)'from eosphold'
        write(70,*)'gf=',gf
        write(70,'(a,7d30.20)')'eosold(1-7)=',eosold(1),eosold(2),
     &  eosold(3),eosold(4),eosold(5),
     &  eosold(6),eosold(7)
        write(70,*)' '
        write(70,*)'and from eosphdbg2 is very different'
        write(70,*)'gf,phsflg=',gf,phsflg
        write(70,'(a,7d30.20)')'eos(1-7)=',eos(1),eos(2),eos(3),
     &  eos(4),eos(5),eos(6),eos(7)
        close(70)
        endif
        endif
      endif
CCC   #################################################################

CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosphdbg.f extract info from eos datas
CCC   it only extract info from sd,bd --> eos array in hadronic phase
CCC   #################################################################
CCC   gf: 1-> energy density, 2-> entropy density
CCC   phsflg: 0-> RG, 1-> Mixed, 2-> QGP phase 
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 06092006
CCC   gf check added, include 'spherio.esx.inc' and evoke 
CCC   getesx(2,given,phsflg,esxrg) to extract the info of eos
CCC
CCC   last updated 06072006
CCC   it is inherited from eosph()
CCC
CCC   last updated 05072006
CCC   esq, esr, es is expend from (1:4,0:2) --> (1:5,0:2) to adopt
CCC   the modification in thintp()
CCC   however, the output esqr(5,0) has not been used anywhere
CCC   since the code obtain this value using tmintp() and mixdphs()
CCC   
CCC   last updated 05052006
CCC   include 'spherio.mixdphs.inc' to incorporate strangessness from
CCC   the output of mixdphs()
CCC   for the time being mixdphs() is not implemented
CCC   us is defined to incorporate the strangeness
CCC
CCC   last updated 05042006
CCC   include 'spherio.const.inc'  
CCC   include 'spherio.eos.inc' to include strangeness
CCC   however at present stage strangeness is not fully implemented
CCC   #################################################################
      SUBROUTINE eosphdbg(eos,gf) 

      IMPLICIT NONE 
      
      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      include 'spherio.esx.inc'
      include 'spherio.debug.inc'

      INTEGER phsflg,gf
      DOUBLE PRECISION given(3)
      DOUBLE PRECISION sdgvn,ndgvn
c      double precision edgvn

      if(gf.ne.2) then 
CCC   ##############################################################
CCC   debugg setting for gf check
         write(*,*)'unexpected gf error in eosphdbg... gf<>2'
         stop
CCC   ##############################################################
      else if(gf.eq.2) then 
         sdgvn= eos(2)
         eos(1)= zero 
      end if
      ndgvn= eos(3)
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
      eos(7)=zero
CCC   ##############################################################
      given(gf)=eos(gf) 
      given(3)= eos(3)             
CCC   #########################################################
      phsflg=0
      call getesx(2,given,phsflg,esx)	! --> entropy input, hadronic phase
CCC   ###########################################################
      eos(1)= esx(1)    ! --> energy density
c     eos(2)= sdgvn       ! --> entropy density
c     eos(3)= ndgvn       ! --> baryon density
      eos(4)= esx(4)    ! --> pressure
      eos(5)= esx(5)    ! --> temperature
      eos(6)= esx(6)    ! --> baryon chemical potential
      eos(7)= esx(7)    ! --> strangeness chemical potential
CCC   ###########################################################
      RETURN 
      STOP 234
      END




CCC   #################################################################
CCC   eosph_cs2.f output cs**2
CCC   for massless pion gg=3
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 06152009
CCC   dummy structure (of massless pions) is built
CCC   #################################################################
      SUBROUTINE eosph_cs2(eos,gf,cs2)
      IMPLICIT NONE 
      include 'spherio.eos.inc'
      include 'spherio.const.inc'
      include 'spherio.debug.inc'
      INTEGER gf
      double precision cs2,temp

      temp=eos(1)
      cs2=1.d0/3.d0

CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosph_crossover
CCC   for EOS with cross-over phase transition
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 06152009
CCC   dummy structure (of massless pions) is built
CCC   #################################################################
      SUBROUTINE eosph_crossover(eos,gf)
      IMPLICIT NONE 
      include 'spherio.eos.inc'
      include 'spherio.const.inc'
      include 'spherio.debug.inc'
      INTEGER phsflg
      INTEGER gf
      INTEGER ii
      DOUBLE PRECISION given(3)
      DOUBLE PRECISION Tm,ub
      DOUBLE PRECISION es(1:4,0:2) !<- one dimension less than strangeness case
      DOUBLE PRECISION esqr(1:5,0:2)
      DOUBLE PRECISION edgvn,sdgvn,ndgvn

      if(gf.eq.1) then 
         edgvn= eos(1) 
         eos(2)=zero
      else if(gf.eq.2) then 
         sdgvn= eos(2)
         eos(1)= zero 
      end if
      ndgvn= eos(3)
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
CCC   incorporate strangeness here
      eos(7)=zero
CCC   incorporate strangeness here
      given(gf)=eos(gf) 
      given(3)= eos(3)             
      if(gf.eq.1) then
         call phsjdg1(given(gf),given(3),phsflg)
         if(phsflg.lt.0) return
      endif
      if(gf.eq.2) then
         call phsjdg2(given(gf),given(3),phsflg)
         if(phsflg.lt.0) return
      endif
ccc   ##########################################################
      call tmintp_crossover(gf,given,Tm,ub)
ccc   ###########################################################
      if(Tm.ge.0.015) then
         if(Tm.le.0.25) then
           call thintp_crossover(Tm,ub,es)
         elseif(Tm.ge.0.25)then
           phsflg=2   !QGP phase only
           call thintp(phsflg,Tm,ub,esqr)
           do ii=1,4
            es(ii,0)=esqr(ii,0)
           enddo
         endif
         if(gf.eq.1) then
c           eos(1)= edgvn 
            eos(2)= es(2,0) 
c           eos(3)= ndgvn 
            eos(4)= es(4,0)
            eos(5)= Tm 
            eos(6)= ub 
         else if(gf.eq.2) then 
            eos(1)= es(1,0) 
c           eos(2)= sdgvn 
c           eos(3)= ndgvn 
            eos(4)= es(4,0)
            eos(5)= Tm 
            eos(6)= ub
         end if
      end if
CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosph.f control of everything for EoS in  SPheRIO \(^^) 
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 04182010
CCC   #################################################################
      SUBROUTINE eosph_str_latt_ins(eos,gf)

      IMPLICIT NONE 
      
      include 'spherio.const.inc'
      include 'spherio.eos.inc'

      INTEGER gf

      write(*,*)'not implemented yet!'
      stop 'not implemented yet!'

CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosph_overried.f control of everything for EoS in  SPheRIO \(^^) 
CCC   The present form is an example of massless pion gg=3
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 04182010
CCC   #################################################################
      SUBROUTINE eosph_override(eos,gf)

      IMPLICIT NONE 
      
      include 'spherio.const.inc'
      include 'spherio.eos.inc'

      INTEGER gf
      double precision gg,tt

      gg=3.d0

      eos(3-gf)=zero
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
      eos(7)=zero


      if(gf.eq.1) then											!!energy input

      tt=(eos(1)/gg/pi**2*30.0d0*(hbarc*hbarc*hbarc))**(1.d0/4.d0)
      eos(3-gf)=gg*2.0d0/45.d0*pi**2*tt**3/(hbarc*hbarc*hbarc)	!!entropy density
      eos(4)=gg/90.d0*pi**2*tt**4/(hbarc*hbarc*hbarc)				!!pressure
      eos(5)=tt													!!temperature

      else if(gf.eq.2) then										!!entropy input

      tt=(eos(2)/gg/pi**2*45.0d0/2.d0*(hbarc*hbarc*hbarc))**(1.d0/3.d0)
      eos(3-gf)=gg/30.d0*pi**2*tt**4/(hbarc*hbarc*hbarc)			!!energy density
      eos(4)=gg/90.d0*pi**2*tt**4/(hbarc*hbarc*hbarc)				!!pressure
      eos(5)=tt													!!temperature



      else
      write(*,*)'gf error from eosph_pion, gf=',gf
      stop 'gf error from eosph_pion'
      end if
CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosph_pion.f control of everything for EoS in  SPheRIO \(^^) 
CCC   for lattice EOS tables by Pasi
CCC   https://wiki.bnl.gov/TECHQM/index.php/QCD_Equation_of_State
CCC   #################################################################
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 03032011
CCC   #################################################################
      subroutine eosph_latt_pasi(eos,gf)
      IMPLICIT NONE 
      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      INTEGER gf
      double precision Edens,Sdens,Temp,Press,Vs2
      eos(3-gf)=zero
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
      eos(7)=zero

      if(gf.eq.1) then											!!energy input
      Edens=eos(1)
      call E_to_S_Pasi(Edens,Sdens,Temp,Press,Vs2)
      eos(2)=Sdens
      eos(4)=Press
      eos(5)=Temp

      else if(gf.eq.2) then										!!entropy input
      Sdens=eos(2)
      call S_to_E_Pasi(Sdens,Temp,Edens,Press,Vs2)
      eos(1)=Edens
      eos(4)=Press
      eos(5)=Temp

      else
      write(*,*)'gf error from eosph_latt_pasi, gf=',gf
      stop 'gf error from eosph_latt_pasi'
      end if      

      return
      end

      Subroutine S_to_E_Pasi(Sdens,Temp,Edens,Press,Vs2)
      implicit real*8 (a-h,o-z)
      include 'epos.incsf'
      include 'spherio.fnames.inc'
      parameter (Ntab=33001)
      CHARACTER filename*108
      dimension T(Ntab), C(Ntab), E(Ntab), P(Ntab), Sln(Ntab)
      data Coef/0.363409593351677d0/, hc/0.1973d0/,ifirst/0/
      save ifirst, T, C, E, P, Sln
      filename= fneos(1:nfneos)//eosdatapath3//pasif2
      if(ifirst.eq.0) then
      open(11,file=filename,status='old')

      do i=1,Ntab
      read(11,*) T(i), C(i), E(i), P(i), Sln(i)
      end do
      close(11)
      ifirst=1
      end if

      smin=exp(Sln(Ntab))
      smax=exp(Sln(1))

      if(Sdens.lt.smin) then
c      write(*,*) 'Entropy less than the limit of the table of EoS'
      Temp=0.
      Edens=0.
      Press=0.
      Vs2=1./5.
      return
      end if

      if(Sdens.gt.smax) then
c      write(*,*) 'Entropy larger than the limit of the table of EoS'
      Temp=Coef*Sdens**0.3333333333333d0*hc
      Edens=0.74d0*Sdens*Temp
      Press=0.25*Sdens*Temp
      Vs2=1.d0/3.d0
      return
      end if
      
      delS=(Sln(1)-Sln(Ntab))/(Ntab-1)
      
      Sln_in=log(Sdens)
      
      i=(Sln(1)-Sln_in)/delS+1

      if(i.eq.Ntab) i=Ntab-1

      x1=Sln(i)
      x2=Sln(i+1)
      
      x=Sln_in
      y1=E(i)
      y2=E(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Edens=y

      y1=T(i)
      y2=T(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Temp=y

      y1=C(i)
      y2=C(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Vs2=y
      
      y1=P(i)
      y2=P(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Press=y

      return
      end
      
      

      Subroutine E_to_S_Pasi(Edens,Sdens,Temp,Press,Vs2)
      implicit real*8 (a-h,o-z)
      include 'spherio.fnames.inc'
      include 'epos.incsf'
      parameter (Ntab=33001)
      CHARACTER filename*108
      dimension T(Ntab), C(Ntab), Eln(Ntab), P(Ntab), S(Ntab)
      data Coef/0.502958294812902d0/, hc/0.1973d0/, ifirst/0/
      save ifirst, T, C, Eln, P, S
      filename= fneos(1:nfneos)//eosdatapath3//pasif1

      if(ifirst.eq.0) then
      open(11,file=filename,status='old')
      do i=1,Ntab
      read(11,*) T(i), C(i), Eln(i), P(i), S(i)
      end do
      close(11)
      ifirst=1
      end if

      emin=exp(Eln(Ntab))
      emax=exp(Eln(1))

      if(Edens.lt.emin) then
c      write(*,*) 'Energy less than the limit of the table of EoS'
      Temp=0.
      Sdens=0.
      Press=0.
      Vs2=1./5.
      return
      end if

      if(Edens.gt.emax) then
c      write(*,*) 'Energy larger than the limit of the table of EoS'
      Temp=hc*Coef*(Edens/hc)**0.25d0
      Press=0.333333333333d0*Edens
      Sdens=4.d0*Press/Temp
      Vs2=1.d0/3.d0
      return
      end if
      
      delE=(Eln(1)-Eln(Ntab))/(Ntab-1)
      
      Eln_in=log(Edens)
      
      i=(Eln(1)-Eln_in)/delE+1

      
      if(i.eq.Ntab) i=Ntab-1

      x1=Eln(i)
      x2=Eln(i+1)
      
      x=Eln_in
      y1=S(i)
      y2=S(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Sdens=y

      y1=T(i)
      y2=T(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Temp=y

      y1=C(i)
      y2=C(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Vs2=y
      
      y1=P(i)
      y2=P(i+1)
      y=(y2-y1)*(x-x1)/(x2-x1)+y1
      Press=y

      return
      end


CCC   #################################################################
CCC   eosph_pion.f control of everything for EoS in  SPheRIO \(^^) 
CCC   for massless pion gg=3
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 09122006
CCC   #################################################################
      SUBROUTINE eosph_pion(eos,gf)

      IMPLICIT NONE 
      
      include 'spherio.const.inc'
      include 'spherio.eos.inc'

      INTEGER gf
      double precision gg,tt

      gg=3.d0

      eos(3-gf)=zero
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
      eos(7)=zero


      if(gf.eq.1) then											!!energy input

      tt=(eos(1)/gg/pi**2*30.0d0*(hbarc*hbarc*hbarc))**(1.d0/4.d0)
      eos(3-gf)=gg*2.0d0/45.d0*pi**2*tt**3/(hbarc*hbarc*hbarc)	!!entropy density
      eos(4)=gg/90.d0*pi**2*tt**4/(hbarc*hbarc*hbarc)				!!pressure
      eos(5)=tt													!!temperature

      else if(gf.eq.2) then										!!entropy input

      tt=(eos(2)/gg/pi**2*45.0d0/2.d0*(hbarc*hbarc*hbarc))**(1.d0/3.d0)
      eos(3-gf)=gg/30.d0*pi**2*tt**4/(hbarc*hbarc*hbarc)			!!energy density
      eos(4)=gg/90.d0*pi**2*tt**4/(hbarc*hbarc*hbarc)				!!pressure
      eos(5)=tt													!!temperature



      else
      write(*,*)'gf error from eosph_pion, gf=',gf
      stop 'gf error from eosph_pion'
      end if
CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosph_pion1()
CCC   #################################################################
CCC   last updated 01222007
CCC   written by Kodama
CCC   #################################################################
CCC   open(1,file='eosPi1.dat')
CCC   de=0.1
CCC   do i=1,200
CCC   e=de*i
CCC   call EosPi2(e,s,P,T)
CCC   write(1,*) s,e,P,T
CCC   end do
CCC   stop
CCC   end
CCC   #################################################################
      subroutine eosph_pion1(ein,s,P,T)
      implicit real*8 (a-h,o-z)
      parameter (gh=3.,gg=16.,gq=12.)
      parameter (pi=3.141592653)
      parameter (pi2=pi*pi)
      parameter (c1=gh*pi2/90., c2=7.*gq*pi2/360.+gg*pi2/90.)
      parameter (hc=0.1973)
      e=ein/hc
      T4=e/(3.*c1)
      T=T4**0.25
      s=4.*c1*T**3
      P=c1*T4*hc
      T=T*hc
      return
      end
CCC   #################################################################





CCC   #################################################################
CCC   eosph_pion2()
CCC   #################################################################
CCC   last updated 01222007
CCC   written by Kodama
CCC   #################################################################
CCC   open(1,file='eosPi2.dat')
CCC   ds=0.1
CCC   do i=1,200
CCC   s=ds*i
CCC   call EosPi1(e,s,P,T)
CCC   write(1,*) s,e,P,T
CCC   end do
CCC   stop
CCC   end
CCC   #################################################################
      subroutine eosph_pion2(e,s,P,T)
      implicit real*8 (a-h,o-z)
      parameter (gh=3.,gg=16.,gq=12.)
      parameter (pi=3.141592653)
      parameter (pi2=pi*pi)
      parameter (c1=gh*pi2/90., c2=7.*gq*pi2/360.+gg*pi2/90.)
      parameter (hc=0.1973)

      T=(s/(4.*c1))**0.3333333333
      T4=T**4
      P=c1*T4*hc
      e=3.*P
      T=T*hc
      return
      end
CCC   #################################################################






CCC   #################################################################
CCC   eosph_pion_bag1()
CCC   #################################################################
CCC   last updated 01222007
CCC   written by Kodama
CCC
CCC   last updated 01232007
CCC   fixed a bug
CCC   #################################################################
CCC   open(1,file='eos1.dat')
CCC   de=0.1
CCC   do i=1,200
CCC   e=de*i
CCC   call Eos2(e,s,P,T)
CCC   write(1,*) s,e,P,T
CCC   end do
CCC   stop
CCC   end
CCC   #################################################################
      subroutine eosph_pion_bag1(ein,s,P,T)
      implicit real*8 (a-h,o-z)
      parameter (gh=3.,gg=16.,gq=12.)
      parameter (pi=3.141592653)
      parameter (pi2=pi*pi)
      parameter (c1=gh*pi2/90., c2=7.*gq*pi2/360.+gg*pi2/90.)
      parameter (hc=0.1973)
      parameter (Tc=0.170/hc)
      
      Tc3=Tc**3
      Tc4=Tc3*Tc
      B=(c2-c1)*Tc4
      eh=3.*c1*Tc4
      eq=3.*c2*Tc4+B
      e=ein/hc

      if(e.le.eh) then
      T4=e/(3.*c1)
      T=T4**0.25
      s=4.*c1*T**3
      P=c1*T4*hc
      T=T*hc
      return
      else
      if(e.gt.eq) then
      T4=(e-B)/(3.*c2)
      T=T4**0.25
      P=(c2*T4-B)*hc
      s=4.*c2*T**3
      T=T*hc
      return
      else

      sh=4.*c1*Tc3
      sq=4.*c2*Tc3
      P=c1*Tc4*hc
      s=((sq-sh)*(e-eh)/(eq-eh)+sh)
      T=Tc*hc
      return
      end if
      end if
      end
CCC   #################################################################







CCC   #################################################################
CCC   eosph_pion_bag2()
CCC   #################################################################
CCC   last updated 01222007
CCC   written by Kodama
CCC   #################################################################
CCC   open(1,file='eos2.dat')
CCC   ds=0.1
CCC   do i=1,200
CCC   s=ds*i
CCC   call Eos1(e,s,P,T)
CCC   write(1,*) s,e,P,T
CCC   end do
CCC   stop
CCC   end
CCC   #################################################################
      subroutine eosph_pion_bag2(e,s,P,T)
      implicit real*8 (a-h,o-z)
      parameter (gh=3.,gg=16.,gq=12.)
      parameter (pi=3.141592653)
      parameter (pi2=pi*pi)
      parameter (c1=gh*pi2/90., c2=7.*gq*pi2/360.+gg*pi2/90.)
      parameter (hc=0.1973)
      parameter (Tc=0.170/hc)
      
      Tc3=Tc**3
      Tc4=Tc3*Tc
      B=(c2-c1)*Tc4

      sh=4.*c1*Tc3
      sq=4.*c2*Tc3

      if(s.le.sh) then
      T=(s/(4.*c1))**0.3333333333
      T4=T**4
      P=c1*T4*hc
      e=3.*P
      T=T*hc
      return
      else
      if(s.gt.sq) then
      T=(s/(4.*c2))**0.3333333333
      T4=T**4
      P=(c2*T4-B)*hc
      e=(3.*c2*T4+B)*hc
      T=T*hc
      return
      else
      eh=3.*c1*Tc4
      eq=3.*c2*Tc4+B
      P=c1*Tc4*hc
      e=((eq-eh)*(s-sh)/(sq-sh)+eh)*hc
      T=Tc*hc
      return
      end if
      end if
      end
CCC   #################################################################








CCC   #################################################################
CCC   eosph_pion.f control of everything for EoS in  SPheRIO \(^^) 
CCC   for massless pion gg=3
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 06122007
CCC   incorporate ieosmode
CCC
CCC   last updated 03052007
CCC   incorporate more debugging cases
CCC
CCC   last updated 09122006
CCC   #################################################################
      SUBROUTINE eosph(eos,gf)
      IMPLICIT NONE 
      include 'spherio.eos.inc'
      include 'spherio.const.inc'
      include 'spherio.debug.inc'
      INTEGER gf

      select case (ieosmode)
      case (1)				!!old eos without strangeness
           call eosph_original(eos,gf)
      case (2)
           call eosph_strangeness(eos,gf)
      case (3)				!!eos for massless pion + bag
          eos(3)=zero
          eos(4)=zero
          eos(5)=zero
          eos(6)=zero
          eos(7)=zero
           if (gf.eq.1) then
            call eosph_pion_bag1(eos(1),eos(2),eos(4),eos(5))
           else if (gf.eq.2) then
            call eosph_pion_bag2(eos(1),eos(2),eos(4),eos(5))
           else
            stop 'gf error in eosph for pionbag'
           endif
      case (4)				!!eos for massless pion
           call eosph_pion(eos,gf)
c         call eosph_pion(eos,gf)
c          eos(3)=zero
c          eos(4)=zero
c          eos(5)=zero
c          eos(6)=zero
c          eos(7)=zero
c      	if (gf.eq.1) then
c      		call eosph_pion1(eos(1),eos(2),eos(4),eos(5))
c      	else if (gf.eq.2) then
c      		call eosph_pion2(eos(1),eos(2),eos(4),eos(5))
c      	else
c      		stop 'gf error in eosph for pure masslesspion'
c          endif
      case (7)
          call eosph_crossover(eos,gf)
      case (8)
          call eosph_str_latt_ins(eos,gf)
      case (9)
          call eosph_latt_pasi(eos,gf)
      case (99)
          call eosph_override(eos,gf)
      case default            !!eos with strangeness
          write(*,*)'ieosmode=',ieosmode
          stop 'fatal ieos error in eosph'
      end select

CCC   ###########################################################
      RETURN 
      END




CCC   #################################################################
CCC   eosphtrials()
CCC   test the eosph() subroutine
CCC   gf: 1-> energy density, 2-> entropy density
CCC   eos(1)=  energy density... 
CCC   eos(2)=  entropy density... 
CCC   eos(3)=  baryon density... 
CCC   eos(4)=  pressure... 
CCC   eos(5)=  temperature... 
CCC   eos(6)=  baryon chemical potential. 
CCC   eos(7)=  strangeness chemicalpotential --> to incorporate strangeness 
CCC   #################################################################
CCC   last updated 10092007
CCC   add more test
CCC
CCC   last updated 08122006
CCC   #################################################################
      SUBROUTINE eosphtrials()
      IMPLICIT NONE
      include 'spherio.eos.inc'
      include 'spherio.debug.inc'
      include 'spherio.eosdbg.inc'
      include 'epos.incsf'
      integer iloop,phsflg
      double precision sdgvn,ndgvn
CCC   #################################################################
CCC   for eosph debugging initial setting
      icalledtime=0.d0
      ifailtime=0.d0
CCC   #################################################################
      if (iauxi.ge.5) then

      eos(2)=0.d0
      eos(3)=0.d0
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a,4d30.20)') 'input eos(2-3)=',eos(2),eos(3)
      CLOSE(70)
      call eosph(eos,2)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') 'eosph(eos,2) called, output are'
      WRITE(70,'(a,4d30.20)') 'eos(1-4)=',eos(1),eos(2),eos(3),eos(4)
      WRITE(70,'(a,3d30.20)') 'eos(5-7)=',eos(5),eos(6),eos(7)
      CLOSE(70)

      eos(2)=1.d-1
      eos(3)=0.d0
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a,4d30.20)') 'input eos(2-3)=',eos(2),eos(3)
      CLOSE(70)
      call eosph(eos,2)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') 'eosph(eos,2) called, output are'
      WRITE(70,'(a,4d30.20)') 'eos(1-4)=',eos(1),eos(2),eos(3),eos(4)
      WRITE(70,'(a,3d30.20)') 'eos(5-7)=',eos(5),eos(6),eos(7)
      CLOSE(70)

      eos(2)=0.d0
      eos(3)=1.d-1
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a,4d30.20)') 'input eos(2-3)=',eos(2),eos(3)
      CLOSE(70)
      call eosph(eos,2)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') 'eosph(eos,2) called, output are'
      WRITE(70,'(a,4d30.20)') 'eos(1-4)=',eos(1),eos(2),eos(3),eos(4)
      WRITE(70,'(a,3d30.20)') 'eos(5-7)=',eos(5),eos(6),eos(7)
      CLOSE(70)

      eos(2)=1.d-5
      eos(3)=1.d-5
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a,4d30.20)') 'input eos(2-3)=',eos(2),eos(3)
      CLOSE(70)
     	call eosph(eos,2)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') 'eosph(eos,2) called, output are'
      WRITE(70,'(a,4d30.20)') 'eos(1-4)=',eos(1),eos(2),eos(3),eos(4)
      WRITE(70,'(a,3d30.20)') 'eos(5-7)=',eos(5),eos(6),eos(7)
      WRITE(70,'(a)') ' '
      CLOSE(70)

      do iloop=1,50
      eos(2)=1.d0*10.d0**(-iloop)
      eos(3)=0.d0
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a,4d30.20)') 'input eos(2-3)=',eos(2),eos(3)
      CLOSE(70)
      sdgvn=eos(2)
      ndgvn=eos(3)
      call phsjdg2(sdgvn,ndgvn,phsflg)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') 'phsjdg2 called, here is the output'
      WRITE(70,'(a,2d30.20,i3)')'sdgvn,ndgvn,phsflg=',sdgvn,ndgvn,phsflg
      CLOSE(70)
      call eosph(eos,2)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') 'eosph(eos,2) called, here is the output'
      WRITE(70,'(a,4d30.20)') 'eos(1-4)=',eos(1),eos(2),eos(3),eos(4)
      WRITE(70,'(a,3d30.20)') 'eos(5-7)=',eos(5),eos(6),eos(7)
      CLOSE(70)
      enddo

      endif

      return
      stop
      end


CCC   #################################################################
CCC   for reading data table of the e(s)nb->Tm/mu and et.al in SPheRIO \(^^) 
CCC   in the code incorporating strangeness
CCC   #################################################################
CCC   last updated 06122006
CCC   #################################################################
      SUBROUTINE esxread() 
      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.esxdata.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'

      INTEGER m1,m2
      CHARACTER filename1*108, filename2*108
      CHARACTER filename3*108, filename4*108
c     ------------------------------------------------------

      filename1= fneos(1:nfneos)//eosdatapath2//esxf1
      filename2= fneos(1:nfneos)//eosdatapath2//esxf2
      filename3= fneos(1:nfneos)//eosdatapath2//esxf3
      filename4= fneos(1:nfneos)//eosdatapath2//esxf4

CCC   #################################################################
CCC   DATA READING
CCC   #################################################################
      OPEN(10,file=filename1,status='unknown')
      READ(10,'(2i8)') mbin1eq,mbin2eq
      do m1=1,mbin1eq            !! for baryon number density 
         do m2=1,mbin2eq         !! for energy density 
            READ(10,'(7d16.8)') 
     &           edeq(m1,m2),sdeq(m1,m2),rhobeq(m1),ppeq(m1,m2),
     &           tteq(m1,m2),mubeq(m1,m2),museq(m1,m2)
         end do
      end do
      CLOSE(10)

CCC   #################################################################
      OPEN(10,file=filename2,status='unknown')
      READ(10,'(2i8)') mbin1er,mbin2er
      do m1=1,mbin1er
         do m2=1,mbin2er
            READ(10,'(7d16.8)') 
     &           eder(m1,m2),sder(m1,m2),rhober(m1),pper(m1,m2),
     &           tter(m1,m2),muber(m1,m2),muser(m1,m2)
         end do
      end do
      CLOSE(10)
CCC   #################################################################
      OPEN(10,file=filename3,status='unknown') 
      READ(10,'(2i8)') mbin1sq,mbin2sq
      do m1=1,mbin1sq            
         do m2=1,mbin2sq         
            READ(10,'(7d16.8)') 
     &           edsq(m1,m2),sdsq(m1,m2),rhobsq(m1),ppsq(m1,m2),
     &           ttsq(m1,m2),mubsq(m1,m2),mussq(m1,m2)
         end do
      end do
      CLOSE(10)
CCC   #################################################################
      OPEN(10,file=filename4,status='unknown') 
      READ(10,'(2i8)') mbin1sr,mbin2sr
      do m1=1,mbin1sr            
         do m2=1,mbin2sr         
            READ(10,'(7d16.8)') 
     &           edsr(m1,m2),sdsr(m1,m2),rhobsr(m1),ppsr(m1,m2),
     &           ttsr(m1,m2),mubsr(m1,m2),mussr(m1,m2)
         end do
      end do
      CLOSE(10)

c      write(*,*)'mussr(mbin1sr,mbin2sr)=',mussr(mbin1sr,mbin2sr)

CCC   #################################################################
      RETURN
      STOP 
      END 





CCC   #################################################################
CCC   geteosesx() 
CCC   carry out the interpolation with given arrays
CCC   #################################################################
CCC   last updated 10092007
CCC   fix a bug
CCC
CCC   last updated 08112006
CCC   inherited and modified from getesx()
CCC   #################################################################
      SUBROUTINE geteosesx(eos,gf,phsflg)

      IMPLICIT NONE

      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      include 'spherio.esxdata.inc'
      include 'spherio.debug.inc'
      include 'epos.incsf'

      INTEGER phsflg,gf

      INTEGER jj,kk,n1,n2,m1,m2,k1,k2,j1,j2 
      integer ioutfl,ioutgl
      integer itag

      double precision pp
      DOUBLE PRECISION ndgvn1,ndgvn2
      DOUBLE PRECISION xnb(1:5),sign 
      DOUBLE PRECISION xx0(1:200),xx1(1:5)

      DOUBLE PRECISION yymub(1:5),yymus(1:5),yypp(1:5)
      DOUBLE PRECISION yytt(1:5),yygf(1:5)
      DOUBLE PRECISION mubin(1:5),musin(1:5),ppin(1:5)
      DOUBLE PRECISION ttin(1:5),gfin(1:5)

      DOUBLE PRECISION yyy,xxx


c     yyy: dens. entropia
c     xxx: dens. barionica
      yyy(xxx)=0.3d0+62.5d0*xxx
      ioutfl=0
      ioutgl=0
CCC   #################################################################
CCC   method+phase
      itag=gf*10+phsflg
CCC   #################################################################
      ndgvn1= eos(3)
      if(ndgvn1.lt.zero) then 
         ndgvn2= -ndgvn1 
         sign= -1.d+00
      else
         ndgvn2= +ndgvn1  
         sign= +1.d+00
      end if
      

      select case (itag)
CCC   #################################################################
      case (20)			!!entropy+hadron=sr
         call locate1(rhobsr,mbin1sr,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'rhobsr lower boundary overflow!'
              write(70,*)'eos(gf,3)=',eos(gf),eos(3)
              close(70)
             endif
         else if(m1.eq.mbin1sr) then	!<--
            j1=mbin1sr-1	!<--
            j2=mbin1sr	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'rhobsr upper boundary overflow!'
              write(70,*)'eos(gf,3)=',eos(gf),eos(3)
              close(70)
            endif
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0
         do 401 jj=j1,j2
            n1=n1+1
            xnb(n1)= rhobsr(jj)	!<--
            do m2=1,mbin2sr	!<--
               xx0(m2)= sdsr(jj,m2)	!<--
            end do
            call locate1(xx0,mbin2sr,eos(gf),m2)	!<--
            if(m2.eq.0) then
               ioutgl=1
               k1=1
               k2=2
            if (iauxi.ge.20) then
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'sdsr lower boundary overflow!'
              write(70,*)'eos(gf,3)=',eos(gf),eos(3)
              close(70)
            endif
            else if(m2.eq.mbin2sr) then	!<--
               k1=mbin2sr-1	!<--
               k2=mbin2sr	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'sdsr upper boundary overflow!'
              write(70,*)'eos(gf,3)=',eos(gf),eos(3)
              close(70)
            endif
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 411 kk=k1,k2
               n2=n2+1
               xx1(n2)= sdsr(jj,kk)	!<--
               yygf(n2)= edsr(jj,kk)	!<--
               yypp(n2)= ppsr(jj,kk)	!<--
               yytt(n2)= ttsr(jj,kk)	!<--
               yymub(n2)= mubsr(jj,kk)	!<--
               yymus(n2)= mussr(jj,kk)	!<--
 411     continue
            if (eos(gf).gt.0.and.ioutgl.ne.1) then
              pp=(log(eos(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
            else
              pp=((eos(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            gfin(n1)=(1.d0-pp)*yygf(1)+pp*yygf(2)	!<--
 401     continue
CCC   #################################################################
      case (10)			!!energy+hadron=er
         call locate1(rhober,mbin1er,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
         else if(m1.eq.mbin1er) then	!<--
            j1=mbin1er-1	!<--
            j2=mbin1er	!<--
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 402 jj=j1,j2  
            n1=n1+1
            xnb(n1)= rhober(jj)	!<--
            do m2=1,mbin2er	!<--
               xx0(m2)= eder(jj,m2)	!<--
            end do
            call locate1(xx0,mbin2er,eos(gf),m2)	!<--
            if(m2.eq.0) then
               ioutgl=1
               k1=1
               k2=2
            else if(m2.eq.mbin2er) then	!<--
               k1=mbin2er-1	!<--
               k2=mbin2er	!<--
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 412 kk=k1,k2
               n2=n2+1
               xx1(n2)= eder(jj,kk)	!<--
               yygf(n2)= sder(jj,kk)	!<--
               yypp(n2)= pper(jj,kk)	!<--
               yytt(n2)= tter(jj,kk)	!<--
               yymub(n2)= muber(jj,kk)	!<--
               yymus(n2)= muser(jj,kk)	!<--
 412     continue
            if (eos(gf).gt.0.and.ioutgl.ne.1) then
              pp=(log(eos(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
            else
              pp=((eos(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            gfin(n1)=(1.d0-pp)*yygf(1)+pp*yygf(2)	!<--
 402     continue
CCC   #################################################################
      case (22)			!!entropy+qgp=sq
         call locate1(rhobsq,mbin1sq,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
         else if(m1.eq.mbin1sq) then	!<--
            j1=mbin1sq-1	!<--
            j2=mbin1sq	!<--
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 403 jj=j1,j2  
            n1=n1+1
            xnb(n1)= rhobsq(jj)	!<--
            do m2=1,mbin2sq	!<--
               xx0(m2)= sdsq(jj,m2)	!<--
            end do
            call locate1(xx0,mbin2sq,eos(gf),m2)	!<--
            if(m2.eq.0) then
               ioutgl=1
               k1=1
               k2=2
            else if(m2.eq.mbin2sq) then	!<--
               k1=mbin2sq-1	!<--
               k2=mbin2sq	!<--
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 413 kk=k1,k2
               n2=n2+1
               xx1(n2)= sdsq(jj,kk)	!<--
               yygf(n2)= edsq(jj,kk)	!<--
               yypp(n2)= ppsq(jj,kk)	!<--
               yytt(n2)= ttsq(jj,kk)	!<--
               yymub(n2)= mubsq(jj,kk)	!<--
               yymus(n2)= mussq(jj,kk)	!<--
 413     continue
            if (eos(gf).gt.0.and.ioutgl.ne.1) then
              pp=(log(eos(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
            else
              pp=((eos(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            gfin(n1)=(1.d0-pp)*yygf(1)+pp*yygf(2)	!<--
 403     continue
CCC   #################################################################
      case (12)			!!energy+qgp=eq
         call locate1(rhobeq,mbin1eq,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
         else if(m1.eq.mbin1eq) then	!<--
            j1=mbin1eq-1	!<--
            j2=mbin1eq	!<--
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 404 jj=j1,j2  
            n1=n1+1
            xnb(n1)= rhobeq(jj)	!<--
            do m2=1,mbin2eq	!<--
               xx0(m2)= edeq(jj,m2)	!<--
            end do
            call locate1(xx0,mbin2eq,eos(gf),m2)	!<--
            if(m2.eq.0) then
               ioutgl=1
               k1=1
               k2=2
            else if(m2.eq.mbin2eq) then	!<--
               k1=mbin2eq-1	!<--
               k2=mbin2eq	!<--
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 414 kk=k1,k2
               n2=n2+1
               xx1(n2)= edeq(jj,kk)	!<--
               yygf(n2)= sdeq(jj,kk)	!<--
               yypp(n2)= ppeq(jj,kk)	!<--
               yytt(n2)= tteq(jj,kk)	!<--
               yymub(n2)= mubeq(jj,kk)	!<--
               yymus(n2)= museq(jj,kk)	!<--
 414     continue
            if (eos(gf).gt.0.and.ioutgl.ne.1) then
              pp=(log(eos(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
            else
              pp=((eos(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            gfin(n1)=(1.d0-pp)*yygf(1)+pp*yygf(2)	!<--
 404     continue
CCC   #################################################################
      case default
            write(*,*)'gf or phsflg debugging error in geteosesx'
            write(*,*)'gf,phsflg=',gf,phsflg
            stop
      end select
CCC   #################################################################
      pp=(ndgvn2-xnb(1))/(xnb(2)-xnb(1))
      if((itag.eq.20).and.(eos(gf).lt.yyy(ndgvn2)))then
c        pp=(log(ndgvn2+1.d-50)-log(xnb(1)))/(log(xnb(2))-log(xnb(1)))
c         pp=0.d0
      if (iauxi.ge.20) then
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(2a)')'The following info shows the limit ', 
     &               'of EOS table interpolation'
      WRITE(70,'(a,2d30.20)')'xnb(1),xnb(2)=',xnb(1),xnb(2)
      WRITE(70,'(a,2d30.20)')'gfin(1),gfin(2)=',gfin(1),gfin(2)
      WRITE(70,'(a,2d30.20)')'ttin(1),ttin(2)=',ttin(1),ttin(2)
      WRITE(70,'(a,2d30.20)')'mubin(1),mubin(2)=',mubin(1),mubin(2)
      WRITE(70,'(a,2d30.20)')'musin(1),musin(2)=',musin(1),musin(2)
      WRITE(70,'(a,2d30.20)')'ndgvn2,pp=',ndgvn2,pp
      CLOSE(70)
      endif
      endif
      eos(3-gf)=(1.d0-pp)*gfin(1)+pp*gfin(2)	! --> another density	!<--
      eos(4)=(1.d0-pp)*ppin(1)+pp*ppin(2)	! --> pressure
      eos(5)=(1.d0-pp)*ttin(1)+pp*ttin(2)	! --> temperature
      eos(6)=(1.d0-pp)*mubin(1)+pp*mubin(2) ! --> baryon chemical potential
      eos(7)=(1.d0-pp)*musin(1)+pp*musin(2) ! --> strangeness chemical potential
      if(ioutfl.eq.1)then		!!very low density
         eos(6)=ndgvn2/xnb(1)*mubin(1)
         eos(7)=ndgvn2/xnb(1)*musin(1)
      endif
      eos(6)=eos(6)*sign
      eos(7)=eos(7)*sign

      if ((gf.eq.2).and.(eos(2).eq.zero).and.(eos(3).eq.zero)) then
      eos(1)=zero
      eos(4)=zero
      eos(5)=zero
      eos(6)=zero
      eos(7)=zero
      endif


      RETURN 
      END 


      



CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################



CCC   #################################################################
CCC   geteosesx_tmub() 
CCC   Interpolation to make use of the stbf3 and stbf4 tables
CCC   #################################################################
CCC   last updated 09212013
CCC   should be done using loop to avoid unnecessary typos
CCC
CCC   last updated 09202013
CCC   inherited and modified from getesx()
CCC   #################################################################
      SUBROUTINE geteosesx_tmub(eos,rt,rmub,phsflg)

      IMPLICIT NONE

      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      include 'spherio.evgen3.inc'
      include 'spherio.debug.inc'
      include 'epos.incsf'

      INTEGER phsflg
      INTEGER jj,kk,n1,n2,m1,m2,k1,k2,j1,j2 

      double precision rt,rmub
      double precision pp
      DOUBLE PRECISION xT(1:5),sign 
      DOUBLE PRECISION xx0(1:200),xx1(1:5)

      DOUBLE PRECISION yyp(1:5),yynb(1:5),yye(1:5),yys(1:5),yyms(1:5)
      DOUBLE PRECISION Pin(1:5),nbin(1:5),ein(1:5),ssin(1:5),msin(1:5)

      DOUBLE PRECISION yyy,xxx

      if(rmub.lt.zero) then 
         rmub= -rmub
         sign= -1.d+00
      else
         sign= +1.d+00
      end if

      select case (phsflg)
CCC   #################################################################
      case (0)			!!hadrons
         call locate1(xx_T,nr_T,rt,m1)
         if(m1.eq.0) then
            j1=1
            j2=2
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'xx_T lower boundary overflow!'
              write(70,*)'xx_T(1),rt=',xx_T(1),rt
              close(70)
             endif
         else if(m1.eq.nr_T) then	!<--
            j1=nr_T-1	!<--
            j2=nr_T	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'xx_T upper boundary overflow!'
              write(70,*)'xx_T(nr_T),rt=',xx_T(nr_T),rt
              close(70)
            endif
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0
         do jj=j1,j2
            n1=n1+1
            xT(n1)= xx_T(jj)	!<--
            do m2=1,nr_ub	!<--
               xx0(m2)= xx_ub(jj,m2)	!<--
            end do
            call locate1(xx0,nr_ub,rmub,m2)	!<--
            if(m2.eq.0) then
               k1=1
               k2=2
            if (iauxi.ge.20) then
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'xx_ub lower boundary overflow!'
              write(70,*)'xx_ub(jj,1),rmub=',xx_ub(jj,1),rmub
              close(70)
            endif
            else if(m2.eq.nr_ub) then	!<--
               k1=nr_ub-1	!<--
               k2=nr_ub		!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'xx_ub upper boundary overflow!'
              write(70,*)'xx_ub(jj,nr_ub),rmub=',xx_ub(jj,nr_ub),rmub
              close(70)
            endif
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do kk=k1,k2
               n2=n2+1
               xx1(n2)= xx_ub(jj,kk)	!<--
               yyP(n2)= xx_P(jj,kk)		!<--
               yynb(n2)= xx_nb(jj,kk)	!<--
               yye(n2)= xx_e(jj,kk)		!<--
               yys(n2)= xx_s(jj,kk)		!<--
               yyms(n2)=xx_us(jj,kk)	!<--
            enddo
            pp=(rmub-(xx1(1)))/((xx1(2))-(xx1(1)))
            Pin(n1)=(1.d0-pp)*yyP(1)+pp*yyP(2)
            nbin(n1)=(1.d0-pp)*yynb(1)+pp*yynb(2)
            ein(n1)=(1.d0-pp)*yye(1)+pp*yye(2)
            ssin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
            msin(n1)=(1.d0-pp)*yyms(1)+pp*yyms(2)
         enddo
CCC   #################################################################
      case (2)			!!QGP
         call locate1(qq_T,nq_T,rt,m1)
         if(m1.eq.0) then
            j1=1
            j2=2
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'qq_T lower boundary overflow!'
              write(70,*)'qq_T(1),rt=',qq_T(1),rt
              close(70)
             endif
         else if(m1.eq.nq_T) then	!<--
            j1=nq_T-1	!<--
            j2=nq_T	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'qq_T upper boundary overflow!'
              write(70,*)'qq_T(nq_T),rt=',qq_T(nq_T),rt
              close(70)
            endif
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0
         do jj=j1,j2
            n1=n1+1
            xT(n1)= qq_T(jj)	!<--
            do m2=1,nq_ub	!<--
               xx0(m2)= qq_ub(jj,m2)	!<--
            end do
            call locate1(xx0,nq_ub,rmub,m2)	!<--
            if(m2.eq.0) then
               k1=1
               k2=2
            if (iauxi.ge.20) then
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'qq_ub lower boundary overflow!'
              write(70,*)'qq_ub(jj,1),rmub=',qq_ub(jj,1),rmub
              close(70)
            endif
            else if(m2.eq.nq_ub) then	!<--
               k1=nq_ub-1	!<--
               k2=nq_ub		!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'qq_ub upper boundary overflow!'
              write(70,*)'qq_ub(jj,nq_ub),rmub=',qq_ub(jj,nq_ub),rmub
              close(70)
            endif
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do kk=k1,k2
               n2=n2+1
               xx1(n2)= qq_ub(jj,kk)	!<--
               yyP(n2)= qq_P(jj,kk)		!<--
               yynb(n2)= qq_nb(jj,kk)	!<--
               yye(n2)= qq_e(jj,kk)		!<--
               yys(n2)= qq_s(jj,kk)		!<--
               yyms(n2)=qq_us(jj,kk)	!<--
            enddo
            pp=(rmub-(xx1(1)))/((xx1(2))-(xx1(1)))
            Pin(n1)=(1.d0-pp)*yyP(1)+pp*yyP(2)
            nbin(n1)=(1.d0-pp)*yynb(1)+pp*yynb(2)
            ein(n1)=(1.d0-pp)*yye(1)+pp*yye(2)
            ssin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
            msin(n1)=(1.d0-pp)*yyms(1)+pp*yyms(2)
         enddo
CCC   #################################################################
      case (1)			!!mixed phase
         call locate1(mm_T,nm_T,rt,m1)
         if(m1.eq.0) then
            j1=1
            j2=2
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'mm_T lower boundary overflow!'
              write(70,*)'mm_T(1),rt=',mm_T(1),rt
              close(70)
             endif
         else if(m1.eq.nm_T) then	!<--
            j1=nm_T-1	!<--
            j2=nm_T	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'mm_T upper boundary overflow!'
              write(70,*)'mm_T(nm_T),rt=',mm_T(nm_T),rt
              close(70)
            endif
         else
            j1=m1
            j2=m1+1
         end if
c         write(*,*)'j1,j2,rt,mm_T(j1),mm_T(j2)',
c     &     j1,j2,rt,mm_T(j1),mm_T(j2)
         
         n1=0
         do jj=j1,j2
            n1=n1+1
            xT(n1)= mm_T(jj)	!<--
            do m2=1,nm_ub	!<--
               xx0(m2)= mm_ub(jj,m2)	!<--
            end do
            call locate1(xx0,nm_ub,rmub,m2)	!<--
            if(m2.eq.0) then
               k1=1
               k2=2
            if (iauxi.ge.20) then
              open(70,file=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'mm_ub lower boundary overflow!'
              write(70,*)'mm_ub(jj,1),rmub=',mm_ub(jj,1),rmub
              close(70)
            endif
            else if(m2.eq.nm_ub) then	!<--
               k1=nm_ub-1	!<--
               k2=nm_ub		!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
              write(70,*)' '
              write(70,*)'mm_ub upper boundary overflow!'
              write(70,*)'mm_ub(jj,nm_ub),rmub=',mm_ub(jj,nm_ub),rmub
              close(70)
            endif
            else
               k1=m2
               k2=m2+1
            end if
c            write(*,*)'k1,k2,rmub,xx0(k1),xx0(k2)',
c     &         k1,k2,rmub,xx0(k1),xx0(k2)
            
            
            n2=0
            do kk=k1,k2
               n2=n2+1
               xx1(n2)= mm_ub(jj,kk)	!<--
               yyP(n2)= mm_P(jj,kk)		!<--
               yynb(n2)= mm_nb(jj,kk)	!<--
               yye(n2)= mm_e(jj,kk)		!<--
               yys(n2)= mm_s(jj,kk)		!<--
               yyms(n2)=mm_us(jj,kk)	!<--
            enddo
            pp=(rmub-(xx1(1)))/((xx1(2))-(xx1(1)))
            Pin(n1)=(1.d0-pp)*yyP(1)+pp*yyP(2)
            nbin(n1)=(1.d0-pp)*yynb(1)+pp*yynb(2)
            ein(n1)=(1.d0-pp)*yye(1)+pp*yye(2)
            ssin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
            msin(n1)=(1.d0-pp)*yyms(1)+pp*yyms(2)
         enddo
CCC   #################################################################
      case default
            write(*,*)'phsflg phsflg debugging error in geteosesx_tmub'
            write(*,*)'phsflg=',phsflg
            stop
      end select
CCC   #################################################################
      pp=(rt-xT(1))/(xT(2)-xT(1))
      eos(1)=(1.d0-pp)*ein(1)+pp*ein(2)		! --> energy
      eos(2)=(1.d0-pp)*ssin(1)+pp*ssin(2)		! --> entropy
      eos(3)=(1.d0-pp)*nbin(1)+pp*nbin(2)		! --> baryon density
      eos(4)=(1.d0-pp)*Pin(1)+pp*Pin(2)		! --> pressure
      eos(5)=rt				! --> temperature
      eos(6)=rmub				! --> baryon chemical potential
      eos(7)=(1.d0-pp)*msin(1)+pp*msin(2)	! --> strangeness chemical potential
      eos(3)=eos(3)*sign
      eos(6)=eos(6)*sign
      eos(7)=eos(7)*sign
c      write(*,*)'pp,rt,xT(1),xT(2)=',pp,rt,xT(1),xT(2)
c      write(*,*)'ein(1),ein(2)=',ein(1),ein(2)
      
      RETURN 
      END 

CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################



CCC   #################################################################
CCC   geteositp() 
CCC   carry out the interpolation with given arrays
CCC   #################################################################
CCC   last updated 08122006
CCC   inherited and modified from geteosesx()
CCC   #################################################################
      SUBROUTINE geteosmix(eos,gf,phsflg)

      IMPLICIT NONE

      include 'spherio.const.inc'
      include 'spherio.eos.inc'
      include 'spherio.mixdata.inc'
      include 'spherio.debug.inc'
      include 'epos.incsf'

      INTEGER phsflg,gf

      INTEGER jj,kk,n1,n2,m1,m2,k1,k2,j1,j2 
      integer ioutfl
      integer itag

      double precision pp
      DOUBLE PRECISION ndgvn1,ndgvn2
      DOUBLE PRECISION xnb(1:5),sign 
      DOUBLE PRECISION xx0(1:200),xx1(1:5)

      DOUBLE PRECISION yymub(1:5),yymus(1:5),yypp(1:5)
      DOUBLE PRECISION yytt(1:5),yygf(1:5)
      DOUBLE PRECISION mubin(1:5),musin(1:5),ppin(1:5)
      DOUBLE PRECISION ttin(1:5),gfin(1:5)

      DOUBLE PRECISION yyy,xxx


c     yyy: dens. entropia
c     xxx: dens. barionica
      yyy(xxx)=0.3d0+62.5d0*xxx
      ioutfl=0
CCC   #################################################################
CCC   method+phase
      itag=gf*10+phsflg
CCC   #################################################################
      ndgvn1= eos(3)
      if(ndgvn1.lt.zero) then 
         ndgvn2= -ndgvn1 
         sign= -1.d+00
      else
         ndgvn2= +ndgvn1  
         sign= +1.d+00
      end if
      

      select case (itag)
CCC   #################################################################
      case (21)			!!entropy+mix
         call locate1(rhobmixtp,mbbxmixtp,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      		write(70,*)' '
      		write(70,*)'rhobmixtp lower boundary overflow!'
      		write(70,*)'eos(gf,3)=',eos(gf),eos(3)
      		close(70)
            endif
         else if(m1.eq.mbbxmixtp) then	!<--
            j1=mbbxmixtp-1	!<--
            j2=mbbxmixtp	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      		write(70,*)' '
      		write(70,*)'rhobmixtp upper boundary overflow!'
      		write(70,*)'eos(gf,3)=',eos(gf),eos(3)
      		close(70)
            endif
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 405 jj=j1,j2  
            n1=n1+1
            xnb(n1)= rhobmixtp(jj)	!<--
            do m2=1,mtpxmixtp	!<--
               xx0(m2)= sdmixtp(jj,m2)	!<--
            end do
            call locate1(xx0,mtpxmixtp,eos(gf),m2)	!<--
            if(m2.eq.0) then
               k1=1
               k2=2
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      		write(70,*)' '
      		write(70,*)'sdmixtp lower boundary overflow!'
      		write(70,*)'eos(gf,3)=',eos(gf),eos(3)
      		close(70)
            endif
            else if(m2.eq.mtpxmixtp) then	!<--
               k1=mtpxmixtp-1	!<--
               k2=mtpxmixtp	!<--
            if (iauxi.ge.20) then
              OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      		write(70,*)' '
      		write(70,*)'sdmixtp higer boundary overflow!'
      		write(70,*)'eos(gf,3)=',eos(gf),eos(3)
      		close(70)
            endif
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 415 kk=k1,k2
               n2=n2+1
               xx1(n2)= sdmixtp(jj,kk)	!<--
               yygf(n2)= edmixtp(jj,kk)	!<--
               yypp(n2)= ppmixtp(jj,kk)	!<--
               yytt(n2)= ttmixtp(jj,kk)	!<--
               yymub(n2)= mubmixtp(jj,kk)	!<--
               yymus(n2)= musmixtp(jj,kk)	!<--
 415        continue
      	  if (eos(gf).gt.0) then
              pp=(log(eos(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
      	  else
              pp=((eos(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            gfin(n1)=(1.d0-pp)*yygf(1)+pp*yygf(2)	!<--
 405     continue
CCC   #################################################################
      case (11)			!!energy+mix
         call locate1(rhobmixee,mbbxmixee,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1
            j1=1
            j2=2
         else if(m1.eq.mbbxmixee) then	!<--
            j1=mbbxmixee-1	!<--
            j2=mbbxmixee	!<--
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 406 jj=j1,j2  
            n1=n1+1
            xnb(n1)= rhobmixee(jj)	!<--
            do m2=1,meexmixee		!<--
               xx0(m2)= edmixee(jj,m2)	!<--
            end do
            call locate1(xx0,meexmixee,eos(gf),m2)	!<--
            if(m2.eq.0) then
               k1=1
               k2=2
            else if(m2.eq.meexmixee) then	!<--
               k1=meexmixee-1	!<--
               k2=meexmixee	!<--
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 416 kk=k1,k2
               n2=n2+1
               xx1(n2)= edmixee(jj,kk)	!<--
               yygf(n2)= sdmixee(jj,kk)	!<--
               yypp(n2)= ppmixee(jj,kk)	!<--
               yytt(n2)= ttmixee(jj,kk)	!<--
               yymub(n2)= mubmixee(jj,kk)	!<--
               yymus(n2)= musmixee(jj,kk)	!<--
 416        continue
      	  if (eos(gf).gt.0) then
              pp=(log(eos(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
      	  else
              pp=((eos(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            gfin(n1)=(1.d0-pp)*yygf(1)+pp*yygf(2)	!<--
 406     continue
CCC   #################################################################
      case default
      	write(*,*)'gf or phsflg debugging error in geteosmix'
      	write(*,*)'gf,phsflg=',gf,phsflg
      	stop
      end select
CCC   #################################################################
      pp=(ndgvn2-xnb(1))/(xnb(2)-xnb(1))
      eos(3-gf)=(1.d0-pp)*gfin(1)+pp*gfin(2)	! --> another density	!<--
      eos(4)=(1.d0-pp)*ppin(1)+pp*ppin(2)	! --> pressure
      eos(5)=(1.d0-pp)*ttin(1)+pp*ttin(2)	! --> temperature
      eos(6)=(1.d0-pp)*mubin(1)+pp*mubin(2) ! --> baryon chemical potential
      eos(7)=(1.d0-pp)*musin(1)+pp*musin(2) ! --> strangeness chemical potential
      if(ioutfl.eq.1)then		!!very low density
         eos(6)=ndgvn2/xnb(1)*mubin(1)
      endif
      eos(6)=eos(6)*sign
      eos(7)=eos(7)*sign

CCC   #################################################################
      RETURN 
      END 


      



CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################



CCC   #################################################################
CCC   to find the value of temperature, chemical potential and other
CCC   themal quantities from data table and interpolation
CCC   by using baryon density and entropy density/energy density
CCC   as input
CCC   #################################################################
CCC   last updated 07112006
CCC   remark the debugging output during the interpolation
CCC
CCC   last updated 06192006
CCC   rewrite the debug output
CCC
CCC   last updated 06122006
CCC   implemented with inclusion of 'spherio.esxdata.inc'
CCC   in replacement of 'spherio.tmu.inc'
CCC
CCC   last updated 06092006
CCC   first setup the framework
CCC   #################################################################
      SUBROUTINE getesx(gf,given,phsflg,esx)
      IMPLICIT NONE
      include 'spherio.const.inc'
      include 'spherio.esx.inc'
      include 'spherio.esxdata.inc'
      include 'spherio.debug.inc'

      INTEGER phsflg,gf
      DOUBLE PRECISION given(3)
      INTEGER jj,kk,n1,n2,m1,m2,k1,k2,j1,j2 
      integer ioutfl
      integer itag
      double precision pp
      DOUBLE PRECISION ndgvn1,ndgvn2
      DOUBLE PRECISION xnb(5),sign 
      DOUBLE PRECISION xx0(150),xx1(5)
      DOUBLE PRECISION yymub(5),yymus(5),yypp(5),yytt(5),yyed(5)
      DOUBLE PRECISION mubin(5),musin(5),ppin(5),ttin(5),edin(5)
      DOUBLE PRECISION yyy,xxx
c     ------------------------------------------------------
c     ------------------------------------------------------ 

c.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
c     yyy: dens. entropia
c     xxx: dens. barionica
      yyy(xxx)=0.3d0+62.5d0*xxx
      ioutfl=0
c.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
      if ((phsflg.ne.0).and.(gf.ne.2)) then
      write (*,*)'gf or phsflg debugging error in getesx'
      stop
      end if

      itag=gf*10+phsflg
      esx(gf)=given(gf)	! --> given input
      esx(3)=given(3)		! --> given baryon density	
     
      ndgvn1= given(3) 
      if(ndgvn1.lt.zero) then 
         ndgvn2= -ndgvn1 
         sign= -1.d+00
      else
         ndgvn2= +ndgvn1  
         sign= +1.d+00
      end if
      
CCC   #################################################################
      select case (itag)
      case (20)
         call locate(rhobsr,mbin1sr,ndgvn2,m1)	!<--
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
!           write(*,*)'rhob lower boundary overflow, rhob,tpdst=',
!     &        ndgvn1,given(gf)
         else if(m1.eq.mbin1sr) then	!<--
            j1=mbin1sr-1	!<--
            j2=mbin1sr	!<--
!           write(*,*)'rhob upper boundary overflow, rhob,tpdst=',
!     &        ndgvn1,given(gf)
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 401 jj=j1,j2  
            n1=n1+1
            xnb(n1)= rhobsr(jj)	!<--
            do m2=1,mbin2sr	!<--
               xx0(m2)= sdsr(jj,m2)	!<--
            end do
            call locate(xx0,mbin2sr,given(gf),m2)	!<--
            if(m2.eq.0) then
               k1=1
               k2=2
!              write(*,*)'sdsr lower boundary overflow, rhob,tpdst=',
!     &          ndgvn1,given(gf)
            else if(m2.eq.mbin2sr) then	!<--
               k1=mbin2sr-1	!<--
               k2=mbin2sr	!<--
!              write(*,*)'sdsr upper boundary overflow, rhob,tpdst=',
!     &          ndgvn1,given(gf)
            else
               k1=m2
               k2=m2+1
            end if
            n2=0
            do 411 kk=k1,k2
               n2=n2+1
               xx1(n2)= sdsr(jj,kk)	!<--
               yyed(n2)= edsr(jj,kk)	!<--
               yypp(n2)= ppsr(jj,kk)	!<--
               yytt(n2)= ttsr(jj,kk)	!<--
               yymub(n2)= mubsr(jj,kk)	!<--
               yymus(n2)= mussr(jj,kk)	!<--
 411     continue
            if (given(gf).gt.0) then
              pp=(log(given(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
            else
              pp=((given(gf))-(xx1(1)))/((xx1(2))-(xx1(1)))
            endif
            ppin(n1)=(1.d0-pp)*yypp(1)+pp*yypp(2)
            ttin(n1)=(1.d0-pp)*yytt(1)+pp*yytt(2)
            mubin(n1)=(1.d0-pp)*yymub(1)+pp*yymub(2)
            musin(n1)=(1.d0-pp)*yymus(1)+pp*yymus(2)
            edin(n1)=(1.d0-pp)*yyed(1)+pp*yyed(2)	!<--
 401     continue
CCC   #################################################################
      pp=(ndgvn2-xnb(1))/(xnb(2)-xnb(1))
      if( (gf.eq.2) .and. (phsflg.eq.0) .and. 
     &    ( given(gf).lt.yyy(ndgvn2) ) )then
        pp=(log(ndgvn2+1.d-50)-log(xnb(1)))/(log(xnb(2))-log(xnb(1)))
      endif
      esx(5)=(1.d0-pp)*ttin(1)+pp*ttin(2)	! --> temperature
      esx(1)=(1.d0-pp)*edin(1)+pp*edin(2)	! --> energy density	!<--
      esx(4)=(1.d0-pp)*ppin(1)+pp*ppin(2)	! --> pressure
      esx(6)=(1.d0-pp)*mubin(1)+pp*mubin(2) ! --> baryon chemical potential
      esx(7)=(1.d0-pp)*musin(1)+pp*musin(2) ! --> strangeness chemical potential
      if(ioutfl.eq.1)then
         esx(6)=ndgvn2/xnb(1)*mubin(1)
      endif
      esx(6)=esx(6)*sign
      esx(7)=esx(7)*sign
CCC   #################################################################
      case default
         write(*,*)'gf or phsflg debugging error in getesx'
      end select
CCC   #################################################################
      RETURN 
      END 
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################



c-----------------------------------------------------------------------
      subroutine gettmunew(given,gf,Tm,ub,phsflg)
c-----------------------------------------------------------------------
      implicit none
      double precision Tm,ub,x(2),given(3)
      double precision tolx,tolf,temp
      integer np,ntrial
      data tolx /1d-6/
      data tolf /1d-6/
      data np /2/
      data ntrial /250/
      integer phsflg,gf
      temp = given(3)
      if(temp.lt.0d0)given(3)=-given(3)
      call ingues(given,gf,phsflg,x(1),x(2))
      call mnewt(ntrial,x,np,tolx,tolf,given,gf,phsflg)
      Tm=x(1)
      ub=x(2)   
      if(temp.lt.0d0)then
         ub = -ub
         given(3)=temp
      endif
      return
      end

CCC #################################################################
CCC   last updated at 04302006
CCC   to incorporate the strangeness
CCC   spherio.thr.inc is included
CCC #################################################################
      subroutine ingues(given,gf,phsflg,T,ub)

      implicit none
      include 'spherio.thr.inc'
      double precision given(3),T,ub
      integer gf,phsflg
      double precision dist,temp,var
      integer ii,jj

      dist = 1.0d+30   !!  distancia inicial grande
      if(phsflg.eq.0)then
         do ii = 1,mbin1r
            do jj = 1,mbin2r
               if(gf.eq.1) var=eer(ii,jj)
               if(gf.eq.2) var=esr(ii,jj)
               temp=sqrt((var-given(gf))**2+(enr(ii,jj)-given(3))**2)
               if(temp.lt.dist)then
                  dist=temp
                  T=etr(ii,jj)
                  ub=emr(jj)
               endif
            enddo
         enddo
      endif
      if(phsflg.eq.2)then
         do ii = 1,mbin1q
            do jj = 1,mbin2q
               if(gf.eq.1) var=eeq(ii,jj)
               if(gf.eq.2) var=esq(ii,jj)
               temp=sqrt((var-given(gf))**2+(enq(ii,jj)-given(3))**2)
               if(temp.lt.dist)then
                  dist=temp
                  T=etq(ii,jj)
                  ub=emq(jj)
               endif
            enddo
         enddo
      endif
      return
      end



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   mixdphs.f: for finding mixed phase T and x (rate of qgp and rg) 
CCC   #################################################################
CCC   last updated 04302006
CCC   modified the common block mix1,mix2
CCC   spherio.mixph.inc, spherio.const.inc are included
CCC   for the time being, the strangeness chemical potential has NOT
CCC   be incorporated into the calculation of phase separation fraction
CCC
CCC   last updated 05052006
CCC   include 'spherio.mixdphs.inc' to incorporate strangeness
CCC   for the time being this subroutine is served only for debugging purpose
CCC   Ubmix(2) --> strangeness chemical potential
CCC
CCC   last updated 11242001
CCC   #################################################################
      SUBROUTINE mixdphs(gf1,given,Tmix,Ubmix,Xmix,phsflg) 
      
      IMPLICIT NONE 
      include 'spherio.const.inc'
      include 'spherio.mixph.inc'
      include 'spherio.mixdphs.inc'
      include 'spherio.debug.inc'

      DOUBLE PRECISION A,B,C,D,E,F,G,H
      DOUBLE PRECISION yygvn,ndgvn,ndgvn2,given(3) 
      DOUBLE PRECISION C2,C1,C0,tp,sign,diff1,diff2 


      INTEGER i,gf1,gf2,phsflg

      DOUBLE PRECISION xmin,xmax 

      
      xmin=+9.99d+00
      xmax=-9.99d+00 
      ndgvn=given(3) 
      yygvn=given(gf1) 

ccc   ///////////////////////////////////////////
ccc   using a relation: n_B(T,-mu_B)=-n_B(T,mu_B)
      if(ndgvn.lt.zero) then 
         sign=-1.d+00
         ndgvn2=abs(ndgvn) 
      else
         sign=+1.d+00
         ndgvn2= ndgvn 
      end if
ccc   ///////////////////////////////////////////
      gf2=gf1+2
      do 23 i=1,mbinx-1 
         
         A= rgh(gf2,i+1)-rgh(gf2,i) 
         B= qgh(gf2,i)  -rgh(gf2,i)
         C= rgh(gf2,i)  -rgh(gf2,i+1) -qgh(gf2,i) +qgh(gf2,i+1) 
         D= rgh(gf2,i)  -yygvn 
         E= rgh(5,i+1)  -rgh(5,i) 
         F= qgh(5,i)    -rgh(5,i) 
         G= rgh(5,i)    -rgh(5,i+1)   -qgh(5,i)   +qgh(5,i+1) 
         H= rgh(5,i)    -ndgvn2 

         C2= F*C-B*G 
         C1= A*F+C*H-B*E-D*G
         C0= A*H-D*E 

         if(C2.lt.zero) then 
            C2=-C2
            C1=-C1
            C0=-C0
         end if
         if(C1*C1-four*C2*C0.lt.1.d-99) goto 23 
         Xmix= (-C1+sqrt(C1*C1-four*C2*C0))/(two*C2)

         if(Xmix.lt.zero.or.Xmix.gt.uni) then 
            goto 21
         end if

         if(abs(A+C*Xmix).gt.zero) then
            tp= -(B*Xmix+D)/(A+C*Xmix) 
         else if(abs(E+G*Xmix).gt.zero) then 
            tp= -(F*Xmix+H)/(E+G*Xmix)
         else
            goto 21 
         end if
         if(tp.lt.zero.or.tp.gt.uni) goto 23 
ccc   here is goal
         Tmix= (uni-tp)*rgh(1,i) + tp*rgh(1,i+1)
         Ubmix(1)= (uni-tp)*rgh(2,i) + tp*rgh(2,i+1)
         Ubmix(1)=Ubmix(1)*sign 
CCC   for debugging purpose only
         Ubmix(2)=zero
CCC   for debugging purpose only

         RETURN

 21      continue
         if(xmin.gt.Xmix) xmin= Xmix 
         if(xmax.lt.Xmix) xmax= Xmix 
 23   continue
      if(xmin.gt.1.d+00) then 
         phsflg=2 
         return
      else if(xmax.lt.0.d+00) then 
         phsflg=0 
         return
      else
         if(gf1.eq.1) then 
            diff1= abs(given(gf1) -eqmax)
            diff2= abs(given(gf1) -ermax)
            if(diff1.lt.diff2) then 
               phsflg=2
            else if(diff2.lt.diff1) then 
               phsflg=0
            end if
         end if
         if(gf1.eq.2) then 
            diff1= abs(given(gf1) -sqmax)
            diff2= abs(given(gf1) -srmax)
            if(diff1.lt.diff2) then 
               phsflg=2
            else if(diff2.lt.diff1) then 
               phsflg=0
            end if
         end if
      end if
      RETURN
      END



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   mixread()
CCC   for reading data table for the eos information in the mixed phase
CCC   #################################################################
CCC   last updated 08092006
CCC   #################################################################
      SUBROUTINE mixread() 
      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.mixdata.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'

      INTEGER m1,m2
      CHARACTER filename1*108, filename2*108
c      CHARACTER chtemp*200
      DOUBLE PRECISION dptemp
c     ------------------------------------------------------

      filename1= fneos(1:nfneos)//eosdatapath2//mixf1
      filename2= fneos(1:nfneos)//eosdatapath2//mixf2
CCC   #################################################################
CCC   DATA READING
CCC   #################################################################
      OPEN(10,file=filename1,status='old')
      READ(10,'(2i8)')mbbxmixtp,mtpxmixtp
      READ(10,'(a39)')
      do m1=1,mbbxmixtp		         !! for baryon number density 
         do m2=1,mtpxmixtp	         !! for entropy density 
            READ(10,'(8d30.20)') 
     &         edmixtp(m1,m2),sdmixtp(m1,m2),
     &         rhobmixtp(m1),ppmixtp(m1,m2),
     &         ttmixtp(m1,m2),mubmixtp(m1,m2),
     &         musmixtp(m1,m2),dptemp
         end do
      end do
      CLOSE(10)

CCC   #################################################################
      OPEN(10,file=filename2,status='old')
      READ(10,'(2i8)')mbbxmixee,meexmixee
      READ(10,'(a39)')
      do m1=1,mbbxmixee				!! for baryon number density
         do m2=1,meexmixee			!! for entropy density
            READ(10,'(8d30.20)') 
     &         edmixee(m1,m2),sdmixee(m1,m2),
     &         rhobmixee(m1),ppmixee(m1,m2),
     &         ttmixee(m1,m2),mubmixee(m1,m2),
     &         musmixee(m1,m2),dptemp
         end do
      end do
      CLOSE(10)

c      write(*,*)'musmixee(mbbxmixee,meexmixee)=',
c    &musmixee(mbbxmixee,meexmixee)

CCC   #################################################################
CCC   #################################################################
      RETURN
      STOP 
      END 





CCC   #######################################################################
CCC   SPheRIO resonace data pd.f 
CCC   Light Unflavored mesons(S= C= B= 0)     ID=   1  ->   64 (64)
CCC   Strange meson     (S=+/-1, C= B= 0)     ID=  70  ->  117 (48)
CCC   Charmed mesons             (C=+/-1)     ID= 120  ->  133 (14)
CCC   Charmed strange mesons (C= S= +/-1)     ID= 140  ->  141 ( 2)
CCC   N baryons            (S= 0, I= 1/2)     ID= 150  ->  201 (52)
CCC   Delta baryons        (S= 0, I= 3/2)     ID= 210  ->  289 (80)
CCC   Lambda baryons         (S=-1, I= 0)     ID= 300  ->  327 (28)
CCC   Sigma baryons          (S=-1, I= 1)     ID= 330  ->  383 (54)
CCC   Xsi baryons          (S=-2, I= 1/2)     ID= 390  ->  401 (12)
CCC   Omega baryons          (S=-3, I= 0)     ID= 410  ->  411 ( 2) total 356
CCC   Quarks and Gluons                       ID= 450  ->  456      Nf=3 
CCC                      for Quarks and Gluons, b,q,s need to divided by 3 
CCC   #######################################################################
CCC   last updated 05152006
CCC   include 'spherio.const.inc'
CCC   deleted some unnecessary blanks
CCC   #######################################################################
      SUBROUTINE pdtable()
      IMPLICIT NONE 

      include 'spherio.const.inc'
      DOUBLE PRECISION m
      INTEGER g,b,q,s 
      
      COMMON/prtclms/ m(1000)
      COMMON/quantum/ g(1000),b(1000),q(1000),s(1000) 
CCC   ######################################################################

CCC   Light Unflavored mesons(S= C= B= 0) 
CCC   //////////////////////////////////////////////////////////////////////
ccc   ------------------------      mass, g, B, Q, S 
      data m(1),g(1),b(1),q(1),s(1)/0.140,1,+0,+1,+0/ !! pi+ 
      data m(2),g(2),b(2),q(2),s(2)/0.135,1,+0,+0,+0/ !! pi0  
      data m(3),g(3),b(3),q(3),s(3)/0.140,1,+0,-1,+0/ !! pi-      
      data m(4),g(4),b(4),q(4),s(4)/0.547,1,+0,+0,+0/ !! eta 
      data m(5),g(5),b(5),q(5),s(5)/0.769,3,+0,+1,+0/ !! rho+ 
      data m(6),g(6),b(6),q(6),s(6)/0.769,3,+0,+0,+0/ !! rho0 
      data m(7),g(7),b(7),q(7),s(7)/0.769,3,+0,-1,+0/ !! rho- 
      data m(8),g(8),b(8),q(8),s(8)/0.783,3,+0,+0,+0/ !! omega
      data m(9),g(9),b(9),q(9),s(9)/0.958,1,+0,+0,+0/ !! eta' 
      
ccc   --------------------------------   mass, g, B, Q, S       
      data m(10),g(10),b(10),q(10),s(10)/0.980,1,+0,+0,+0/ !!f0(980)
      data m(11),g(11),b(11),q(11),s(11)/0.985,1,+0,+1,+0/ !!a0(980)+
      data m(12),g(12),b(12),q(12),s(12)/0.985,1,+0,+0,+0/ !!a0(980)0
      data m(13),g(13),b(13),q(13),s(13)/0.985,1,+0,-1,+0/ !!a0(980)-
      data m(14),g(14),b(14),q(14),s(14)/1.019,3,+0,+0,+0/ !!phi(1020) 
      data m(15),g(15),b(15),q(15),s(15)/1.170,3,+0,+0,+0/ !!h1
      data m(16),g(16),b(16),q(16),s(16)/1.229,3,+0,+1,+0/ !!b1+ 
      data m(17),g(17),b(17),q(17),s(17)/1.229,3,+0,+0,+0/ !!b10 
      data m(18),g(18),b(18),q(18),s(18)/1.229,3,+0,-1,+0/ !!b1- 
      data m(19),g(19),b(19),q(19),s(19)/1.230,3,+0,+1,+0/ !!a1(1260)+ 
      data m(20),g(20),b(20),q(20),s(20)/1.230,3,+0,+0,+0/ !!a1(1260)0 
      data m(21),g(21),b(21),q(21),s(21)/1.230,3,+0,-1,+0/ !!a1(1260)- 
      data m(22),g(22),b(22),q(22),s(22)/1.275,5,+0,+0,+0/ !!f2(1270) 
      data m(23),g(23),b(23),q(23),s(23)/1.282,3,+0,+0,+0/ !!f1(1285) 
      data m(24),g(24),b(24),q(24),s(24)/1.297,1,+0,+0,+0/ !!eta(1295)
      data m(25),g(25),b(25),q(25),s(25)/1.300,1,+0,+1,+0/ !!pi(1300)+
      data m(26),g(26),b(26),q(26),s(26)/1.300,1,+0,+0,+0/ !!pi(1300)0
      data m(27),g(27),b(27),q(27),s(27)/1.300,1,+0,-1,+0/ !!pi(1300)-
      data m(28),g(28),b(28),q(28),s(28)/1.318,5,+0,+1,+0/ !!a2(1320)+
      data m(29),g(29),b(29),q(29),s(29)/1.318,5,+0,+0,+0/ !!a2(1320)0
      data m(30),g(30),b(30),q(30),s(30)/1.318,5,+0,-1,+0/ !!a2(1320)-
      data m(31),g(31),b(31),q(31),s(31)/1.426,3,+0,+0,+0/ !!f1(1420)
      data m(32),g(32),b(32),q(32),s(32)/1.419,3,+0,+0,+0/ !!omega(1420)
      data m(33),g(33),b(33),q(33),s(33)/1.474,1,+0,+1,+0/ !!a0(1450)+ 
      data m(34),g(34),b(34),q(34),s(34)/1.474,1,+0,+0,+0/ !!a0(1450)0 
      data m(35),g(35),b(35),q(35),s(35)/1.474,1,+0,-1,+0/ !!a0(1450)- 
      data m(36),g(36),b(36),q(36),s(36)/1.465,3,+0,+1,+0/ !!rho(1450)+ 
      data m(37),g(37),b(37),q(37),s(37)/1.465,3,+0,+0,+0/ !!rho(1450)0
      data m(38),g(38),b(38),q(38),s(38)/1.465,3,+0,-1,+0/ !!rho(1450)- 
      data m(39),g(39),b(39),q(39),s(39)/1.500,1,+0,+0,+0/ !!f0(1500)
      data m(40),g(40),b(40),q(40),s(40)/1.525,5,+0,+0,+0/ !!f'2
      data m(41),g(41),b(41),q(41),s(41)/1.649,3,+0,+0,+0/ !!omega(1650)
      data m(42),g(42),b(42),q(42),s(42)/1.667,7,+0,+0,+0/ !!omega3(1670)
      data m(43),g(43),b(43),q(43),s(43)/1.670,5,+0,+1,+0/ !!pi2(1670)+ 
      data m(44),g(44),b(44),q(44),s(44)/1.670,5,+0,+0,+0/ !!pi2(1670)0 
      data m(45),g(45),b(45),q(45),s(45)/1.670,5,+0,-1,+0/ !!pi2(1670)-
      data m(46),g(46),b(46),q(46),s(46)/1.680,3,+0,+0,+0/ !!phi(1680)
      data m(47),g(47),b(47),q(47),s(47)/1.691,7,+0,+1,+0/ !!rho3(1690)+
      data m(48),g(48),b(48),q(48),s(48)/1.691,7,+0,+0,+0/ !!rho3(1690)0
      data m(49),g(49),b(49),q(49),s(49)/1.691,7,+0,-1,+0/ !!rho3(1690)-
      data m(50),g(50),b(50),q(50),s(50)/1.700,3,+0,+1,+0/ !!rho(1700)+
      data m(51),g(51),b(51),q(51),s(51)/1.700,3,+0,+0,+0/ !!rho(1700)0
      data m(52),g(52),b(52),q(52),s(52)/1.700,3,+0,-1,+0/ !!rho(1700)-
      data m(53),g(53),b(53),q(53),s(53)/1.715,1,+0,+0,+0/ !!f0(1710)
      data m(54),g(54),b(54),q(54),s(54)/1.801,1,+0,+1,+0/ !!pi(1800)+
      data m(55),g(55),b(55),q(55),s(55)/1.801,1,+0,+0,+0/ !!pi(1800)0
      data m(56),g(56),b(56),q(56),s(56)/1.801,1,+0,-1,+0/ !!pi(1800)-
      data m(57),g(57),b(57),q(57),s(57)/1.854,7,+0,+0,+0/ !!phi3(1850)
      data m(58),g(58),b(58),q(58),s(58)/2.011,5,+0,+0,+0/ !!f2(2010)
      data m(59),g(59),b(59),q(59),s(59)/2.014,9,+0,+1,+0/ !!a4(2040)+
      data m(60),g(60),b(60),q(60),s(60)/2.014,9,+0,+0,+0/ !!a4(2040)0
      data m(61),g(61),b(61),q(61),s(61)/2.014,9,+0,-1,+0/ !!a4(2040)-
      data m(62),g(62),b(62),q(62),s(62)/2.034,9,+0,+0,+0/ !!f4(2050)
      data m(63),g(63),b(63),q(63),s(63)/2.297,5,+0,+0,+0/ !!f2(2300)
      data m(64),g(64),b(64),q(64),s(64)/2.339,5,+0,+0,+0/ !!f2(2340)
ccc   ---------------------------------------------------------------------
      data m(65),g(65),b(65),q(65),s(65)/0.000,0,+0,+0,+0/ !! ----- 
      data m(66),g(66),b(66),q(66),s(66)/0.000,0,+0,+0,+0/ !! ----- 
      data m(67),g(67),b(67),q(67),s(67)/0.000,0,+0,+0,+0/ !! ----- 
      data m(68),g(68),b(68),q(68),s(68)/0.000,0,+0,+0,+0/ !! ----- 
      data m(69),g(69),b(69),q(69),s(69)/0.000,0,+0,+0,+0/ !! ----- 
CCC   //////////////////////////////////////////////////////////////////////

CCC    Strange meson(S=+/-1, C= B= 0)
ccc   --------------------------------   mass, g, B, Q, S       
      data m(70),g(70),b(70),q(70),s(70)/0.494,1,+0,+1,+1/ !!K+
      data m(71),g(71),b(71),q(71),s(71)/0.494,1,+0,-1,-1/ !!K-
      data m(72),g(72),b(72),q(72),s(72)/0.498,1,+0,+0,+1/ !!K0
      data m(73),g(73),b(73),q(73),s(73)/0.498,1,+0,-0,-1/ !!K0br
       
      data m(74),g(74),b(74),q(74),s(74)/0.892,3,+0,+1,+1/ !!K*(892)+
      data m(75),g(75),b(75),q(75),s(75)/0.892,3,+0,-1,-1/ !!K*(892)-
      data m(76),g(76),b(76),q(76),s(76)/0.896,3,+0,+0,+1/ !!K*(892)0
      data m(77),g(77),b(77),q(77),s(77)/0.896,3,+0,-0,-1/ !!K*(892)0br 

      data m(78),g(78),b(78),q(78),s(78)/1.273,3,+0,+1,+1/ !!K1(1270)+
      data m(79),g(79),b(79),q(79),s(79)/1.273,3,+0,-1,-1/ !!K1(1270)-
      data m(80),g(80),b(80),q(80),s(80)/1.273,3,+0,+0,+1/ !!K1(1270)0
      data m(81),g(81),b(81),q(81),s(81)/1.273,3,+0,-0,-1/ !!K1(1270)0br
 
      data m(82),g(82),b(82),q(82),s(82)/1.402,3,+0,+1,+1/ !!K1(1400)+
      data m(83),g(83),b(83),q(83),s(83)/1.402,3,+0,-1,-1/ !!K1(1400)-
      data m(84),g(84),b(84),q(84),s(84)/1.402,3,+0,+0,+1/ !!K1(1400)0
      data m(85),g(85),b(85),q(85),s(85)/1.402,3,+0,-0,-1/ !!K1(1400)0br
 
      data m(86),g(86),b(86),q(86),s(86)/1.414,3,+0,+1,+1/ !!K*(1410)+
      data m(87),g(87),b(87),q(87),s(87)/1.414,3,+0,-1,-1/ !!K*(1410)-
      data m(88),g(88),b(88),q(88),s(88)/1.414,3,+0,+0,+1/ !!K*(1410)0
      data m(89),g(89),b(89),q(89),s(89)/1.414,3,+0,-0,-1/ !!K*(1410)0br

      data m(90),g(90),b(90),q(90),s(90)/1.412,1,+0,+1,+1/ !!K0*(1430)+
      data m(91),g(91),b(91),q(91),s(91)/1.412,1,+0,-1,-1/ !!K0*(1430)-
      data m(92),g(92),b(92),q(92),s(92)/1.412,1,+0,+0,+1/ !!K0*(1430)0
      data m(93),g(93),b(93),q(93),s(93)/1.412,1,+0,-0,-1/ !!K0*(1430)0br

      data m(94),g(94),b(94),q(94),s(94)/1.425,5,+0,+1,+1/ !!K2*(1430)+
      data m(95),g(95),b(95),q(95),s(95)/1.425,5,+0,-1,-1/ !!K2*(1430)-
      data m(96),g(96),b(96),q(96),s(96)/1.432,5,+0,+0,+1/ !!K2*(1430)0
      data m(97),g(97),b(97),q(97),s(97)/1.432,5,+0,-0,-1/ !!K2*(1430)0br

      data m(98),g(98),b(98),q(98),s(98)/1.717,3,+0,+1,+1/ !!K*(1680)+
      data m(99),g(99),b(99),q(99),s(99)/1.717,3,+0,-1,-1/ !!K*(1680)-
      data m(100),g(100),b(100),q(100),s(100)/1.717,3,+0,+0,+1/ !!K*(1680)0
      data m(101),g(101),b(101),q(101),s(101)/1.717,3,+0,-0,-1/ !!K*(1680)0br
      
ccc   -------------------------------------   mass, g, B, Q, S       
      data m(102),g(102),b(102),q(102),s(102)/1.773,5,+0,+1,+1/ !!K2(1770)+
      data m(103),g(103),b(103),q(103),s(103)/1.773,5,+0,-1,-1/ !!K2(1770)-
      data m(104),g(104),b(104),q(104),s(104)/1.773,5,+0,+0,+1/ !!K2(1770)0
      data m(105),g(105),b(105),q(105),s(105)/1.773,5,+0,-0,-1/ !!K2(1770)0br

      data m(106),g(106),b(106),q(106),s(106)/1.776,7,+0,+1,+1/ !!K3*(1780)+
      data m(107),g(107),b(107),q(107),s(107)/1.776,7,+0,-1,-1/ !!K3*(1780)-
      data m(108),g(108),b(108),q(108),s(108)/1.776,7,+0,+0,+1/ !!K3*(1780)0
      data m(109),g(109),b(109),q(109),s(109)/1.776,7,+0,-0,-1/ !!K3*(1780)0br

      data m(110),g(110),b(110),q(110),s(110)/1.816,5,+0,+1,+1/ !!K2(1820)+
      data m(111),g(111),b(111),q(111),s(111)/1.816,5,+0,-1,-1/ !!K2(1820)-
      data m(112),g(112),b(112),q(112),s(112)/1.816,5,+0,+0,+1/ !!K2(1820)0
      data m(113),g(113),b(113),q(113),s(113)/1.816,5,+0,-0,-1/ !!K2(1820)0br

      data m(114),g(114),b(114),q(114),s(114)/2.045,9,+0,+1,+1/ !!K4*(2045)+
      data m(115),g(115),b(115),q(115),s(115)/2.045,9,+0,-1,-1/ !!K4*(2045)-
      data m(116),g(116),b(116),q(116),s(116)/2.045,9,+0,+0,+1/ !!K4*(2045)0
      data m(117),g(117),b(117),q(117),s(117)/2.045,9,+0,-0,-1/ !!K4*(2045)0br
ccc   ---------------------------------------------------------------------
      data m(118),g(118),b(118),q(118),s(118)/0.000,0,+0,+0,+0/ !! ----- 
      data m(119),g(119),b(119),q(119),s(119)/0.000,0,+0,+0,+0/ !! ----- 
CCC   //////////////////////////////////////////////////////////////////////

CCC    Charmed mesons(C=+/-1)
ccc   -------------------------------------   mass, g, B, Q, S       
      data m(120),g(120),b(120),q(120),s(120)/1.869,1,+0,+1,+0/ !! D+
      data m(121),g(121),b(121),q(121),s(121)/1.869,1,+0,-1,+0/ !! D- 
      data m(122),g(122),b(122),q(122),s(122)/1.865,1,+0,+0,+0/ !! D0
      data m(123),g(123),b(123),q(123),s(123)/1.865,1,+0,-0,+0/ !! D0br

      data m(124),g(124),b(124),q(124),s(124)/2.007,3,+0,+0,+0/ !! D*(2007)0
      data m(125),g(125),b(125),q(125),s(125)/2.007,3,+0,-0,+0/ !! D*(2007)0br
      data m(126),g(126),b(126),q(126),s(126)/2.010,3,+0,+1,+0/ !! D*(2010)+
      data m(127),g(127),b(127),q(127),s(127)/2.010,3,+0,-1,+0/ !! D*(2010)- 

      data m(128),g(128),b(128),q(128),s(128)/2.422,3,+0,+0,+0/ !! D1(2420)0
      data m(129),g(129),b(129),q(129),s(129)/2.422,3,+0,-0,+0/ !! D1(2420)0br

      data m(130),g(130),b(130),q(130),s(130)/2.459,5,+0,+1,+0/ !! D2*(2460)+
      data m(131),g(131),b(131),q(131),s(131)/2.459,5,+0,-1,+0/ !! D2*(2460)- 
      data m(132),g(132),b(132),q(132),s(132)/2.459,5,+0,+0,+0/ !! D2*(2460)0
      data m(133),g(133),b(133),q(133),s(133)/2.459,5,+0,-0,+0/ !! D2*(2460)0br

      data m(134),g(134),b(134),q(134),s(134)/0.000,0,+0,-0,+0/ !! -----
      data m(135),g(135),b(135),q(135),s(135)/0.000,0,+0,-0,+0/ !! -----
      data m(136),g(136),b(136),q(136),s(136)/0.000,0,+0,-0,+0/ !! -----
      data m(137),g(137),b(137),q(137),s(137)/0.000,0,+0,-0,+0/ !! -----
      data m(138),g(138),b(138),q(138),s(138)/0.000,0,+0,-0,+0/ !! -----
      data m(139),g(139),b(139),q(139),s(139)/0.000,0,+0,-0,+0/ !! -----

CCC   Charmed strange mesons(C= S= +/-1)
ccc   -------------------------------------   mass, g, B, Q, S             
      data m(140),g(140),b(140),q(140),s(140)/1.969,1,+0,+1,+1/ !! Ds+
      data m(141),g(141),b(141),q(141),s(141)/1.969,1,+0,-1,-1/ !! Ds- 
      data m(142),g(142),b(142),q(142),s(142)/0.000,0,+0,-0,+0/ !! -----
      data m(143),g(143),b(143),q(143),s(143)/0.000,0,+0,-0,+0/ !! -----
      data m(144),g(144),b(144),q(144),s(144)/0.000,0,+0,-0,+0/ !! -----
      data m(145),g(145),b(145),q(145),s(145)/0.000,0,+0,-0,+0/ !! -----
      data m(146),g(146),b(146),q(146),s(146)/0.000,0,+0,-0,+0/ !! -----
      data m(147),g(147),b(147),q(147),s(147)/0.000,0,+0,-0,+0/ !! -----
      data m(148),g(148),b(148),q(148),s(148)/0.000,0,+0,-0,+0/ !! -----
      data m(149),g(149),b(149),q(149),s(149)/0.000,0,+0,-0,+0/ !! -----

CCC   N baryons (S= 0, I= 1/2)
ccc   -------------------------------------   mass, g, B, Q, S             
      data m(150),g(150),b(150),q(150),s(150)/0.938,2,+1,+1,+0/ !! p
      data m(151),g(151),b(151),q(151),s(151)/0.938,2,-1,-1,+0/ !! p br 
      data m(152),g(152),b(152),q(152),s(152)/0.940,2,+1,+0,+0/ !! n
      data m(153),g(153),b(153),q(153),s(153)/0.940,2,-1,-0,+0/ !! n br       

      data m(154),g(154),b(154),q(154),s(154)/1.440,2,+1,+1,+0/ !! N(1440)+
      data m(155),g(155),b(155),q(155),s(155)/1.440,2,+1,+0,+0/ !! N(1440)0
      data m(156),g(156),b(156),q(156),s(156)/1.440,2,-1,-1,+0/ !! N(1440)+br
      data m(157),g(157),b(157),q(157),s(157)/1.440,2,-1,-0,+0/ !! N(1440)0br

      data m(158),g(158),b(158),q(158),s(158)/1.520,4,+1,+1,+0/ !! N(1520)+
      data m(159),g(159),b(159),q(159),s(159)/1.520,4,+1,+0,+0/ !! N(1520)0
      data m(160),g(160),b(160),q(160),s(160)/1.520,4,-1,-1,+0/ !! N(1520)+br
      data m(161),g(161),b(161),q(161),s(161)/1.520,4,-1,-0,+0/ !! N(1520)0br

      data m(162),g(162),b(162),q(162),s(162)/1.535,2,+1,+1,+0/ !! N(1535)+
      data m(163),g(163),b(163),q(163),s(163)/1.535,2,+1,+0,+0/ !! N(1535)0
      data m(164),g(164),b(164),q(164),s(164)/1.535,2,-1,-1,+0/ !! N(1535)+br
      data m(165),g(165),b(165),q(165),s(165)/1.535,2,-1,-0,+0/ !! N(1535)0br

      data m(166),g(166),b(166),q(166),s(166)/1.650,2,+1,+1,+0/ !! N(1650)+
      data m(167),g(167),b(167),q(167),s(167)/1.650,2,+1,+0,+0/ !! N(1650)0
      data m(168),g(168),b(168),q(168),s(168)/1.650,2,-1,-1,+0/ !! N(1650)+br
      data m(169),g(169),b(169),q(169),s(169)/1.650,2,-1,-0,+0/ !! N(1650)0br

      data m(170),g(170),b(170),q(170),s(170)/1.675,6,+1,+1,+0/ !! N(1675)+
      data m(171),g(171),b(171),q(171),s(171)/1.675,6,+1,+0,+0/ !! N(1675)0
      data m(172),g(172),b(172),q(172),s(172)/1.675,6,-1,-1,+0/ !! N(1675)+br
      data m(173),g(173),b(173),q(173),s(173)/1.675,6,-1,-0,+0/ !! N(1675)0br

      data m(174),g(174),b(174),q(174),s(174)/1.680,6,+1,+1,+0/ !! N(1680)+
      data m(175),g(175),b(175),q(175),s(175)/1.680,6,+1,+0,+0/ !! N(1680)0
      data m(176),g(176),b(176),q(176),s(176)/1.680,6,-1,-1,+0/ !! N(1680)+br
      data m(177),g(177),b(177),q(177),s(177)/1.680,6,-1,-0,+0/ !! N(1680)0br

      data m(178),g(178),b(178),q(178),s(178)/1.700,4,+1,+1,+0/ !! N(1700)+
      data m(179),g(179),b(179),q(179),s(179)/1.700,4,+1,+0,+0/ !! N(1700)0
      data m(180),g(180),b(180),q(180),s(180)/1.700,4,-1,-1,+0/ !! N(1700)+br
      data m(181),g(181),b(181),q(181),s(181)/1.700,4,-1,-0,+0/ !! N(1700)0br

      data m(182),g(182),b(182),q(182),s(182)/1.710,2,+1,+1,+0/ !! N(1710)+
      data m(183),g(183),b(183),q(183),s(183)/1.710,2,+1,+0,+0/ !! N(1710)0
      data m(184),g(184),b(184),q(184),s(184)/1.710,2,-1,-1,+0/ !! N(1710)+br
      data m(185),g(185),b(185),q(185),s(185)/1.710,2,-1,-0,+0/ !! N(1710)0br

      data m(186),g(186),b(186),q(186),s(186)/1.720,4,+1,+1,+0/ !! N(1720)+
      data m(187),g(187),b(187),q(187),s(187)/1.720,4,+1,+0,+0/ !! N(1720)0
      data m(188),g(188),b(188),q(188),s(188)/1.720,4,-1,-1,+0/ !! N(1720)+br
      data m(189),g(189),b(189),q(189),s(189)/1.720,4,-1,-0,+0/ !! N(1720)0br

      data m(190),g(190),b(190),q(190),s(190)/2.190,8,+1,+1,+0/ !! N(2190)+
      data m(191),g(191),b(191),q(191),s(191)/2.190,8,+1,+0,+0/ !! N(2190)0
      data m(192),g(192),b(192),q(192),s(192)/2.190,8,-1,-1,+0/ !! N(2190)+br
      data m(193),g(193),b(193),q(193),s(193)/2.190,8,-1,-0,+0/ !! N(2190)0br
      
      data m(194),g(194),b(194),q(194),s(194)/2.220,10,+1,+1,+0/ !! N(2220)+
      data m(195),g(195),b(195),q(195),s(195)/2.220,10,+1,+0,+0/ !! N(2220)0
      data m(196),g(196),b(196),q(196),s(196)/2.220,10,-1,-1,+0/ !! N(2220)+br
      data m(197),g(197),b(197),q(197),s(197)/2.220,10,-1,-0,+0/ !! N(2220)0br
      
      data m(198),g(198),b(198),q(198),s(198)/2.250,10,+1,+1,+0/ !! N(2250)+
      data m(199),g(199),b(199),q(199),s(199)/2.250,10,+1,+0,+0/ !! N(2250)0
      data m(200),g(200),b(200),q(200),s(200)/2.250,10,-1,-1,+0/ !! N(2250)+br
      data m(201),g(201),b(201),q(201),s(201)/2.250,10,-1,-0,+0/ !! N(2250)0br

      data m(202),g(202),b(202),q(202),s(202)/0.000,0,+0,+0,+0/ !! ----- 
      data m(203),g(203),b(203),q(203),s(203)/0.000,0,+0,+0,+0/ !! ----- 
      data m(204),g(204),b(204),q(204),s(204)/0.000,0,+0,+0,+0/ !! ----- 
      data m(205),g(205),b(205),q(205),s(205)/0.000,0,+0,+0,+0/ !! ----- 
      data m(206),g(206),b(206),q(206),s(206)/0.000,0,+0,+0,+0/ !! ----- 
      data m(207),g(207),b(207),q(207),s(207)/0.000,0,+0,+0,+0/ !! ----- 
      data m(208),g(208),b(208),q(208),s(208)/0.000,0,+0,+0,+0/ !! ----- 
      data m(209),g(209),b(209),q(209),s(209)/0.000,0,+0,+0,+0/ !! ----- 

CCC   Delta baryons (S= 0, I= 3/2)
ccc   -------------------------------------   mass, g, B, Q, S    
      data m(210),g(210),b(210),q(210),s(210)/1.232,4,+1,+2,+0/ !!Dlt(1232)++
      data m(211),g(211),b(211),q(211),s(211)/1.232,4,+1,+1,+0/ !!Dlt(1232)+
      data m(212),g(212),b(212),q(212),s(212)/1.232,4,+1,+0,+0/ !!Dlt(1232)0
      data m(213),g(213),b(213),q(213),s(213)/1.232,4,+1,-1,+0/ !!Dlt(1232)- 
      data m(214),g(214),b(214),q(214),s(214)/1.232,4,-1,-2,+0/ !!Dlt(1232)++br
      data m(215),g(215),b(215),q(215),s(215)/1.232,4,-1,-1,+0/ !!Dlt(1232)+ br
      data m(216),g(216),b(216),q(216),s(216)/1.232,4,-1,-0,+0/ !!Dlt(1232)0 br
      data m(217),g(217),b(217),q(217),s(217)/1.232,4,-1,+1,+0/ !!Dlt(1232)- br
      
      data m(218),g(218),b(218),q(218),s(218)/1.600,4,+1,+2,+0/ !!Dlt(1600)++
      data m(219),g(219),b(219),q(219),s(219)/1.600,4,+1,+1,+0/ !!Dlt(1600)+
      data m(220),g(220),b(220),q(220),s(220)/1.600,4,+1,+0,+0/ !!Dlt(1600)0
      data m(221),g(221),b(221),q(221),s(221)/1.600,4,+1,-1,+0/ !!Dlt(1600)- 
      data m(222),g(222),b(222),q(222),s(222)/1.600,4,-1,-2,+0/ !!Dlt(1600)++br
      data m(223),g(223),b(223),q(223),s(223)/1.600,4,-1,-1,+0/ !!Dlt(1600)+ br
      data m(224),g(224),b(224),q(224),s(224)/1.600,4,-1,-0,+0/ !!Dlt(1600)0 br
      data m(225),g(225),b(225),q(225),s(225)/1.600,4,-1,+1,+0/ !!Dlt(1600)- br
      
      data m(226),g(226),b(226),q(226),s(226)/1.620,2,+1,+2,+0/ !!Dlt(1620)++
      data m(227),g(227),b(227),q(227),s(227)/1.620,2,+1,+1,+0/ !!Dlt(1620)+
      data m(228),g(228),b(228),q(228),s(228)/1.620,2,+1,+0,+0/ !!Dlt(1620)0
      data m(229),g(229),b(229),q(229),s(229)/1.620,2,+1,-1,+0/ !!Dlt(1620)- 
      data m(230),g(230),b(230),q(230),s(230)/1.620,2,-1,-2,+0/ !!Dlt(1620)++br
      data m(231),g(231),b(231),q(231),s(231)/1.620,2,-1,-1,+0/ !!Dlt(1620)+ br
      data m(232),g(232),b(232),q(232),s(232)/1.620,2,-1,-0,+0/ !!Dlt(1620)0 br
      data m(233),g(233),b(233),q(233),s(233)/1.620,2,-1,+1,+0/ !!Dlt(1620)- br
      
      data m(234),g(234),b(234),q(234),s(234)/1.700,4,+1,+2,+0/ !!Dlt(1700)++
      data m(235),g(235),b(235),q(235),s(235)/1.700,4,+1,+1,+0/ !!Dlt(1700)+
      data m(236),g(236),b(236),q(236),s(236)/1.700,4,+1,+0,+0/ !!Dlt(1700)0
      data m(237),g(237),b(237),q(237),s(237)/1.700,4,+1,-1,+0/ !!Dlt(1700)- 
      data m(238),g(238),b(238),q(238),s(238)/1.700,4,-1,-2,+0/ !!Dlt(1700)++br
      data m(239),g(239),b(239),q(239),s(239)/1.700,4,-1,-1,+0/ !!Dlt(1700)+ br
      data m(240),g(240),b(240),q(240),s(240)/1.700,4,-1,-0,+0/ !!Dlt(1700)0 br
      data m(241),g(241),b(241),q(241),s(241)/1.700,4,-1,+1,+0/ !!Dlt(1700)- br

      data m(242),g(242),b(242),q(242),s(242)/1.905,6,+1,+2,+0/ !!Dlt(1905)++
      data m(243),g(243),b(243),q(243),s(243)/1.905,6,+1,+1,+0/ !!Dlt(1905)+
      data m(244),g(244),b(244),q(244),s(244)/1.905,6,+1,+0,+0/ !!Dlt(1905)0
      data m(245),g(245),b(245),q(245),s(245)/1.905,6,+1,-1,+0/ !!Dlt(1905)- 
      data m(246),g(246),b(246),q(246),s(246)/1.905,6,-1,-2,+0/ !!Dlt(1905)++br
      data m(247),g(247),b(247),q(247),s(247)/1.905,6,-1,-1,+0/ !!Dlt(1905)+ br
      data m(248),g(248),b(248),q(248),s(248)/1.905,6,-1,-0,+0/ !!Dlt(1905)0 br
      data m(249),g(249),b(249),q(249),s(249)/1.905,6,-1,+1,+0/ !!Dlt(1905)- br
      
      data m(250),g(250),b(250),q(250),s(250)/1.910,2,+1,+2,+0/ !!Dlt(1910)++
      data m(251),g(251),b(251),q(251),s(251)/1.910,2,+1,+1,+0/ !!Dlt(1910)+
      data m(252),g(252),b(252),q(252),s(252)/1.910,2,+1,+0,+0/ !!Dlt(1910)0
      data m(253),g(253),b(253),q(253),s(253)/1.910,2,+1,-1,+0/ !!Dlt(1910)- 
      data m(254),g(254),b(254),q(254),s(254)/1.910,2,-1,-2,+0/ !!Dlt(1910)++br
      data m(255),g(255),b(255),q(255),s(255)/1.910,2,-1,-1,+0/ !!Dlt(1910)+ br
      data m(256),g(256),b(256),q(256),s(256)/1.910,2,-1,-0,+0/ !!Dlt(1910)0 br
      data m(257),g(257),b(257),q(257),s(257)/1.910,2,-1,+1,+0/ !!Dlt(1910)- br

      data m(258),g(258),b(258),q(258),s(258)/1.920,4,+1,+2,+0/ !!Dlt(1920)++
      data m(259),g(259),b(259),q(259),s(259)/1.920,4,+1,+1,+0/ !!Dlt(1920)+
      data m(260),g(260),b(260),q(260),s(260)/1.920,4,+1,+0,+0/ !!Dlt(1920)0
      data m(261),g(261),b(261),q(261),s(261)/1.920,4,+1,-1,+0/ !!Dlt(1920)- 
      data m(262),g(262),b(262),q(262),s(262)/1.920,4,-1,-2,+0/ !!Dlt(1920)++br
      data m(263),g(263),b(263),q(263),s(263)/1.920,4,-1,-1,+0/ !!Dlt(1920)+ br
      data m(264),g(264),b(264),q(264),s(264)/1.920,4,-1,-0,+0/ !!Dlt(1920)0 br
      data m(265),g(265),b(265),q(265),s(265)/1.920,4,-1,+1,+0/ !!Dlt(1920)- br
      
      data m(266),g(266),b(266),q(266),s(266)/1.930,6,+1,+2,+0/ !!Dlt(1930)++
      data m(267),g(267),b(267),q(267),s(267)/1.930,6,+1,+1,+0/ !!Dlt(1930)+
      data m(268),g(268),b(268),q(268),s(268)/1.930,6,+1,+0,+0/ !!Dlt(1930)0
      data m(269),g(269),b(269),q(269),s(269)/1.930,6,+1,-1,+0/ !!Dlt(1930)- 
      data m(270),g(270),b(270),q(270),s(270)/1.930,6,-1,-2,+0/ !!Dlt(1930)++br
      data m(271),g(271),b(271),q(271),s(271)/1.930,6,-1,-1,+0/ !!Dlt(1930)+ br
      data m(272),g(272),b(272),q(272),s(272)/1.930,6,-1,-0,+0/ !!Dlt(1930)0 br
      data m(273),g(273),b(273),q(273),s(273)/1.930,6,-1,+1,+0/ !!Dlt(1930)- br
      
      data m(274),g(274),b(274),q(274),s(274)/1.950,8,+1,+2,+0/ !!Dlt(1950)++
      data m(275),g(275),b(275),q(275),s(275)/1.950,8,+1,+1,+0/ !!Dlt(1950)+
      data m(276),g(276),b(276),q(276),s(276)/1.950,8,+1,+0,+0/ !!Dlt(1950)0
      data m(277),g(277),b(277),q(277),s(277)/1.950,8,+1,-1,+0/ !!Dlt(1950)- 
      data m(278),g(278),b(278),q(278),s(278)/1.950,8,-1,-2,+0/ !!Dlt(1950)++br
      data m(279),g(279),b(279),q(279),s(279)/1.950,8,-1,-1,+0/ !!Dlt(1950)+ br
      data m(280),g(280),b(280),q(280),s(280)/1.950,8,-1,-0,+0/ !!Dlt(1950)0 br
      data m(281),g(281),b(281),q(281),s(281)/1.950,8,-1,+1,+0/ !!Dlt(1950)- br

      data m(282),g(282),b(282),q(282),s(282)/2.420,12,+1,+2,+0/!!Dlt(2420)++
      data m(283),g(283),b(283),q(283),s(283)/2.420,12,+1,+1,+0/!!Dlt(2420)+
      data m(284),g(284),b(284),q(284),s(284)/2.420,12,+1,+0,+0/!!Dlt(2420)0
      data m(285),g(285),b(285),q(285),s(285)/2.420,12,+1,-1,+0/!!Dlt(2420)- 
      data m(286),g(286),b(286),q(286),s(286)/2.420,12,-1,-2,+0/!!Dlt(2420)++br
      data m(287),g(287),b(287),q(287),s(287)/2.420,12,-1,-1,+0/!!Dlt(2420)+ br
      data m(288),g(288),b(288),q(288),s(288)/2.420,12,-1,-0,+0/!!Dlt(2420)0 br
      data m(289),g(289),b(289),q(289),s(289)/2.420,12,-1,+1,+0/!!Dlt(2420)- br

      data m(290),g(290),b(290),q(290),s(290)/0.000,0,+0,+0,+0/ !! ----- 
      data m(291),g(291),b(291),q(291),s(291)/0.000,0,+0,+0,+0/ !! ----- 
      data m(292),g(292),b(292),q(292),s(292)/0.000,0,+0,+0,+0/ !! ----- 
      data m(293),g(293),b(293),q(293),s(293)/0.000,0,+0,+0,+0/ !! ----- 
      data m(294),g(294),b(294),q(294),s(294)/0.000,0,+0,+0,+0/ !! ----- 
      data m(295),g(295),b(295),q(295),s(295)/0.000,0,+0,+0,+0/ !! ----- 
      data m(296),g(296),b(296),q(296),s(296)/0.000,0,+0,+0,+0/ !! ----- 
      data m(297),g(297),b(297),q(297),s(297)/0.000,0,+0,+0,+0/ !! ----- 
      data m(298),g(298),b(298),q(298),s(298)/0.000,0,+0,+0,+0/ !! ----- 
      data m(299),g(299),b(299),q(299),s(299)/0.000,0,+0,+0,+0/ !! ----- 
      
CCC   Lambda baryons (S=-1, I= 0)
ccc   -------------------------------------   mass, g, B, Q, S          
      data m(300),g(300),b(300),q(300),s(300)/1.116,2,+1,+0,-1/ !!Lmd 
      data m(301),g(301),b(301),q(301),s(301)/1.116,2,-1,-0,+1/ !!Lmd br

      data m(302),g(302),b(302),q(302),s(302)/1.406,2,+1,+0,-1/ !!Lmd(1405) 
      data m(303),g(303),b(303),q(303),s(303)/1.406,2,-1,-0,+1/ !!Lmd(1405)or

      data m(304),g(304),b(304),q(304),s(304)/1.520,4,+1,+0,-1/ !!Lmd(1520) 
      data m(305),g(305),b(305),q(305),s(305)/1.520,4,-1,-0,+1/ !!Lmd(1520)br

      data m(306),g(306),b(306),q(306),s(306)/1.600,2,+1,+0,-1/ !!Lmd(1600) 
      data m(307),g(307),b(307),q(307),s(307)/1.600,2,-1,-0,+1/ !!Lmd(1600)br

      data m(308),g(308),b(308),q(308),s(308)/1.670,2,+1,+0,-1/ !!Lmd(1670) 
      data m(309),g(309),b(309),q(309),s(309)/1.670,2,-1,-0,+1/ !!Lmd(1670)br

      data m(310),g(310),b(310),q(310),s(310)/1.690,4,+1,+0,-1/ !!Lmd(1690) 
      data m(311),g(311),b(311),q(311),s(311)/1.690,4,-1,-0,+1/ !!Lmd(1690)br

      data m(312),g(312),b(312),q(312),s(312)/1.800,2,+1,+0,-1/ !!Lmd(1800) 
      data m(313),g(313),b(313),q(313),s(313)/1.800,2,-1,-0,+1/ !!Lmd(1800)br

      data m(314),g(314),b(314),q(314),s(314)/1.810,2,+1,+0,-1/ !!Lmd(1810) 
      data m(315),g(315),b(315),q(315),s(315)/1.810,2,-1,-0,+1/ !!Lmd(1810)br

      data m(316),g(316),b(316),q(316),s(316)/1.820,6,+1,+0,-1/ !!Lmd(1820) 
      data m(317),g(317),b(317),q(317),s(317)/1.820,6,-1,-0,+1/ !!Lmd(1820)br

      data m(318),g(318),b(318),q(318),s(318)/1.830,6,+1,+0,-1/ !!Lmd(1830) 
      data m(319),g(319),b(319),q(319),s(319)/1.830,6,-1,-0,+1/ !!Lmd(1830)br

      data m(320),g(320),b(320),q(320),s(320)/1.890,4,+1,+0,-1/ !!Lmd(1890) 
      data m(321),g(321),b(321),q(321),s(321)/1.890,4,-1,-0,+1/ !!Lmd(1890)br

      data m(322),g(322),b(322),q(322),s(322)/2.100,8,+1,+0,-1/ !!Lmd(2100) 
      data m(323),g(323),b(323),q(323),s(323)/2.100,8,-1,-0,+1/ !!Lmd(2100)br

      data m(324),g(324),b(324),q(324),s(324)/2.110,6,+1,+0,-1/ !!Lmd(2110) 
      data m(325),g(325),b(325),q(325),s(325)/2.110,6,-1,-0,+1/ !!Lmd(2110)br

      data m(326),g(326),b(326),q(326),s(326)/2.350,10,+1,+0,-1/!!Lmd(2350) 
      data m(327),g(327),b(327),q(327),s(327)/2.350,10,-1,-0,+1/!!Lmd(2350)br

      data m(328),g(328),b(328),q(328),s(328)/0.000,0,+0,+0,+0/ !! ----- 
      data m(329),g(329),b(329),q(329),s(329)/0.000,0,+0,+0,+0/ !! ----- 
ccc   ------------------------------------------------------------------
      
CCC   Sigma baryons (S=-1, I= 1)
ccc   -------------------------------------   mass, g, B, Q, S
      data m(330),g(330),b(330),q(330),s(330)/1.189,2,+1,+1,-1/ !!Sgm+
      data m(331),g(331),b(331),q(331),s(331)/1.193,2,+1,+0,-1/ !!Sgm0
      data m(332),g(332),b(332),q(332),s(332)/1.197,2,+1,-1,-1/ !!Sgm-
      data m(333),g(333),b(333),q(333),s(333)/1.189,2,-1,-1,+1/ !!Sgm+br
      data m(334),g(334),b(334),q(334),s(334)/1.193,2,-1,-0,+1/ !!Sgm0br
      data m(335),g(335),b(335),q(335),s(335)/1.197,2,-1,+1,+1/ !!Sgm-br
      
      data m(336),g(336),b(336),q(336),s(336)/1.383,4,+1,+1,-1/ !!Sgm(1385)+
      data m(337),g(337),b(337),q(337),s(337)/1.384,4,+1,+0,-1/ !!Sgm(1385)0
      data m(338),g(338),b(338),q(338),s(338)/1.387,4,+1,-1,-1/ !!Sgm(1385)-
      data m(339),g(339),b(339),q(339),s(339)/1.383,4,-1,-1,+1/ !!Sgm(1385)+br
      data m(340),g(340),b(340),q(340),s(340)/1.384,4,-1,-0,+1/ !!Sgm(1385)0br
      data m(341),g(341),b(341),q(341),s(341)/1.387,4,-1,+1,+1/ !!Sgm(1385)-br
      
      data m(342),g(342),b(342),q(342),s(342)/1.660,2,+1,+1,-1/ !!Sgm(1660)+
      data m(343),g(343),b(343),q(343),s(343)/1.660,2,+1,+0,-1/ !!Sgm(1660)0
      data m(344),g(344),b(344),q(344),s(344)/1.660,2,+1,-1,-1/ !!Sgm(1660)-
      data m(345),g(345),b(345),q(345),s(345)/1.660,2,-1,-1,+1/ !!Sgm(1660)+br
      data m(346),g(346),b(346),q(346),s(346)/1.660,2,-1,-0,+1/ !!Sgm(1660)0br
      data m(347),g(347),b(347),q(347),s(347)/1.660,2,-1,+1,+1/ !!Sgm(1660)-br
      
      data m(348),g(348),b(348),q(348),s(348)/1.670,4,+1,+1,-1/ !!Sgm(1670)+
      data m(349),g(349),b(349),q(349),s(349)/1.670,4,+1,+0,-1/ !!Sgm(1670)0
      data m(350),g(350),b(350),q(350),s(350)/1.670,4,+1,-1,-1/ !!Sgm(1670)-
      data m(351),g(351),b(351),q(351),s(351)/1.670,4,-1,-1,+1/ !!Sgm(1670)+br
      data m(352),g(352),b(352),q(352),s(352)/1.670,4,-1,-0,+1/ !!Sgm(1670)0br
      data m(353),g(353),b(353),q(353),s(353)/1.670,4,-1,+1,+1/ !!Sgm(1670)-br
      
      data m(354),g(354),b(354),q(354),s(354)/1.750,2,+1,+1,-1/ !!Sgm(1750)+
      data m(355),g(355),b(355),q(355),s(355)/1.750,2,+1,+0,-1/ !!Sgm(1750)0
      data m(356),g(356),b(356),q(356),s(356)/1.750,2,+1,-1,-1/ !!Sgm(1750)-
      data m(357),g(357),b(357),q(357),s(357)/1.750,2,-1,-1,+1/ !!Sgm(1750)+br
      data m(358),g(358),b(358),q(358),s(358)/1.750,2,-1,-0,+1/ !!Sgm(1750)0br
      data m(359),g(359),b(359),q(359),s(359)/1.750,2,-1,+1,+1/ !!Sgm(1750)-br
      
      data m(360),g(360),b(360),q(360),s(360)/1.775,6,+1,+1,-1/ !!Sgm(1775)+
      data m(361),g(361),b(361),q(361),s(361)/1.775,6,+1,+0,-1/ !!Sgm(1775)0
      data m(362),g(362),b(362),q(362),s(362)/1.775,6,+1,-1,-1/ !!Sgm(1775)-
      data m(363),g(363),b(363),q(363),s(363)/1.775,6,-1,-1,+1/ !!Sgm(1775)+br
      data m(364),g(364),b(364),q(364),s(364)/1.775,6,-1,-0,+1/ !!Sgm(1775)0br
      data m(365),g(365),b(365),q(365),s(365)/1.775,6,-1,+1,+1/ !!Sgm(1775)-br

      data m(366),g(366),b(366),q(366),s(366)/1.915,6,+1,+1,-1/ !!Sgm(1915)+
      data m(367),g(367),b(367),q(367),s(367)/1.915,6,+1,+0,-1/ !!Sgm(1915)0
      data m(368),g(368),b(368),q(368),s(368)/1.915,6,+1,-1,-1/ !!Sgm(1915)-
      data m(369),g(369),b(369),q(369),s(369)/1.915,6,-1,-1,+1/ !!Sgm(1915)+br
      data m(370),g(370),b(370),q(370),s(370)/1.915,6,-1,-0,+1/ !!Sgm(1915)0br
      data m(371),g(371),b(371),q(371),s(371)/1.915,6,-1,+1,+1/ !!Sgm(1915)-br

      data m(372),g(372),b(372),q(372),s(372)/1.940,4,+1,+1,-1/ !!Sgm(1940)+
      data m(373),g(373),b(373),q(373),s(373)/1.940,4,+1,+0,-1/ !!Sgm(1940)0
      data m(374),g(374),b(374),q(374),s(374)/1.940,4,+1,-1,-1/ !!Sgm(1940)-
      data m(375),g(375),b(375),q(375),s(375)/1.940,4,-1,-1,+1/ !!Sgm(1940)+br
      data m(376),g(376),b(376),q(376),s(376)/1.940,4,-1,-0,+1/ !!Sgm(1940)0br
      data m(377),g(377),b(377),q(377),s(377)/1.940,4,-1,+1,+1/ !!Sgm(1940)-br

      data m(378),g(378),b(378),q(378),s(378)/2.030,8,+1,+1,-1/ !!Sgm(2030)+
      data m(379),g(379),b(379),q(379),s(379)/2.030,8,+1,+0,-1/ !!Sgm(2030)0
      data m(380),g(380),b(380),q(380),s(380)/2.030,8,+1,-1,-1/ !!Sgm(2030)-
      data m(381),g(381),b(381),q(381),s(381)/2.030,8,-1,-1,+1/ !!Sgm(2030)+br
      data m(382),g(382),b(382),q(382),s(382)/2.030,8,-1,-0,+1/ !!Sgm(2030)0br
      data m(383),g(383),b(383),q(383),s(383)/2.030,8,-1,+1,+1/ !!Sgm(2030)-br

      data m(384),g(384),b(384),q(384),s(384)/0.000,0,+0,+0,+0/ !! -----
      data m(385),g(385),b(385),q(385),s(385)/0.000,0,+0,+0,+0/ !! -----
      data m(386),g(386),b(386),q(386),s(386)/0.000,0,+0,+0,+0/ !! -----
      data m(387),g(387),b(387),q(387),s(387)/0.000,0,+0,+0,+0/ !! -----
      data m(388),g(388),b(388),q(388),s(388)/0.000,0,+0,+0,+0/ !! -----
      data m(389),g(389),b(389),q(389),s(389)/0.000,0,+0,+0,+0/ !! -----

CCC   Xsi baryons (S=-2, I= 1/2)
ccc   -------------------------------------   mass, g, B, Q, S

      data m(390),g(390),b(390),q(390),s(390)/1.315,2,+1,+0,-2/ !!Xs0
      data m(391),g(391),b(391),q(391),s(391)/1.321,2,+1,-1,-2/ !!Xs-  
      data m(392),g(392),b(392),q(392),s(392)/1.315,2,-1,-0,+2/ !!Xs0 br
      data m(393),g(393),b(393),q(393),s(393)/1.321,2,-1,+1,+2/ !!Xs- br

      data m(394),g(394),b(394),q(394),s(394)/1.532,4,+1,+0,-2/ !!Xs(1530)0 
      data m(395),g(395),b(395),q(395),s(395)/1.535,4,+1,-1,-2/ !!Xs(1530)- 
      data m(396),g(396),b(396),q(396),s(396)/1.532,4,-1,-0,+2/ !!Xs(1530)0 br
      data m(397),g(397),b(397),q(397),s(397)/1.535,4,-1,+1,+2/ !!Xs(1530)- br

      data m(398),g(398),b(398),q(398),s(398)/1.823,4,+1,+0,-2/ !!Xs(1820)0 
      data m(399),g(399),b(399),q(399),s(399)/1.823,4,+1,-1,-2/ !!Xs(1820)- 
      data m(400),g(400),b(400),q(400),s(400)/1.823,4,-1,-0,+2/ !!Xs(1820)0 br
      data m(401),g(401),b(401),q(401),s(401)/1.823,4,-1,+1,+2/ !!Xs(1820)- br

      data m(402),g(402),b(402),q(402),s(402)/0.000,0,+0,+0,+0/ !! ----- 
      data m(403),g(403),b(403),q(403),s(403)/0.000,0,+0,+0,+0/ !! ----- 
      data m(404),g(404),b(404),q(404),s(404)/0.000,0,+0,+0,+0/ !! ----- 
      data m(405),g(405),b(405),q(405),s(405)/0.000,0,+0,+0,+0/ !! ----- 
      data m(406),g(406),b(406),q(406),s(406)/0.000,0,+0,+0,+0/ !! ----- 
      data m(407),g(407),b(407),q(407),s(407)/0.000,0,+0,+0,+0/ !! ----- 
      data m(408),g(408),b(408),q(408),s(408)/0.000,0,+0,+0,+0/ !! ----- 
      data m(409),g(409),b(409),q(409),s(409)/0.000,0,+0,+0,+0/ !! ----- 

CCC   Omega baryons (S=-3, I= 0)
ccc   -------------------------------------   mass, g, B, Q, S
      data m(410),g(410),b(410),q(410),s(410)/1.672,4,+1,-1,-3/ !!Omega
      data m(411),g(411),b(411),q(411),s(411)/1.672,4,-1,+1,+3/ !!Omega br
      data m(412),g(412),b(412),q(412),s(412)/0.000,0,+0,+0,+0/ !! ----- 
      data m(413),g(413),b(413),q(413),s(413)/0.000,0,+0,+0,+0/ !! ----- 
      data m(414),g(414),b(414),q(414),s(414)/0.000,0,+0,+0,+0/ !! ----- 
      data m(415),g(415),b(415),q(415),s(415)/0.000,0,+0,+0,+0/ !! ----- 
      data m(416),g(416),b(416),q(416),s(416)/0.000,0,+0,+0,+0/ !! ----- 
      data m(417),g(417),b(417),q(417),s(417)/0.000,0,+0,+0,+0/ !! ----- 
      data m(418),g(418),b(418),q(418),s(418)/0.000,0,+0,+0,+0/ !! ----- 
      data m(419),g(419),b(419),q(419),s(419)/0.000,0,+0,+0,+0/ !! ----- 
      data m(420),g(420),b(420),q(420),s(420)/0.000,0,+0,+0,+0/ !! -----
      data m(421),g(421),b(421),q(421),s(421)/0.000,0,+0,+0,+0/ !! ----- 
      data m(422),g(422),b(422),q(422),s(422)/0.000,0,+0,+0,+0/ !! ----- 
      data m(423),g(423),b(423),q(423),s(423)/0.000,0,+0,+0,+0/ !! ----- 
      data m(424),g(424),b(424),q(424),s(424)/0.000,0,+0,+0,+0/ !! ----- 
      data m(425),g(425),b(425),q(425),s(425)/0.000,0,+0,+0,+0/ !! ----- 
      data m(426),g(426),b(426),q(426),s(426)/0.000,0,+0,+0,+0/ !! ----- 
      data m(427),g(427),b(427),q(427),s(427)/0.000,0,+0,+0,+0/ !! ----- 
      data m(428),g(428),b(428),q(428),s(428)/0.000,0,+0,+0,+0/ !! ----- 
      data m(429),g(429),b(429),q(429),s(429)/0.000,0,+0,+0,+0/ !! ----- 
      data m(430),g(430),b(430),q(430),s(430)/0.000,0,+0,+0,+0/ !! -----
      data m(431),g(431),b(431),q(431),s(431)/0.000,0,+0,+0,+0/ !! -----
      data m(432),g(432),b(432),q(432),s(432)/0.000,0,+0,+0,+0/ !! ----- 
      data m(433),g(433),b(433),q(433),s(433)/0.000,0,+0,+0,+0/ !! ----- 
      data m(434),g(434),b(434),q(434),s(434)/0.000,0,+0,+0,+0/ !! ----- 
      data m(435),g(435),b(435),q(435),s(435)/0.000,0,+0,+0,+0/ !! ----- 
      data m(436),g(436),b(436),q(436),s(436)/0.000,0,+0,+0,+0/ !! ----- 
      data m(437),g(437),b(437),q(437),s(437)/0.000,0,+0,+0,+0/ !! ----- 
      data m(438),g(438),b(438),q(438),s(438)/0.000,0,+0,+0,+0/ !! ----- 
      data m(439),g(439),b(439),q(439),s(439)/0.000,0,+0,+0,+0/ !! -----
      data m(440),g(440),b(440),q(440),s(440)/0.000,0,+0,+0,+0/ !! -----
      data m(441),g(441),b(441),q(441),s(441)/0.000,0,+0,+0,+0/ !! -----
      data m(442),g(442),b(442),q(442),s(442)/0.000,0,+0,+0,+0/ !! ----- 
      data m(443),g(443),b(443),q(443),s(443)/0.000,0,+0,+0,+0/ !! ----- 
      data m(444),g(444),b(444),q(444),s(444)/0.000,0,+0,+0,+0/ !! ----- 
      data m(445),g(445),b(445),q(445),s(445)/0.000,0,+0,+0,+0/ !! ----- 
      data m(446),g(446),b(446),q(446),s(446)/0.000,0,+0,+0,+0/ !! ----- 
      data m(447),g(447),b(447),q(447),s(447)/0.000,0,+0,+0,+0/ !! ----- 
      data m(448),g(448),b(448),q(448),s(448)/0.000,0,+0,+0,+0/ !! ----- 
      data m(449),g(449),b(449),q(449),s(449)/0.000,0,+0,+0,+0/ !! -----
CCC   ###################################################################### 
CCC   Quarks and Gluons 
ccc   ------------------------                 mass, g, B, Q, S 
      data m(450),g(450),b(450),q(450),s(450)/0.000,16,+0,+0,+0/ !! gluon
      data m(451),g(451),b(451),q(451),s(451)/0.000, 6,+1,+2,-0/ !! u 
      data m(452),g(452),b(452),q(452),s(452)/0.000, 6,-1,-2,+0/ !! u br
      data m(453),g(453),b(453),q(453),s(453)/0.000, 6,+1,-1,-0/ !! d
      data m(454),g(454),b(454),q(454),s(454)/0.000, 6,-1,+1,+0/ !! d br 
      data m(455),g(455),b(455),q(455),s(455)/0.000, 6,+1,-1,-1/ !! s
      data m(456),g(456),b(456),q(456),s(456)/0.000, 6,-1,+1,+1/ !! s br
      data m(457),g(457),b(457),q(457),s(457)/0.000,0,+0,+0,+0/ !! ----- 
      data m(458),g(458),b(458),q(458),s(458)/0.000,0,+0,+0,+0/ !! ----- 
      data m(459),g(459),b(459),q(459),s(459)/0.000,0,+0,+0,+0/ !! -----
      data m(460),g(460),b(460),q(460),s(460)/0.000,0,+0,+0,+0/ !! -----
CCC   ###################################################################### 
      return 
      end 



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@




CCC   #######################################################################
CCC   SPheRIO resonace data pd.f 
CCC   Light Unflavored mesons(S= C= B= 0)     ID=   1  ->   64 (64)
CCC   Strange meson     (S=+/-1, C= B= 0)     ID=  70  ->  117 (48)
CCC   Charmed mesons             (C=+/-1)     ID= 120  ->  133 (14)
CCC   Charmed strange mesons (C= S= +/-1)     ID= 140  ->  141 ( 2)
CCC   N baryons            (S= 0, I= 1/2)     ID= 150  ->  201 (52)
CCC   Delta baryons        (S= 0, I= 3/2)     ID= 210  ->  289 (80)
CCC   Lambda baryons         (S=-1, I= 0)     ID= 300  ->  327 (28)
CCC   Sigma baryons          (S=-1, I= 1)     ID= 330  ->  383 (54)
CCC   Xsi baryons          (S=-2, I= 1/2)     ID= 390  ->  401 (12)
CCC   Omega baryons          (S=-3, I= 0)     ID= 410  ->  411 ( 2) total 356
CCC   Quarks and Gluons                       ID= 450  ->  456      Nf=3 
CCC                      for Quarks and Gluons, b,q,s need to divided by 3 
CCC   #######################################################################
CCC   last updated 04282010
CCC   modified to avoid g77 compile error
CCC
CCC   last updated 05152006
CCC   include 'spherio.const.inc'
CCC   deleted some unnecessary blanks
CCC   #######################################################################
      SUBROUTINE pdtable_m0()
      IMPLICIT NONE 

      include 'spherio.const.inc'
      DOUBLE PRECISION m
      INTEGER g,b,q,s 
      
      COMMON/prtclms/ m(1000)
      COMMON/quantum/ g(1000),b(1000),q(1000),s(1000) 
CCC   ######################################################################

CCC   Light Unflavored mesons(S= C= B= 0) 
CCC   //////////////////////////////////////////////////////////////////////
ccc   ------------------------      mass, g, B, Q, S 
c      data m(1),g(1),b(1),q(1),s(1)/0.d0,1,+0,+1,+0/ !! pi+ 
c      data m(2),g(2),b(2),q(2),s(2)/0.d0,1,+0,+0,+0/ !! pi0  
c      data m(3),g(3),b(3),q(3),s(3)/0.d0,1,+0,-1,+0/ !! pi-   
      m(1)=0.d0
      g(1)=1
      b(1)=0
      q(1)=1
      s(1)=0
      m(2)=0.d0
      g(2)=1
      b(2)=0
      q(2)=0
      s(2)=0
      m(3)=0.d0
      g(3)=1
      b(3)=0
      q(3)=-1
      s(3)=0
         
      return 
      end 

CCC   #################################################################
CCC   phsjdg1()
CCC   decide in which phase the current state locates
CCC   #################################################################
CCC   last updated 06122007
CCC   incorporate ieosmode
CCC
CCC   last updated 03272007
CCC   router
CCC   #################################################################
      subroutine phsjdg1(edgvn,ndgvn,phsflg)
      implicit none
      include 'spherio.eos.inc'
      double precision edgvn,ndgvn
      integer phsflg

      select case (ieosmode)
      case (1)
         call phsjdg1_original(edgvn,ndgvn,phsflg)
      case (2)
         call phsjdg1dbg(edgvn,ndgvn,phsflg)
      case (3)
         stop 'phsjdg not implemented yet'
      case (4,9)
         phsflg=0                 !hadron phase
      case (7)
         call phsjdg1_crossover(edgvn,ndgvn,phsflg)
      case (8)
         stop 'phsjdg not implemented yet'
      case (99)
         call phsjdg1_override(edgvn,ndgvn,phsflg)
      case default
         stop 'ieosmode fatal error in phsjdg1'
      end select

      eos(1)=1.d0                 !!dummy assingnment

      return
      stop
      end


CCC   #################################################################
CCC   phsjdg2()
CCC   decide in which phase the current state locates
CCC   #################################################################
CCC   last updated 06122007
CCC   incorporate ieosmode
CCC
CCC   last updated 03272007
CCC   router
CCC   #################################################################
      SUBROUTINE phsjdg2(sdgvn,ndgvn,phsflg)
      IMPLICIT NONE
      include 'spherio.eos.inc'
      DOUBLE PRECISION sdgvn,ndgvn
      INTEGER phsflg

      select case (ieosmode)
      case (1)
         call phsjdg2_original(sdgvn,ndgvn,phsflg)
      case (2)
         call phsjdg2dbg(sdgvn,ndgvn,phsflg)
      case (3)
         stop 'phsjdg not implemented yet'
      case (4,9)
         phsflg=0                !hadron phase
      case (7)
          call phsjdg2_crossover(sdgvn,ndgvn,phsflg)
      case (8)
         stop 'phsjdg not implemented yet'
      case (99)
         call phsjdg2_override(sdgvn,ndgvn,phsflg)
      case default
         stop 'ieosmode fatal error in phsjdg2'
      end select

      eos(1)=1.d0                 !!dummy assingnment

      return
      stop
      END 
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################

CCC   #################################################################
CCC   phsjdg1dbg()
CCC   decide in which phase the current state locates
CCC   #################################################################
CCC   last updated at 08122006
CCC   inherited and modified from phsjdg1()
CCC   #################################################################
      subroutine phsjdg1dbg(edgvn,ndgvn,phsflg)
      implicit none
      include 'spherio.bdy.inc'
      include 'spherio.bdy0.inc'
      double precision edgvn,ndgvn
      integer phsflg
      double precision x0,x1,y0,y1,pp,yy,andgvn
      integer mm

      andgvn = abs(ndgvn)

      if(andgvn.ge.bdybbmax)then
         call locate1(bdybbdstqgp0,ittx0,andgvn,mm)
c         if(mm.ge.ittx0)then
c            print*,'---->',ndgvn,bdybbdstqgp(ittx)
c            stop  '555 - out of range'
c         endif
         if(mm.eq.ittx0) mm=ittx0-1
         if(mm.eq.0) mm=1
         x0=bdybbdstqgp0(mm)
         x1=bdybbdstqgp0(mm+1)
         y0=bdyeedstqgp0(mm)
         y1=bdyeedstqgp0(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
            phsflg=2   !!  plasma
         else 
            phsflg=-1  !!  out, plasma but energy less than zero boundary
         endif
         return
      endif

      if(andgvn.ge.bdybbdsthrg(ittx))then
         call locate1(bdybbdstqgp,ittx,andgvn,mm)
         if(mm.eq.ittx) then
!	       write(*,*)'andgvn,bdybbdstqgp(ittx),mm',
!     &                  andgvn,bdybbdstqgp(ittx),mm
             stop '456 - out of range'
         end if
         x0=bdybbdstqgp(mm)
         x1=bdybbdstqgp(mm+1)
         y0=bdyeedstqgp(mm)
         y1=bdyeedstqgp(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
            phsflg=2    !! plasma
         else
            x0=bdybbdsthrg(ittx)
            x1=bdybbdstqgp(ittx)
            y0=bdyeedsthrg(ittx)
            y1=bdyeedstqgp(ittx)
            pp=(andgvn-x0)/(x1-x0)
            yy=(1.d0-pp)*y0+pp*y1
            if(edgvn.ge.yy)then
               phsflg=1  !! mixed
            else 
               phsflg=-1 !! out, mixed but energy less then the line connectioning two mixed boundaries
            endif
         endif
      else
         call locate1(bdybbdstqgp,ittx,andgvn,mm)
         if(mm.eq.0) mm=1
         x0=bdybbdstqgp(mm)
         x1=bdybbdstqgp(mm+1)
         y0=bdyeedstqgp(mm)
         y1=bdyeedstqgp(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
             phsflg=2       !! plasma
             return
         endif
         call locate1(bdybbdsthrg,ittx,andgvn,mm)
         if(mm.eq.ittx)stop '457 - out of range'
         if(mm.eq.0) mm=1
         x0=bdybbdsthrg(mm)
         x1=bdybbdsthrg(mm+1)
         y0=bdyeedsthrg(mm)
         y1=bdyeedsthrg(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
             phsflg=1       !! mixed
             return
         endif                  
         call locate1(bdybbdsthrg0,ittx0,andgvn,mm)
         if(mm.eq.ittx0)stop '458 - out of range'
         if(mm.eq.0) mm=1
         x0=bdybbdsthrg0(mm)
         x1=bdybbdsthrg0(mm+1)
         y0=bdyeedsthrg0(mm)
         y1=bdyeedsthrg0(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
             phsflg=0       !! hadrons
         else
             phsflg=-1      !! out
         endif
      endif

      return
      stop
      end


CCC   #################################################################
CCC   phsjdg2dbg()
CCC   decide in which phase the current state locates
CCC   #################################################################
CCC   last updated at 08102006
CCC   inherited and modified from phsjdg2()
CCC   #################################################################
      SUBROUTINE phsjdg2dbg(sdgvn,ndgvn,phsflg)
      IMPLICIT NONE
      include 'spherio.const.inc'
      include 'spherio.bdy.inc'
      include 'spherio.debug.inc'

      INTEGER mm,mm1,mm2,phsflg
      DOUBLE PRECISION nqmax,nrmax
      DOUBLE PRECISION sdgvn,ndgvn
CCC   #####################################################
      nqmax=bdybbmax
      nrmax=bdybbdsthrg(ittx)
      
CCC   QGP phase //////////////////////////////////////////////////
      if(abs(ndgvn).gt.nqmax) then 
         phsflg=2					!!qgp
         return
      else if(abs(ndgvn).gt.nrmax) then 
CCC   QGP or mixed phase /////////////////////////////////////////
c     mixed phase or qgp
         call locate1(bdybbdstqgp,ittx,abs(ndgvn),mm)
         if(sdgvn.gt.bdytpdstqgp(mm)) then
            phsflg=2				!!qgp
         else
            phsflg=1				!!mixed
         end if
         return
      else
CCC   QGP or mixed or RG ////////////////////////////////////////
c     mixed phase or RG or QGP 
         call locate1(bdybbdstqgp,ittx,abs(ndgvn),mm1)
         call locate1(bdybbdsthrg,ittx,abs(ndgvn),mm2)
c... ?!
         IF(mm1.eq.0)mm1=1
         IF(mm2.eq.0)mm2=1
c...
         if(sdgvn.gt.bdytpdstqgp(mm1)) then
            phsflg=2				!!qgp
         else if(sdgvn.gt.bdytpdsthrg(mm2)) then 
            phsflg=1				!!mixed
         else
            phsflg=0				!!hadron
         end if
         return
      end if
CCC   #################################################################
      return
      stop
      END 
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################
CCC   #################################################################

CCC   #################################################################
CCC   phsjdgtrials()
CCC   test the phsjdg subroutines
CCC   #################################################################
CCC   last updated 10092007
CCC   add more test
CCC
CCC   last updated 05122007
CCC   fixed a bug concerning bugflg
CCC
CCC   last updated 08102006
CCC   #################################################################
      subroutine phsjdgtrials()
      implicit none
      include 'spherio.debug.inc'
      include 'epos.incsf'
      double precision edgvn,sdgvn,ndgvn
      integer phsflg

cxx   an implementation to plot an EOS curve is strongly recommended here!!

      if (iauxi.ge.5) then
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a)')'from phsjdgtrials'
      WRITE(70,'(a)')'phsjdgtrials() invoking...'
      CLOSE(70)
      edgvn=0.5d0
      ndgvn=0.5d0
      call phsjdg1(edgvn,ndgvn,phsflg)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a)')'from phsjdg1dbg'
      WRITE(70,'(a,2d30.20,i3)')'edgvn,ndgvn,phsflg=',edgvn,ndgvn,phsflg
      CLOSE(70)

      sdgvn=0.26208826072327606749d0
      ndgvn=0.d0
      call phsjdg2(sdgvn,ndgvn,phsflg)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a)')'from phsjdg2dbg'
      WRITE(70,'(a,2d30.20,i3)')'sdgvn,ndgvn,phsflg=',sdgvn,ndgvn,phsflg
      CLOSE(70)

      sdgvn=0.d0
      ndgvn=0.d0
      call phsjdg2(sdgvn,ndgvn,phsflg)
      OPEN(70,FILE=fneoe(1:nfneoe),access='append')
      WRITE(70,'(a)') ' '
      WRITE(70,'(a)')'from phsjdg2dbg'
      WRITE(70,'(a,2d30.20,i3)')'sdgvn,ndgvn,phsflg=',sdgvn,ndgvn,phsflg
      CLOSE(70)

      endif

      return
      stop
      end

CCC   #################################################################
CCC   #################################################################


CCC   #################################################################
CCC   phsjdg() for EOS with cross over phase transition
CCC   inspired by Lattice QCD data
CCC   #################################################################
CCC   last updated 05072011
CCC   adopted Otavio's version
CCC   #################################################################
      subroutine phsjdg1_crossover(edgvn,ndgvn,phsflg)
      implicit none 
      include 'spherio.crossover.inc'
      double precision edgvn,ndgvn
      integer phsflg
      integer k
      double precision p,engymn

      call locate(xnb,nnpt,ndgvn,k)
      if(k.eq.0)    k=1
      if(k.eq.nnpt) k=nnpt-1
      p=(ndgvn-xnb(k))/(xnb(k+1)-xnb(k))
      engymn=(1.-p)*yengy(k)+p*yengy(k+1)
      if(edgvn.lt.engymn)then
         phsflg = -1 !out
      else
c         phsflg = 1  !in (mixed, palsma or hadronic)
         phsflg = 0
      endif

      return
      end

      subroutine phsjdg2_crossover(sdgvn,ndgvn,phsflg)
      implicit none 
      include 'spherio.crossover.inc'
      double precision sdgvn,ndgvn
      integer phsflg
      integer k
      double precision p,entrmn

      call locate(xnb,nnpt,ndgvn,k)
      if(k.eq.0)    k = 1
      if(k.eq.nnpt) k = nnpt-1
      p=(ndgvn-xnb(k))/(xnb(k+1)-xnb(k))
      entrmn=(1.-p)*yentr(k)+p*yentr(k+1)
      if(sdgvn.lt.entrmn)then
         phsflg = -1 !out
      else
c         phsflg = 1  !in (mixed, palsma or hadronic)
         phsflg = 0
      endif

      return
      end




C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   novo subprograma para determinacao da fase
CCC   para temperatura e potencial quimico
CCC   #################################################################
CCC   last updated 09192013
CCC   built based on phsjdg original
CCC   #################################################################
      subroutine phsjdg_eos01_tmu(rtemp,rmub,phsflg)
      implicit none 
      include 'spherio.mixph.inc'
      include 'spherio.rtzer.inc'
      double precision rtemp,rmub
      integer phsflg
      integer m1,m2,k1,k2
      double precision xx(1:200),yy(1:200)
      double precision x0,x1,y0,y1,pp,yint

      do m2=1,mbinx
         xx(m2)= rgh(1,m2) !temperature
         yy(m2)= rgh(2,m2) !baryonic chemical potential
      end do
      call locate(xx,mbinx,rtemp,m2)
      if(m2.eq.0) then
         k1=1
         k2=2
         phsflg=2   !!  plasma
         return
      else if(m2.eq.mbinx) then
         k1=mbinx-1
         k2=mbinx
c         phsflg=-1   !! out (nope, not necessarily out, since this just implies a very low temperature)
      else
         k1=m2
         k2=m2+1
      end if
         x0=xx(k1)
         x1=xx(k2)
         y0=yy(k1)
         y1=yy(k2)
         pp=(rmub-x0)/(x1-x0)
         yint=(1.d0-pp)*y0+pp*y1
      if (rmub.gt.yint) then
         phsflg=2       !! plasma
      else if (rmub.lt.yint) then
         phsflg=0       !! hadrons
      else
         phsflg=1       !! mixed (not really happening)
      endif
      return
      end





CCC   #################################################################
CCC   novo subprograma para determinacao da fase
CCC   para densidade de energia e densidade barionica
CCC
CCC   last updated at 05012006
CCC   strangeness is incorporated, but only at debugging level
CCC   #################################################################
      subroutine phsjdg1_original(edgvn,ndgvn,phsflg)
      implicit none 
      include 'spherio.mixph.inc'
      include 'spherio.rtzer.inc'
      double precision edgvn,ndgvn
      integer phsflg
      double precision x0,x1,y0,y1,pp,yy,andgvn
      integer mm

      andgvn = abs(ndgvn)

      if(andgvn.ge.nq(mbinx))then
         call locate(znq,nzqmx,andgvn,mm) 
c         if(mm.ge.nzqmx)then
c            print*,'---->',ndgvn,znq(nzqmx)
c            stop  '555 - out of range'
c         endif
         if(mm.ge.nzqmx) mm=nzqmx-1
         if(mm.eq.0) mm=1
         x0=znq(mm)
         x1=znq(mm+1)
         y0=zeq(mm)
         y1=zeq(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
            phsflg=2   !!  plasma
         else 
            phsflg=-1  !!  out
         endif
         return
      endif

      if(andgvn.ge.nr(mbinx))then
         call locate(nq,mbinx,andgvn,mm)
         if(mm.gt.mbinx) then
!	      write(*,*)'andgvn,nq(mbinx),mm',andgvn,nq(mbinx),mm
            stop '556 - out of range'
         end if
         x0=nq(mm)
         x1=nq(mm+1)
         y0=eq(mm)
         y1=eq(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
            phsflg=2    !! plasma
         else
            x0=nr(mbinx)
            x1=nq(mbinx)
            y0=er(mbinx)
            y1=eq(mbinx)
            pp=(andgvn-x0)/(x1-x0)
            yy=(1.d0-pp)*y0+pp*y1
            if(edgvn.ge.yy)then
               phsflg=1  !! mixed
            else 
               phsflg=-1 !! out
            endif
         endif
      else
         call locate(nq,mbinx,andgvn,mm)
         if(mm.eq.0) mm=1
         x0=nq(mm)
         x1=nq(mm+1)
         y0=eq(mm)
         y1=eq(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
             phsflg=2       !! plasma
             return
         endif
         call locate(nr,mbinx,andgvn,mm)
         if(mm.ge.mbinx)stop '557 - out of range'
         if(mm.eq.0) mm=1
         x0=nr(mm)
         x1=nr(mm+1)
         y0=er(mm)
         y1=er(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
             phsflg=1       !! mixed
             return
         endif                  
         call locate(znr,nzrmx,andgvn,mm)
         if(mm.ge.nzrmx)stop '558 - out of range'
         if(mm.eq.0) mm=1
         x0=znr(mm)
         x1=znr(mm+1)
         y0=zer(mm)
         y1=zer(mm+1)
         pp=(andgvn-x0)/(x1-x0)
         yy=(1.d0-pp)*y0+pp*y1
         if(edgvn.ge.yy)then
             phsflg=0       !! hadrons
         else
             phsflg=-1      !! out
         endif
      endif

      return
      end





CCC   #################################################################
CCC   phase judge1.f in  SPheRIO \(^^) 
CCC   for energy density (gf=1) 
CCC
CCC   last updated at 05012006
CCC   strangeness is incorporated, but only at debugging level
CCC   #################################################################
      SUBROUTINE phsjdg1_original_obsolete(edgvn,ndgvn,phsflg)

      IMPLICIT NONE
      include 'spherio.const.inc'
      include 'spherio.mixph.inc'

      INTEGER mm,phsflg

      DOUBLE PRECISION edgvn,ndgvn,aa,bb,emixbnd 

CCC   #############################################################
CCC   QGP phase //////////////////////////////////////////////////
      if(edgvn.gt.eqmax) then 
         phsflg=2
         return 
      else if(edgvn.ge.eqmin) then 
ccc   QGP phase or mixed phase or RG phase ////////////////////////
         call locate(eq,mbinx,edgvn,mm)
         if(abs(ndgvn).lt.nq(mm)) then 
            phsflg=2
         else
            aa= (eq(mbinx)-er(mbinx))/(nq(mbinx)-nr(mbinx))
            bb= (er(mbinx)*nq(mbinx)- eq(mbinx)*nr(mbinx)) 
            bb= bb/(nq(mbinx)-nr(mbinx))
            emixbnd= aa*abs(ndgvn)+bb 
            if(edgvn.gt.emixbnd) then 
               phsflg=1
            else
               phsflg=0
            end if
         end if
      else if(edgvn.gt.ermax)then
ccc   mixed phase or RG phase ////////////////////////////////////
         aa= (eq(mbinx)-er(mbinx))/(nq(mbinx)-nr(mbinx))
         bb= (er(mbinx)*nq(mbinx)- eq(mbinx)*nr(mbinx)) 
         bb= bb/(nq(mbinx)-nr(mbinx))
         emixbnd= aa*abs(ndgvn)+bb 
         if(edgvn.gt.emixbnd) then 
            phsflg=1
         else
            phsflg=0
         end if
      else if(edgvn.gt.ermin)then
         call locate(er,mbinx,edgvn,mm)
         if(abs(ndgvn).lt.nr(mm)) then 
            phsflg=1
         else
            phsflg=0
         end if
         return
ccc   RG phase //////////////////////////////////////////////////
      else if(edgvn.lt.ermin)then
         phsflg=0
         return
      end if
CCC   ##################################################### 
      END 

CCC   #################################################################
CCC   phase judge2.f in  SPheRIO \(^^) 
CCC   for entropy density (gf=2) 
CCC
CCC   last updated at 05012006
CCC   strangeness is incorporated, but only at debugging level
CCC   #################################################################
      SUBROUTINE phsjdg2_original(sdgvn,ndgvn,phsflg)
      IMPLICIT NONE
      include 'spherio.const.inc'
      include 'spherio.mixph.inc'
      include 'spherio.debug.inc'

      INTEGER mm,mm1,mm2,phsflg
      DOUBLE PRECISION nqmax,nrmax
      DOUBLE PRECISION sdgvn,ndgvn
CCC   #####################################################
      nqmax=nq(mbinx)
      nrmax=nr(mbinx)
      
CCC   QGP phase //////////////////////////////////////////////////
      if(abs(ndgvn).gt.nqmax) then 
         phsflg=2
         return
      else if(abs(ndgvn).gt.nrmax) then 
CCC   QGP or mixed phase /////////////////////////////////////////
c     mixed phase or qgp
         call locate(nq,mbinx,abs(ndgvn),mm)
         if(sdgvn.gt.sq(mm)) then 
            phsflg=2 
         else
            phsflg=1
         end if
         return
      else
CCC   QGP or mixed or RG ////////////////////////////////////////
c     mixed phase or RG or QGP 
         call locate(nq,mbinx,abs(ndgvn),mm1)
         call locate(nr,mbinx,abs(ndgvn),mm2)
c... ?!
         IF(mm1.LE.0)mm1=1
         IF(mm2.LE.0)mm2=1
c...
         if(sdgvn.gt.sq(mm1)) then
            phsflg=2
         else if(sdgvn.gt.sr(mm2)) then 
            phsflg=1
         else
            phsflg=0
         end if
         return
      end if
CCC   ////////////////////////////////////////////////////////////
      STOP 234 
      END 



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   Novo subprograma para determinacao da fase
CCC   #################################################################
CCC   last updated 04192010
CCC   #################################################################
      subroutine phsjdg1_override(edgvn,ndgvn,phsflg)
      implicit none 
      double precision edgvn,ndgvn
      integer phsflg
      phsflg=0
      return
      end

      SUBROUTINE phsjdg2_override(sdgvn,ndgvn,phsflg)
      IMPLICIT NONE
      DOUBLE PRECISION sdgvn,ndgvn
      INTEGER phsflg
      phsflg=0
      return
      END 


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CCC   #################################################################
CCC   nxpd()
CCC   #################################################################
CCC   last updated 07072008
CCC   remove icall
CCC   #################################################################
      SUBROUTINE nxpd
      IMPLICIT NONE
      INTEGER nexpid(500),i
c      DATA icall /0/
c      SAVE icall
      COMMON/nxp/nexpid

c      IF(icall.EQ.0) THEN 

c      icall = icall + 1

      DO i=1,500
         nexpid(i)=0
      ENDDO
c****************************************
c Light unflavored mesons 
c (S = C = B =0)
c****************************************
      nexpid(1)   = +120     !PI+
      nexpid(2)   = +110     !PI0
      nexpid(3)   = -120     !PI-
      nexpid(4)   = +220     !ETA
      nexpid(5)   = +121     !RHO+
      nexpid(6)   = +111     !RHO0
      nexpid(7)   = -121     !RHO-
      nexpid(8)   = +221     !OMEG
      nexpid(9)   = +330     !ETAP
      nexpid(10)  = +332     !F0(975)
      nexpid(11)  = +122     !A+(980)
      nexpid(12)  = +112     !A0(980)
      nexpid(13)  = -122     !A-(980)
      nexpid(14)  = +331     !PHI
c****************************************
c Strange mesons 
c (S = +/- 1, C = B = 0)
c****************************************
      nexpid(70)  = +130     !K+
      nexpid(71)  = -130     !K-
      nexpid(72)  = +230     !K0
      nexpid(73)  = -230     !AK+
      nexpid(74)  = +131     !K*+
      nexpid(75)  = -131     !K*-
      nexpid(76)  = +231     !K*0
      nexpid(77)  = -231     !AK*0
c****************************************
c N baryons
c (S = 0, I = 1/2)
c****************************************
      nexpid(150) = +1120    !P
      nexpid(151) = -1120    !AP
      nexpid(152) = +1220    !N
      nexpid(153) = -1220    !AN
      nexpid(154) = +1122    !N*+(1440)
      nexpid(155) = +1222    !N*0(1440)
      nexpid(156) = -1122    !AN*+(1440)
      nexpid(157) = -1222    !AN*0(1440)
      nexpid(158) = +1123    !N*+(1530)
      nexpid(159) = +1223    !N*0(1530)
      nexpid(160) = -1123    !AN*+(1530)
      nexpid(161) = -1223    !AN*0(1530)
      nexpid(162) = +1123    !N*+(1530)
      nexpid(163) = +1223    !N*0(1530)
      nexpid(164) = -1123    !AN*+(1530)
      nexpid(165) = -1223    !AN*0(1530)
      nexpid(166) = +1125    !N*+(1665)
      nexpid(167) = +1225    !N*0(1665)
      nexpid(168) = -1125    !AN*+(1665)
      nexpid(169) = -1225    !AN*0(1665)
      nexpid(170) = +1125    !N*+(1665)
      nexpid(171) = +1225    !N*0(1665)
      nexpid(172) = -1125    !AN*+(1665)
      nexpid(173) = -1225    !AN*0(1665)
      nexpid(174) = +1125    !N*+(1665)
      nexpid(175) = +1225    !N*0(1665)
      nexpid(176) = -1125    !AN*+(1665)
      nexpid(177) = -1225    !AN*0(1665)
      nexpid(178) = +1127    !N*+(1710)
      nexpid(179) = +1227    !N*0(1710)
      nexpid(180) = -1127    !AN*+(1710)
      nexpid(181) = -1227    !AN*0(1710)
      nexpid(182) = +1127    !N*+(1710)
      nexpid(183) = +1227    !N*0(1710)
      nexpid(184) = -1127    !AN*+(1710)
      nexpid(185) = -1227    !AN*0(1710)
      nexpid(186) = +1127    !N*+(1710)
      nexpid(187) = +1227    !N*0(1710)
      nexpid(188) = -1127    !AN*+(1710)
      nexpid(189) = -1227    !AN*0(1710)
c****************************************
c Delta baryons
c (S = 0, I = 3/2)
c****************************************
      nexpid(210) = +1111    !DL++
      nexpid(211) = +1121    !DL+
      nexpid(212) = +1221    !DL0
      nexpid(213) = +2221    !DL-
      nexpid(214) = -1111    !ADL++
      nexpid(215) = -1121    !ADL+
      nexpid(216) = -1221    !ADL0
      nexpid(217) = -2221    !ADL-
      nexpid(218) = +1112    !DL++(1620)
      nexpid(219) = +1124    !DL+(1620)
      nexpid(220) = +1224    !DL0(1620)
      nexpid(221) = +2222    !DL-(1620)
      nexpid(222) = -1112    !ADL++(1620)
      nexpid(223) = -1124    !ADL+(1620)
      nexpid(224) = -1224    !ADL0(1620)
      nexpid(225) = -2222    !ADL-(1620)
      nexpid(226) = +1112    !DL++(1620)
      nexpid(227) = +1124    !DL+(1620)
      nexpid(228) = +1224    !DL0(1620)
      nexpid(229) = +2222    !DL-(1620)
      nexpid(230) = -1112    !ADL++(1620)
      nexpid(231) = -1124    !ADL+(1620)
      nexpid(232) = -1224    !ADL0(1620)
      nexpid(233) = -2222    !ADL-(1620)
      nexpid(234) = +1113    !DL++(1700)
      nexpid(235) = +1126    !DL+(1700)
      nexpid(236) = +1226    !DL0(1700)
      nexpid(237) = +2223    !DL-(1700)
      nexpid(238) = -1113    !ADL++(1700)
      nexpid(239) = -1126    !ADL+(1700)
      nexpid(240) = -1226    !ADL0(1700)
      nexpid(241) = -2223    !ADL-(1700)
c****************************************
c Lambda baryons
c (S = -1, I = 0)
c****************************************
      nexpid(300) = +2130    !L
      nexpid(301) = -2130    !AL
      nexpid(302) = +1233    !L(1405)
      nexpid(303) = -1233    !AL(1405) 
      nexpid(304) = +1234    !L(1520)
      nexpid(305) = -1234    !AL(1520)
      nexpid(306) = +1235    !L(1645)
      nexpid(307) = -1235    !AL(1645)
      nexpid(308) = +1235    !L(1645)
      nexpid(309) = -1235    !AL(1645) 
      nexpid(310) = +1235    !L(1645)
      nexpid(311) = -1235    !AL(1645) 
c****************************************
c Sigma baryons
c (S = -1, I = 1)
c****************************************
      nexpid(330) = +1130    !S+
      nexpid(331) = +1230    !S0
      nexpid(332) = +2230    !S-
      nexpid(333) = -1130    !AS+
      nexpid(334) = -1230    !AS0
      nexpid(335) = -2230    !AS-
      nexpid(336) = +1131    !S*+
      nexpid(337) = +1231    !S*0
      nexpid(338) = +2231    !S*-
      nexpid(339) = -1131    !AS*+
      nexpid(340) = -1231    !AS*0
      nexpid(341) = -2231    !AS*- 
c****************************************
c Xsi baryons
c (S = -2, I = 1/2)
c**************************************** 
      nexpid(390) = +1330    !XI0
      nexpid(391) = +2330    !XI-
      nexpid(392) = -1330    !AXI0
      nexpid(393) = -2330    !AXI-
      nexpid(394) = +1331    !XI*0
      nexpid(395) = +2331    !XI*-
      nexpid(396) = -1331    !AXI*0
      nexpid(397) = -2331    !AXI*-
c****************************************
c Omega baryons
c (S = -3, I = 0)
c****************************************
      nexpid(410) = +3331    !OM-
      nexpid(411) = -3331    !AOM-    

c      ENDIF

      RETURN 
      END




CCC   #################################################################
CCC   pythiapd()
CCC   #################################################################
CCC   last updated 09072008
CCC   #################################################################
      SUBROUTINE pythiapd
      IMPLICIT NONE
      INTEGER pythiapid(500),i
      COMMON/pythiapdtb/pythiapid

      DO i=1,500
         pythiapid(i)=0
      ENDDO

c****************************************
c Light unflavored mesons 
c (S = C = B =0)
c****************************************
      pythiapid(1) =   211   !! pi+
      pythiapid(2) =   111   !! pi0
      pythiapid(3) =  -211   !! pi-
      pythiapid(4) =   221   !! eta
      pythiapid(5) =   213   !! rho+
      pythiapid(6) =   113   !! rho0
      pythiapid(7) =  -213   !! rho-
      pythiapid(8) =   223   !! omega
      pythiapid(9) =   331   !! eta'
      pythiapid(10) =   10221  !! f0(980)
      pythiapid(11) =   10211  !! a0(980)+
      pythiapid(12) =   10111  !! a0(980)0
      pythiapid(13) =  -10211  !! a0(980)-
      pythiapid(14) =   333  !! phi(1020)
c****************************************
c Strange mesons 
c (S = +/- 1, C = B = 0)
c****************************************
      pythiapid(70)  = 321     !K+
      pythiapid(71)  =-321     !K-
      pythiapid(72)  = 311     !K0
      pythiapid(73)  =-311     !AK0
      pythiapid(74)  = 323     !K*+
      pythiapid(75)  =-323     !K*-
      pythiapid(76)  = 313     !K*0
      pythiapid(77)  =-313     !AK*0
c****************************************
c N baryons
c (S = 0, I = 1/2)
c****************************************
      pythiapid(150) = 2212    !P
      pythiapid(151) =-2212    !AP
      pythiapid(152) = 2112    !N
      pythiapid(153) =-2112    !AN
      pythiapid(154) = 4444    !N*+(1440)
      pythiapid(155) = 4444    !N*0(1440)
      pythiapid(156) = 4444    !AN*+(1440)
      pythiapid(157) = 4444    !AN*0(1440)
      pythiapid(158) = 4444    !N*+(1530)
      pythiapid(159) = 4444    !N*0(1530)
      pythiapid(160) = 4444    !AN*+(1530)
      pythiapid(161) = 4444    !AN*0(1530)
      pythiapid(162) = 4444    !N*+(1530)
      pythiapid(163) = 4444    !N*0(1530)
      pythiapid(164) = 4444    !AN*+(1530)
      pythiapid(165) = 4444    !AN*0(1530)
      pythiapid(166) = 4444    !N*+(1665)
      pythiapid(167) = 4444    !N*0(1665)
      pythiapid(168) = 4444    !AN*+(1665)
      pythiapid(169) = 4444    !AN*0(1665)
      pythiapid(170) = 4444    !N*+(1665)
      pythiapid(171) = 4444    !N*0(1665)
      pythiapid(172) = 4444    !AN*+(1665)
      pythiapid(173) = 4444    !AN*0(1665)
      pythiapid(174) = 4444    !N*+(1680)
      pythiapid(175) = 4444    !N*0(1680)
      pythiapid(176) = 4444    !AN*+(1680)
      pythiapid(177) = 4444    !AN*0(1680)
      pythiapid(178) = 4444    !N*+(1710)
      pythiapid(179) = 4444    !N*0(1710)
      pythiapid(180) = 4444    !AN*+(1710)
      pythiapid(181) = 4444    !AN*0(1710)
      pythiapid(182) = 4444    !N*+(1710)
      pythiapid(183) = 4444    !N*0(1710)
      pythiapid(184) = 4444    !AN*+(1710)
      pythiapid(185) = 4444    !AN*0(1710)
      pythiapid(186) = 4444    !N*+(1710)
      pythiapid(187) = 4444    !N*0(1710)
      pythiapid(188) = 4444    !AN*+(1710)
      pythiapid(189) = 4444    !AN*0(1710)
c****************************************
c Delta baryons
c (S = 0, I = 3/2)
c****************************************
      pythiapid(210) = 2224    !DL++
      pythiapid(211) = 2214    !DL+
      pythiapid(212) = 2114    !DL0
      pythiapid(213) = 1114    !DL-
      pythiapid(214) =-2224    !ADL++
      pythiapid(215) =-2214    !ADL+
      pythiapid(216) =-2114    !ADL0
      pythiapid(217) =-1114    !ADL-
      pythiapid(218) = 4444    !DL++(1620)
      pythiapid(219) = 4444    !DL+(1620)
      pythiapid(220) = 4444    !DL0(1620)
      pythiapid(221) = 4444    !DL-(1620)
      pythiapid(222) = 4444    !ADL++(1620)
      pythiapid(223) = 4444    !ADL+(1620)
      pythiapid(224) = 4444    !ADL0(1620)
      pythiapid(225) = 4444    !ADL-(1620)
      pythiapid(226) = 4444    !DL++(1620)
      pythiapid(227) = 4444    !DL+(1620)
      pythiapid(228) = 4444    !DL0(1620)
      pythiapid(229) = 4444    !DL-(1620)
      pythiapid(230) = 4444    !ADL++(1620)
      pythiapid(231) = 4444    !ADL+(1620)
      pythiapid(232) = 4444    !ADL0(1620)
      pythiapid(233) = 4444    !ADL-(1620)
      pythiapid(234) = 4444    !DL++(1700)
      pythiapid(235) = 4444    !DL+(1700)
      pythiapid(236) = 4444    !DL0(1700)
      pythiapid(237) = 4444    !DL-(1700)
      pythiapid(238) = 4444    !ADL++(1700)
      pythiapid(239) = 4444    !ADL+(1700)
      pythiapid(240) = 4444    !ADL0(1700)
      pythiapid(241) = 4444    !ADL-(1700)
c****************************************
c Lambda baryons
c (S = -1, I = 0)
c****************************************
      pythiapid(300) = 3122    !L
      pythiapid(301) =-3122    !AL
      pythiapid(302) = 4444    !L(1405)
      pythiapid(303) = 4444    !AL(1405) 
      pythiapid(304) = 4444    !L(1520)
      pythiapid(305) = 4444    !AL(1520)
      pythiapid(306) = 4444    !L(1645)
      pythiapid(307) = 4444    !AL(1645)
      pythiapid(308) = 4444    !L(1645)
      pythiapid(309) = 4444    !AL(1645) 
      pythiapid(310) = 4444    !L(1645)
      pythiapid(311) = 4444    !AL(1645) 
c****************************************
c Sigma baryons
c (S = -1, I = 1)
c****************************************
      pythiapid(330) = 3222    !S+
      pythiapid(331) = 3212    !S0
      pythiapid(332) = 3112    !S-
      pythiapid(333) =-3222    !AS+
      pythiapid(334) =-3212    !AS0
      pythiapid(335) =-3112    !AS-
      pythiapid(336) = 3224    !S*+
      pythiapid(337) = 3214    !S*0
      pythiapid(338) = 3114    !S*-
      pythiapid(339) =-3224    !AS*+
      pythiapid(340) =-3214    !AS*0
      pythiapid(341) =-3114    !AS*- 
c****************************************
c Xsi baryons
c (S = -2, I = 1/2)
c**************************************** 
      pythiapid(390) = 3322    !XI0
      pythiapid(391) = 3312    !XI-
      pythiapid(392) =-3322    !AXI0
      pythiapid(393) =-3312    !AXI-
      pythiapid(394) = 3324    !XI*0
      pythiapid(395) = 3314    !XI*-
      pythiapid(396) =-3324    !AXI*0
      pythiapid(397) =-3314    !AXI*-
c****************************************
c Omega baryons
c (S = -3, I = 0)
c****************************************
      pythiapid(410) = 3334    !OM-
      pythiapid(411) =-3334    !AOM-    

c      ENDIF

      RETURN 
      END

CCC   #################################################################
CCC   pythia2sid()
CCC   #################################################################
CCC   last updated 09072008
CCC   #################################################################
      function pythia2sid(kf)
      IMPLICIT NONE
      INTEGER pythia2sid,kf

      SELECT case(kf)
      case (4444)
      pythia2sid=0
c$$$c****************************************
c$$$c Light unflavored mesons 
c$$$c (S = C = B =0)
c$$$c****************************************
c$$$      pythiapid(1) =   211   !! pi+
      case(211)
      pythia2sid=1
c$$$      pythiapid(2) =   111   !! pi0
      case(111)
      pythia2sid=2
c$$$      pythiapid(3) =  -211   !! pi-
      case(-211)
      pythia2sid=3
c$$$      pythiapid(4) =   221   !! eta
      case(221)
      pythia2sid=4
c$$$      pythiapid(5) =   213   !! rho+
      case(213)
      pythia2sid=5
c$$$      pythiapid(6) =   113   !! rho0
      case(113)
      pythia2sid=6
c$$$      pythiapid(7) =  -213   !! rho-
      case(-213)
      pythia2sid=7
c$$$      pythiapid(8) =   223   !! omega
      case(223)
      pythia2sid=8
c$$$      pythiapid(9) =   331   !! eta'
      case(331)
      pythia2sid=9
c$$$      pythiapid(10) =   10221  !! f0(980)
      case(10221)
      pythia2sid=10
c$$$      pythiapid(11) =   10211  !! a0(980)+
      case(10211)
      pythia2sid=11
c$$$      pythiapid(12) =   10111  !! a0(980)0
      case(10111)
      pythia2sid=12
c$$$      pythiapid(13) =  -10211  !! a0(980)-
      case(-10211)
      pythia2sid=13
c$$$      pythiapid(14) =   333  !! phi(1020)
      case(333)
      pythia2sid=14
c$$$c****************************************
c$$$c Strange mesons 
c$$$c (S = +/- 1, C = B = 0)
c$$$c****************************************
c$$$      pythiapid(70)  = 321     !K+
      case(321)
      pythia2sid=70
c$$$      pythiapid(71)  =-321     !K-
      case(-321)
      pythia2sid=71
c$$$      pythiapid(72)  = 311     !K0
      case(311)
      pythia2sid=72
c$$$      pythiapid(73)  =-311     !AK0
      case(-311)
      pythia2sid=73
c$$$      pythiapid(74)  = 323     !K*+
      case(323)
      pythia2sid=74
c$$$      pythiapid(75)  =-323     !K*-
      case(-323)
      pythia2sid=75
c$$$      pythiapid(76)  = 313     !K*0
      case(313)
      pythia2sid=76
c$$$      pythiapid(77)  =-313     !AK*0
      case(-313)
      pythia2sid=77
c$$$c****************************************
c$$$c N baryons
c$$$c (S = 0, I = 1/2)
c$$$c****************************************
c$$$      pythiapid(150) = 2212    !P
      case(2212)
      pythia2sid=150
c$$$      pythiapid(151) =-2212    !AP
      case(-2212)
      pythia2sid=151
c$$$      pythiapid(152) = 2112    !N
      case(2112)
      pythia2sid=152
c$$$      pythiapid(153) =-2112    !AN
      case(-2112)
      pythia2sid=153
c$$$      pythiapid(154) = 4444    !N*+(1440)
c$$$      pythiapid(155) = 4444    !N*0(1440)
c$$$      pythiapid(156) = 4444    !AN*+(1440)
c$$$      pythiapid(157) = 4444    !AN*0(1440)
c$$$      pythiapid(158) = 4444    !N*+(1530)
c$$$      pythiapid(159) = 4444    !N*0(1530)
c$$$      pythiapid(160) = 4444    !AN*+(1530)
c$$$      pythiapid(161) = 4444    !AN*0(1530)
c$$$      pythiapid(162) = 4444    !N*+(1530)
c$$$      pythiapid(163) = 4444    !N*0(1530)
c$$$      pythiapid(164) = 4444    !AN*+(1530)
c$$$      pythiapid(165) = 4444    !AN*0(1530)
c$$$      pythiapid(166) = 4444    !N*+(1665)
c$$$      pythiapid(167) = 4444    !N*0(1665)
c$$$      pythiapid(168) = 4444    !AN*+(1665)
c$$$      pythiapid(169) = 4444    !AN*0(1665)
c$$$      pythiapid(170) = 4444    !N*+(1665)
c$$$      pythiapid(171) = 4444    !N*0(1665)
c$$$      pythiapid(172) = 4444    !AN*+(1665)
c$$$      pythiapid(173) = 4444    !AN*0(1665)
c$$$      pythiapid(174) = 4444    !N*+(1680)
c$$$      pythiapid(175) = 4444    !N*0(1680)
c$$$      pythiapid(176) = 4444    !AN*+(1680)
c$$$      pythiapid(177) = 4444    !AN*0(1680)
c$$$      pythiapid(178) = 4444    !N*+(1710)
c$$$      pythiapid(179) = 4444    !N*0(1710)
c$$$      pythiapid(180) = 4444    !AN*+(1710)
c$$$      pythiapid(181) = 4444    !AN*0(1710)
c$$$      pythiapid(182) = 4444    !N*+(1710)
c$$$      pythiapid(183) = 4444    !N*0(1710)
c$$$      pythiapid(184) = 4444    !AN*+(1710)
c$$$      pythiapid(185) = 4444    !AN*0(1710)
c$$$      pythiapid(186) = 4444    !N*+(1710)
c$$$      pythiapid(187) = 4444    !N*0(1710)
c$$$      pythiapid(188) = 4444    !AN*+(1710)
c$$$      pythiapid(189) = 4444    !AN*0(1710)
c$$$c****************************************
c$$$c Delta baryons
c$$$c (S = 0, I = 3/2)
c$$$c****************************************
c$$$      pythiapid(210) = 2224    !DL++
      case(2224)
      pythia2sid=210
c$$$      pythiapid(211) = 2214    !DL+
      case(2214)
      pythia2sid=211
c$$$      pythiapid(212) = 2114    !DL0
      case(2114)
      pythia2sid=212
c$$$      pythiapid(213) = 1114    !DL-
      case(1114)
      pythia2sid=213
c$$$      pythiapid(214) =-2224    !ADL++
      case(-2224)
      pythia2sid=214
c$$$      pythiapid(215) =-2214    !ADL+
      case(-2214)
      pythia2sid=215
c$$$      pythiapid(216) =-2114    !ADL0
      case(-2114)
      pythia2sid=216
c$$$      pythiapid(217) =-1114    !ADL-
      case(-1114)
      pythia2sid=217
c$$$      pythiapid(218) = 4444    !DL++(1620)
c$$$      pythiapid(219) = 4444    !DL+(1620)
c$$$      pythiapid(220) = 4444    !DL0(1620)
c$$$      pythiapid(221) = 4444    !DL-(1620)
c$$$      pythiapid(222) = 4444    !ADL++(1620)
c$$$      pythiapid(223) = 4444    !ADL+(1620)
c$$$      pythiapid(224) = 4444    !ADL0(1620)
c$$$      pythiapid(225) = 4444    !ADL-(1620)
c$$$      pythiapid(226) = 4444    !DL++(1620)
c$$$      pythiapid(227) = 4444    !DL+(1620)
c$$$      pythiapid(228) = 4444    !DL0(1620)
c$$$      pythiapid(229) = 4444    !DL-(1620)
c$$$      pythiapid(230) = 4444    !ADL++(1620)
c$$$      pythiapid(231) = 4444    !ADL+(1620)
c$$$      pythiapid(232) = 4444    !ADL0(1620)
c$$$      pythiapid(233) = 4444    !ADL-(1620)
c$$$      pythiapid(234) = 4444    !DL++(1700)
c$$$      pythiapid(235) = 4444    !DL+(1700)
c$$$      pythiapid(236) = 4444    !DL0(1700)
c$$$      pythiapid(237) = 4444    !DL-(1700)
c$$$      pythiapid(238) = 4444    !ADL++(1700)
c$$$      pythiapid(239) = 4444    !ADL+(1700)
c$$$      pythiapid(240) = 4444    !ADL0(1700)
c$$$      pythiapid(241) = 4444    !ADL-(1700)
c$$$c****************************************
c$$$c Lambda baryons
c$$$c (S = -1, I = 0)
c$$$c****************************************
c$$$      pythiapid(300) = 3122    !L
      case(3122)
      pythia2sid=300
c$$$      pythiapid(301) =-3122    !AL
      case(-3122)
      pythia2sid=301
c$$$      pythiapid(302) = 4444    !L(1405)
c$$$      pythiapid(303) = 4444    !AL(1405) 
c$$$      pythiapid(304) = 4444    !L(1520)
c$$$      pythiapid(305) = 4444    !AL(1520)
c$$$      pythiapid(306) = 4444    !L(1645)
c$$$      pythiapid(307) = 4444    !AL(1645)
c$$$      pythiapid(308) = 4444    !L(1645)
c$$$      pythiapid(309) = 4444    !AL(1645) 
c$$$      pythiapid(310) = 4444    !L(1645)
c$$$      pythiapid(311) = 4444    !AL(1645) 
c$$$c****************************************
c$$$c Sigma baryons
c$$$c (S = -1, I = 1)
c$$$c****************************************
c$$$      pythiapid(330) = 3222    !S+
      case(3222)
      pythia2sid=330
c$$$      pythiapid(331) = 3212    !S0
      case(3212)
      pythia2sid=331
c$$$      pythiapid(332) = 3112    !S-
      case(3112)
      pythia2sid=332
c$$$      pythiapid(333) =-3222    !AS+
      case(-3222)
      pythia2sid=333
c$$$      pythiapid(334) =-3212    !AS0
      case(-3212)
      pythia2sid=334
c$$$      pythiapid(335) =-3112    !AS-
      case(-3112)
      pythia2sid=335
c$$$      pythiapid(336) = 3224    !S*+
      case(3224)
      pythia2sid=336
c$$$      pythiapid(337) = 3214    !S*0
      case(3214)
      pythia2sid=337
c$$$      pythiapid(338) = 3114    !S*-
      case(3114)
      pythia2sid=338
c$$$      pythiapid(339) =-3224    !AS*+
      case(-3224)
      pythia2sid=339
c$$$      pythiapid(340) =-3214    !AS*0
      case(-3214)
      pythia2sid=340
c$$$      pythiapid(341) =-3114    !AS*- 
      case(-3114)
      pythia2sid=341
c$$$c****************************************
c$$$c Xsi baryons
c$$$c (S = -2, I = 1/2)
c$$$c**************************************** 
c$$$      pythiapid(390) = 3322    !XI0
      case(3322)
      pythia2sid=390
c$$$      pythiapid(391) = 3312    !XI-
      case(3312)
      pythia2sid=391
c$$$      pythiapid(392) =-3322    !AXI0
      case(-3322)
      pythia2sid=392
c$$$      pythiapid(393) =-3312    !AXI-
      case(-3312)
      pythia2sid=393
c$$$      pythiapid(394) = 3324    !XI*0
      case(3324)
      pythia2sid=394
c$$$      pythiapid(395) = 3314    !XI*-
      case(3314)
      pythia2sid=395
c$$$      pythiapid(396) =-3324    !AXI*0
      case(-3324)
      pythia2sid=396
c$$$      pythiapid(397) =-3314    !AXI*-
      case(-3314)
      pythia2sid=397
c$$$c****************************************
c$$$c Omega baryons
c$$$c (S = -3, I = 0)
c$$$c****************************************
c$$$      pythiapid(410) = 3334    !OM-
      case(3334)
      pythia2sid=410
c$$$      pythiapid(411) =-3334    !AOM-    
      case(-3334)
      pythia2sid=411
      case default
      continue 
c      write(*,*) 'unknown particle in pythia2sid, kf=',kf
c$$$      stop 'fatal error in pythia2sid'
      pythia2sid=0      
      END SELECT



      RETURN 
      END

CCC   #################################################################
CCC   sharepd()
CCC   #################################################################
CCC   last updated 09072008
CCC   #################################################################
      SUBROUTINE sharepd
      IMPLICIT NONE
      INTEGER sharepid(500),i
      COMMON/sharep/sharepid

      DO i=1,500
         sharepid(i)=0
      ENDDO

c****************************************
c Light unflavored mesons 
c (S = C = B =0)
c****************************************
      sharepid(1) =   377   !! pi+
      sharepid(2) =   379   !! pi0
      sharepid(3) =   378   !! pi-
      sharepid(4) =   372   !! eta
      sharepid(5) =   368   !! rho+
      sharepid(6) =   370   !! rho0
      sharepid(7) =   369   !! rho-
      sharepid(8) =   367   !! omega
      sharepid(9) =   358   !! eta'
      sharepid(10) =   357  !! f0(980)
      sharepid(11) =   354  !! a0(980)+
      sharepid(12) =   356  !! a0(980)0
      sharepid(13) =   355  !! a0(980)-
      sharepid(14) =   353  !! phi(1020)
c****************************************
c Strange mesons 
c (S = +/- 1, C = B = 0)
c****************************************
      sharepid(70)  = 375     !K+
      sharepid(71)  = 376     !K-
      sharepid(72)  = 373     !K0
      sharepid(73)  = 374     !AK0
      sharepid(74)  = 365     !K*+
      sharepid(75)  = 366     !K*-
      sharepid(76)  = 363     !K*0
      sharepid(77)  = 364     !AK*0
c****************************************
c N baryons
c (S = 0, I = 1/2)
c****************************************
      sharepid(150) = 361    !P
      sharepid(151) = 362    !AP
      sharepid(152) = 359    !N
      sharepid(153) = 360    !AN
      sharepid(154) = 283    !N*+(1440)
      sharepid(155) = 284    !N*0(1440)
      sharepid(156) = 285    !AN*+(1440)
      sharepid(157) = 286    !AN*0(1440)
      sharepid(158) = 270    !N*+(1530)
      sharepid(159) = 271    !N*0(1530)
      sharepid(160) = 272    !AN*+(1530)
      sharepid(161) = 273    !AN*0(1530)
      sharepid(162) = 261    !N*+(1530)
      sharepid(163) = 262    !N*0(1530)
      sharepid(164) = 263    !AN*+(1530)
      sharepid(165) = 264    !AN*0(1530)
      sharepid(166) = 234    !N*+(1665)
      sharepid(167) = 235    !N*0(1665)
      sharepid(168) = 236    !AN*+(1665)
      sharepid(169) = 237    !AN*0(1665)
      sharepid(170) = 210    !N*+(1665)
      sharepid(171) = 211    !N*0(1665)
      sharepid(172) = 212    !AN*+(1665)
      sharepid(173) = 213    !AN*0(1665)
      sharepid(174) = 205    !N*+(1680)
      sharepid(175) = 206    !N*0(1680)
      sharepid(176) = 207    !AN*+(1680)
      sharepid(177) = 208    !AN*0(1680)
      sharepid(178) = 181    !N*+(1710)
      sharepid(179) = 182    !N*0(1710)
      sharepid(180) = 183    !AN*+(1710)
      sharepid(181) = 184    !AN*0(1710)
      sharepid(182) = 177    !N*+(1710)
      sharepid(183) = 178    !N*0(1710)
      sharepid(184) = 179    !AN*+(1710)
      sharepid(185) = 180    !AN*0(1710)
      sharepid(186) = 168    !N*+(1710)
      sharepid(187) = 169    !N*0(1710)
      sharepid(188) = 170    !AN*+(1710)
      sharepid(189) = 171    !AN*0(1710)
c****************************************
c Delta baryons
c (S = 0, I = 3/2)
c****************************************
      sharepid(210) = 330    !DL++
      sharepid(211) = 331    !DL+
      sharepid(212) = 332    !DL0
      sharepid(213) = 333    !DL-
      sharepid(214) = 334    !ADL++
      sharepid(215) = 335    !ADL+
      sharepid(216) = 336    !ADL0
      sharepid(217) = 337    !ADL-
      sharepid(218) = 251    !DL++(1620)
      sharepid(219) = 252    !DL+(1620)
      sharepid(220) = 253    !DL0(1620)
      sharepid(221) = 254    !DL-(1620)
      sharepid(222) = 255    !ADL++(1620)
      sharepid(223) = 256    !ADL+(1620)
      sharepid(224) = 257    !ADL0(1620)
      sharepid(225) = 258    !ADL-(1620)
      sharepid(226) = 239    !DL++(1620)
      sharepid(227) = 240    !DL+(1620)
      sharepid(228) = 241    !DL0(1620)
      sharepid(229) = 242    !DL-(1620)
      sharepid(230) = 243    !ADL++(1620)
      sharepid(231) = 244    !ADL+(1620)
      sharepid(232) = 245    !ADL0(1620)
      sharepid(233) = 246    !ADL-(1620)
      sharepid(234) = 188    !DL++(1700)
      sharepid(235) = 189    !DL+(1700)
      sharepid(236) = 190    !DL0(1700)
      sharepid(237) = 191    !DL-(1700)
      sharepid(238) = 192    !ADL++(1700)
      sharepid(239) = 193    !ADL+(1700)
      sharepid(240) = 194    !ADL0(1700)
      sharepid(241) = 195    !ADL-(1700)
c****************************************
c Lambda baryons
c (S = -1, I = 0)
c****************************************
      sharepid(300) = 351    !L
      sharepid(301) = 352    !AL
      sharepid(302) = 300    !L(1405)
      sharepid(303) = 301    !AL(1405) 
      sharepid(304) = 274    !L(1520)
      sharepid(305) = 275    !AL(1520)
      sharepid(306) = 259    !L(1645)
      sharepid(307) = 260    !AL(1645)
      sharepid(308) = 219    !L(1645)
      sharepid(309) = 220    !AL(1645) 
      sharepid(310) = 199    !L(1645)
      sharepid(311) = 200    !AL(1645) 
c****************************************
c Sigma baryons
c (S = -1, I = 1)
c****************************************
      sharepid(330) = 348    !S+
      sharepid(331) = 346    !S0
      sharepid(332) = 344    !S-
      sharepid(333) = 349    !AS+
      sharepid(334) = 347    !AS0
      sharepid(335) = 345    !AS-
      sharepid(336) = 310    !S*+
      sharepid(337) = 308    !S*0
      sharepid(338) = 306    !S*-
      sharepid(339) = 311    !AS*+
      sharepid(340) = 309    !AS*0
      sharepid(341) = 307    !AS*- 
c****************************************
c Xsi baryons
c (S = -2, I = 1/2)
c**************************************** 
      sharepid(390) = 315    !XI0
      sharepid(391) = 313    !XI-
      sharepid(392) = 316    !AXI0
      sharepid(393) = 314    !AXI-
      sharepid(394) = 267    !XI*0
      sharepid(395) = 265    !XI*-
      sharepid(396) = 268    !AXI*0
      sharepid(397) = 266    !AXI*-
c****************************************
c Omega baryons
c (S = -3, I = 0)
c****************************************
      sharepid(410) = 214    !OM-
      sharepid(411) = 215    !AOM-    

c      ENDIF

      RETURN 
      END

CCC   #################################################################
CCC   rftzer()
CCC   #################################################################
      subroutine  rdtzer
      implicit none
      include 'epos.incsf'
      include 'spherio.fnames.inc'
      include 'spherio.rtzer.inc'

      character filename1*108,filename2*108
      integer i,nn
      double precision dummy


      filename1= fneos(1:nfneos)//eosdatapath1//rdtzerf1
      filename2= fneos(1:nfneos)//eosdatapath1//rdtzerf2

      open(10,file=filename1,status='old')
      open(20,file=filename2,status='old')

      nn=0
      do i=1,10000
       read(10,*,END=10)dummy,znq(nn+1),zeq(nn+1)
       nn=nn+1
      enddo
 10   continue
      nzqmx=nn

      
      nn=0
      do i=1,10000
       read(20,*,END=20)dummy,dummy,zer(nn+1),dummy,znr(nn+1),dummy
       nn=nn+1
      enddo
 20   continue
      nzrmx=nn

      close(10)
      close(20)

      return
      end



CCC   #################################################################
CCC   rdt15
CCC   #################################################################
      subroutine  rdt15
      implicit none
      include 'epos.incsf'
      include 'spherio.fnames.inc'
      include 'spherio.crossover.inc'

      character filename1*108
      integer i
      double precision dummy


      filename1= fneos(1:nfneos)//eosdatapath4//rdtzercof1

      open(10,file=filename1,status='old')
      read(10,*)nnpt
      do i=1,nnpt
       read(10,*)dummy,dummy,yengy(i),yentr(i),xnb(i),dummy
      enddo
      close(10)


      return
      end



CCC   #################################################################
CCC   readstb()
CCC   #################################################################
CCC   last updated 03162007
CCC   changed the input convention
CCC
CCC   last updated 03142007
CCC   fix a bug
CCC
CCC   last updated 03132007
CCC   inherit from readtb()
CCC   #################################################################
      SUBROUTINE readstb
      implicit none

      include 'epos.incsf'
      include 'spherio.fnames.inc'
      include 'spherio.evgen2-ic.inc'
      include 'spherio.evgen3.inc'
      
      integer i,j,ii
      character*108 file1,file2,file3,file4,file5
      double precision rtemp
      character*20 atemp
                                      
      file1= fneos(1:nfneos)//eosdatapath2//stbf1
      file2= fneos(1:nfneos)//eosdatapath2//stbf2
      file3= fneos(1:nfneos)//eosdatapath2//stbf3
      file4= fneos(1:nfneos)//eosdatapath2//stbf4
      file5= fneos(1:nfneos)//eosdatapath2//stbf5
      
      open(10,file=file1,status='old')
      do i=1,ntb1x
        do j=1,ntb1y
         read(10,*)temp(i),chemb(i,j),utb(i,j),utab(i,j)
     &          ,denom(i,j)
        enddo
      enddo
      close(10)

      open(20,file=file2,status='old')
      do i=1,ntb2x
         do j=1,ntb2y
            read(20,*)ut(i),mt(j),xintg(i,j)
         enddo
      enddo
      close(20)

      open(30,file=file3,status='old')
      read(30,*)nr_T,nr_ub
      write(*,*)'nr_T,nr_ub=',nr_T,nr_ub
      do i=1,nr_T
        do j=1,nr_ub
c        write(*,*)'i,j=',i,j
         read(30,*)xx_T(i),xx_ub(i,j),xx_P(i,j),
     &          xx_nb(i,j),xx_e(i,j),xx_s(i,j),xx_us(i,j)
        enddo
      enddo
      close(30)

      open(30,file=file4,status='old')
      read(30,*)nq_T,nq_ub
      write(*,*)'nq_T,nq_ub=',nq_T,nq_ub
      do j=1,nq_ub
        do i=1,nq_T
         read(30,*)qq_T(i),qq_ub(i,j),qq_P(i,j),                    !here qq_T() is in a reversed order, due to numerical solution procedure
     &          qq_nb(i,j),qq_e(i,j),qq_s(i,j),qq_us(i,j)
        enddo
      enddo
      close(30)
      
      open(30,file=file5,status='old')
      read(30,*)nm_T,nm_ub
      write(*,*)'nm_T,nm_ub=',nm_T,nm_ub
      read(30,*)atemp,atemp,atemp,atemp,atemp,atemp,atemp,atemp
      do ii=1,nm_T
        i=nm_T-ii+1
        do j=1,nm_ub
         read(30,*)mm_T(i),mm_ub(i,j),mm_P(i,j),
     &          mm_nb(i,j),mm_e(i,j),mm_s(i,j),mm_us(i,j),mm_x(i,j)     !here mm_T() is a decreasing series, reversed input is designed to use locate1()
        enddo
      enddo
      close(30)
      
      return
      end


CCC   #################################################################
CCC   readtb()
CCC   #################################################################
      SUBROUTINE readtb
      implicit none

      include 'epos.incsf'
      include 'spherio.fnames.inc'
      include 'spherio.evgen2-ic.inc'
      include 'spherio.evgen3.inc'
      
      integer i,j
      character*108 file1,file2,file3 
                                      
      file1= fneos(1:nfneos)//eosdatapath1//tbf1
      file2= fneos(1:nfneos)//eosdatapath1//tbf2
      file3= fneos(1:nfneos)//eosdatapath1//tbf3

      open(10,file=file1,status='old')
      do i=1,ntb1x
        do j=1,ntb1y
         read(10,*)temp(i),chemb(i,j),utb(i,j),utab(i,j),denom(i,j)
        enddo
      enddo
      close(10)

      open(20,file=file2,status='old')
      do i=1,ntb2x
         do j=1,ntb2y
            read(20,*)ut(i),mt(j),xintg(i,j)
         enddo
      enddo
      close(20)

      open(30,file=file3,status='old')
      do i=1,nn_T
        do j=1,nn_ub
         read(30,*)xx_T(i),xx_ub(i,j),xx_P(i,j)
        enddo
      enddo
      close(30)

      return
      end


CCC   #################################################################
CCC   for finding thermodynamical quantities from tables
CCC   #################################################################
CCC   last updated 05072006
CCC   to incorporate the strangeness
CCC   spherio.esqr.inc is include where esqr(1:4,0:2) -> esqr(1:5,0:2)
CCC   and esqr(5,0) --> strangeness chemical potential
CCC   esqr is not a common variable, while it is used in all the subroutine 
CCC   which evoke thintp(), and it is the same array used also by geteos() 
CCC   where the data are generated, as well as all the subroutines evoking geteos(). 
CCC   So this is the reason that the definition is singled out as an include file
CCC   geteos() also need to be modified exactly as this point
CCC
CCC   yms1, emsin, out5 is defined to store temporary data for interpolation
CCC   the treatment of the sign of chemical potential is the same as tmintp()
CCC   
CCC   last updated 04302006
CCC   to incorporate the strangeness
CCC   spherio.const.inc, spherio.thr.inc are included
CCC   #################################################################
      SUBROUTINE thintp(phsflg,Tm,ub1,esqr) 

      IMPLICIT NONE 
      include 'spherio.const.inc'
      include 'spherio.thr.inc'
      include 'spherio.esqr.inc'
      include 'spherio.debug.inc'

      DOUBLE PRECISION Tm,ub1,ub2,sign,error

      INTEGER phsflg,n1,n2,m1,m2,jj,ll,k1,k2,l1,l2

      DOUBLE PRECISION eein(5),esin(5),enin(5),epin(5),emsin(5)
      DOUBLE PRECISION xx0(150)
      DOUBLE PRECISION xx1(5),ye1(5),ys1(5),yn1(5),yp1(5),yms1(5)
      DOUBLE PRECISION yy2(5)
      DOUBLE PRECISION out1,out2,out3,out4,out5

ccc   ///////////////////////////////////////////
      if(ub1.lt.zero) then 
         sign=-1.d+00 
         ub2= -ub1
      else
         sign=+1.d+00 
         ub2= +ub1 
      end if
ccc   ///////////////////////////////////////////
ccc   #############################################################
      if(phsflg.eq.2) then 
         call locate(emq,mbin2q,ub2,m2)
         
         if(m2.eq.0) then 
            k1=1
            k2=2
         else if(m2.eq.mbin2q) then 
            k1= mbin2q-1
            k2= mbin2q
         else
            k1= m2
            k2= m2+1
         end if
         
         n2=0 
         do 101 jj=k1,k2  
            n2=n2+1 
            yy2(n2)= emq(jj) 
            do m1=1,mbin1q
               xx0(m1)= etq(m1,jj) 
            end do
            call locate(xx0,mbin1q,Tm,m1)
            if(m1.eq.0) then 
               l1=1
               l2=2
            else if(m1.eq.mbin1q) then 
               l1= mbin1q-1
               l2= mbin1q
            else
               l1= m1
               l2= m1+1
            end if
            n1= 0 
            do 111 ll=l1,l2 
               n1=n1+1
               xx1(n1)=etq(ll,jj)
               ye1(n1)=eeq(ll,jj)
               ys1(n1)=esq(ll,jj)
               yn1(n1)=enq(ll,jj)
               yp1(n1)=epq(ll,jj)    
CCC   to incorporate strangeness
               yms1(n1)=emusq(ll,jj)
CCC   to incorporate strangeness
 111        continue
            call polint11(xx1,ye1,5,2,Tm,eein(n2),error)
            call polint11(xx1,ys1,5,2,Tm,esin(n2),error)
            call polint11(xx1,yn1,5,2,Tm,enin(n2),error)
            call polint11(xx1,yp1,5,2,Tm,epin(n2),error)
CCC   to incorporate strangeness
            call polint11(xx1,yms1,5,2,Tm,emsin(n2),error)
CCC   to incorporate strangeness
 101     continue
ccc   /////////////////////////////////////////////////////////////
      else if(phsflg.eq.0) then 
         call locate(emr,mbin2r,ub2,m2)
         if(m2.eq.0) then 
            k1=1
            k2=2
         else if(m2.eq.mbin2r) then 
            k1= mbin2r-1
            k2= mbin2r
         else
            k1= m2
            k2= m2+1
         end if
         
         n2=0 
         do 201 jj=k1,k2  
            n2=n2+1 
            yy2(n2)= emr(jj) 
            
            do m1=1,mbin1r
               xx0(m1)= etr(m1,jj) 
            end do
            
            call locate(xx0,mbin1r,Tm,m1)
            if(m1.eq.0) then 
               l1=1
               l2=2
            else if(m1.eq.mbin1r) then 
               l1= mbin1r-1
               l2= mbin1r
            else
               l1= m1
               l2= m1+1
            end if

            n1= 0 
            do 211 ll=l1,l2 
               n1=n1+1
               xx1(n1)=etr(ll,jj)
               ye1(n1)=eer(ll,jj)
               ys1(n1)=esr(ll,jj)
               yn1(n1)=enr(ll,jj)
               yp1(n1)=epr(ll,jj)  
CCC   to incorporate strangeness
               yms1(n1)=emusr(ll,jj)
CCC   to incorporate strangeness			           
 211        continue
            call polint11(xx1,ye1,5,2,Tm,eein(n2),error)
            call polint11(xx1,ys1,5,2,Tm,esin(n2),error)
            call polint11(xx1,yn1,5,2,Tm,enin(n2),error)
            call polint11(xx1,yp1,5,2,Tm,epin(n2),error)
CCC   to incorporate strangeness
            call polint11(xx1,yms1,5,2,Tm,emsin(n2),error)
CCC   to incorporate strangeness
 201     continue
      end if
ccc   #############################################################
      call polint11(yy2,eein,5,2,ub2,out1,error) 
      call polint11(yy2,esin,5,2,ub2,out2,error) 
      call polint11(yy2,enin,5,2,ub2,out3,error) 
      call polint11(yy2,epin,5,2,ub2,out4,error)
CCC   to incorporate strangeness
      call polint11(yy2,emsin,5,2,ub2,out5,error)
CCC   to incorporate strangeness
ccc   #############################################################
      esqr(1,0)= out1
      esqr(2,0)= out2
      esqr(3,0)= out3 *sign 
      esqr(4,0)= out4 
CCC   to incorporate strangeness
      esqr(5,0)= out5
CCC   to incorporate strangeness

      RETURN      
      END 
      
      


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   for finding thermodynamical quantities from tables
CCC   #################################################################
CCC   last updated 05072011
CCC   adopted Otavio's version
CCC   #################################################################
       subroutine thintp_crossover(T,ub,es)
       implicit none
       include 'spherio.crossover.inc'
       double precision T,ub,es(4,0:2)
       double precision uba,sinal
       integer i,j
       double precision p,q,z1,z2
c es(1) = energy density
c es(2) = entropy density
c es(3) = baryonic density
c es(4) = pressure
       if(ub.lt.0.)then
          uba = -ub
          sinal = -1.0
       else
          uba = ub
          sinal = +1.0
       endif  

       call locate(etqr,mbinT,T,i)
       if(i.eq.0)i=1
       if(i.eq.mbinT)i=mbinT-1

       call locate(emqr,mbinm,uba,j)
       if(j.eq.0)j=1
       if(j.eq.mbinm)j=mbinm-1

       p=(T-etqr(i))/(etqr(i+1)-etqr(i))
       q=(uba-emqr(j))/(emqr(j+1)-emqr(j))

c energy density
       z1=(1-p)*eeqr(i,j)+p*eeqr(i+1,j)
       z2=(1-p)*eeqr(i,j+1)+p*eeqr(i+1,j+1)
       es(1,0)=(1-q)*z1+q*z2 
   
c entropy density
       z1=(1-p)*esqr(i,j)+p*esqr(i+1,j)
       z2=(1-p)*esqr(i,j+1)+p*esqr(i+1,j+1)
       es(2,0)=(1-q)*z1+q*z2 

c baryonic density
       z1=(1-p)*enqr(i,j)+p*enqr(i+1,j)
       z2=(1-p)*enqr(i,j+1)+p*enqr(i+1,j+1)
       es(3,0)=(1-q)*z1+q*z2
       es(3,0)=sinal*es(3,0)

c pressure
       z1=(1-p)*epqr(i,j)+p*epqr(i+1,j)
       z2=(1-p)*epqr(i,j+1)+p*epqr(i+1,j+1)
       es(4,0)=(1-q)*z1+q*z2 
 
       return
       end
      
      


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   for reading data table of the Tm\mu-> e,s,nb,P in SPheRIO \(^^) 
CCC   #################################################################
CCC   last updated at 04302006
CCC   to incorporate the strangeness
CCC   spherio.fnames.inc, spherio.const.inc and spherio.thr.inc are included
CCC   emusq and emusr is added to store strangeness chemical potential
CCC   at present, they are assigned to zero for debugging purpose
CCC   #################################################################
      SUBROUTINE thrread()
      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.fnames.inc'
      include 'spherio.thr.inc'
      include 'spherio.const.inc'

      INTEGER m1,m2
      CHARACTER filename1*108, filename2*108
CCC   == DATA READING ==
      filename1= fneos(1:nfneos)//eosdatapath1//thrf1
      filename2= fneos(1:nfneos)//eosdatapath1//thrf2

      OPEN(10,file=filename1,status='unknown') 
      READ(10,'(2i8)') mbin1q,mbin2q
      do m2=1,mbin2q             !! for chemical potential
         do m1=1,mbin1q          !! for temperature 
            READ(10,'(6d16.8)') etq(m1,m2),emq(m2),
     &           eeq(m1,m2),esq(m1,m2),enq(m1,m2),epq(m1,m2)     
            emusq(m1,m2)=zero
         end do
      end do
      CLOSE(10)

      OPEN(10,file=filename2,status='unknown') 
      READ(10,'(2i8)') mbin1r,mbin2r 
      do m2=1,mbin2r
         do m1=1,mbin1r
            READ(10,'(6d16.8)') etr(m1,m2),emr(m2),
     &           eer(m1,m2),esr(m1,m2),enr(m1,m2),epr(m1,m2)
            emusr(m1,m2)=zero
         end do
      end do
      CLOSE(10)
CCC  == DATA READING END ==
      RETURN
      STOP 234
      END 




c#######################################################################



CCC   #################################################################
CCC   for reading data table of the Tm\mu-> e,s,nb,P in SPheRIO \(^^) 
CCC   #################################################################
CCC   last updated 04262014
CCC   adopted the extended EoS tables for high temperature limit
CCC
CCC   last updated 05072011
CCC   adopted Otavio's version
CCC   #################################################################
      SUBROUTINE thrread_crossover()
      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.crossover.inc'
      include 'spherio.thr.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'

      INTEGER m1,m2
      CHARACTER filename1*108, filename2*108
      CHARACTER filename3*108
CCC   == ORIGINAL DATA READING ==
      filename1= fneos(1:nfneos)//eosdatapath4//thrcof1
      filename2= fneos(1:nfneos)//eosdatapath4//thrcof2

      open(10,file=filename1,status='old')
      read(10,*)mbinT,mbinm
      do m2=1,mbinm
         do m1=1,mbinT
            read(10,*)etqr(m1),emqr(m2),eeqr(m1,m2),esqr(m1,m2),
     &                enqr(m1,m2),epqr(m1,m2)
         enddo
      enddo
      close(10)

      open(20,file=filename2,status='old')
      read(20,*)mTlam,mulam
      do m2=1,mulam
         do m1=1,mTlam
            read(20,*)Tlam(m1),ulam(m2),lambd(m1,m2)
         enddo
      enddo
      close(20)
CCC  == ORIGINAL DATA READING END ==

CCC   == EXT DATA READING ==
      filename3= fneos(1:nfneos)//eosdatapath1//thrf1

      OPEN(10,file=filename3,status='unknown') 
      READ(10,'(2i8)') mbin1q,mbin2q
      do m2=1,mbin2q             !! for chemical potential
         do m1=1,mbin1q          !! for temperature
            READ(10,'(6d16.8)') etq(m1,m2),emq(m2),
     &           eeq(m1,m2),esq(m1,m2),enq(m1,m2),epq(m1,m2)     
            emusq(m1,m2)=zero
         end do
      end do
      CLOSE(10)
CCC  == EXT DATA READING END ==

      RETURN
      END 




c#######################################################################



CCC   #################################################################
CCC   tmevol()
CCC   #################################################################
CCC   last updated on 05042006
CCC   include 'spherio.eos.inc' to incorporate the strangeness
CCC   #################################################################
      SUBROUTINE tmevol(na,ta,Tm)
      IMPLICIT NONE
      include 'spherio.inc'
      include 'spherio.eos.inc'
      INTEGER nn,na,nb,nc,jj
      DOUBLE PRECISION Tm(-2:1),ta(-2:1)
      nb=idp(-1,na)
      nc=idp(-2,na)
      do 65 jj=-2,1
         if(jj.eq.-2) nn=nc
         if(jj.eq.-1) nn=nb
         if(jj.eq. 0) goto 65
         if(jj.eq. 1) nn=na
         oflg=jj
         eos(2)=ss(oflg,nn)
         eos(3)=bd(oflg,nn)
         call eosph(eos,2)
         Tm(jj)=eos(5)
 65   continue
      RETURN
      END
cxx   ################################################################      




CCC   #################################################################
CCC   to find Tm and ub from the tables and interpolate
CCC   #################################################################
CCC   last updated 05062006
CCC   the data is supposed to have an extra colume for strangeness
CCC   chemical potential, which implies one only need to add one
CCC   more interpolation at the end, after the fraction of 2-value
CCC   interpolation has been evaluated
CCC
CCC   yys(150) and msin(5) is used to store temporary data for 
CCC   strangeness chemical potential
CCC
CCC   about the sign of us, since for the transformation
CCC   ub -> -ub, us -> -us
CCC   the particle number for any species of particles, the total baryon 
CCC   number and the total strange number will take its negative value
CCC   in this case, we can make use of this symmetry
CCC   and store only half of the data of EOS, we only store the data
CCC   where the baryon density is positive
CCC   
CCC   it is noting here, that another possibility is that, this 
CCC   subroutine could be obsoleted in the future when another
CCC   more universal way to extract EOS information would be established
CCC
CCC
CCC   last updated at 05052006
CCC   the interface is changed, with us, the chemical potential added
CCC   it is to be implemented as soon as possible
CCC   
CCC   last updated at 04302006
CCC   to incorporate the strangeness
CCC   spherio.const.inc, spherio.tmu.inc are included
CCC   this subroutine should be further implemented in order to 
CCC   to extract the information of strangeness chemical potential
CCC   for the time being, it has not been fulfilled
CCC
CCC   #################################################################
      SUBROUTINE tmintp(gf,given,Tm,ub,us,phsflg) 

      IMPLICIT NONE 
      include 'spherio.const.inc'
      include 'spherio.tmu.inc'
      include 'spherio.debug.inc'

      INTEGER gf,phsflg,jj,kk,n1,n2,m1,m2,k1,k2,j1,j2
      integer ioutfl

      double precision pp
      DOUBLE PRECISION given(3),ndgvn1,ndgvn2
      DOUBLE PRECISION xnb(5),Tm,ub,us,sign
c      double precision error
      DOUBLE PRECISION ttin(5),muin(5)
      DOUBLE PRECISION xx0(150),xx1(5),yym(5),yyt(5) 
c     to incorporate strangeness
      DOUBLE PRECISION yys(150),msin(5)
c     to incorporate strangeness
      double precision yyy,xxx
c     ------------------------------------------------------
c     ------------------------------------------------------ 

c.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.
c     yyy: dens. entropia
c     xxx: dens. barionica
      yyy(xxx)=0.3d0+62.5d0*xxx
      ioutfl=0
c.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.


CCC   initial value for debugging purpose only
c      us=zero
CCC   initial value for dubugging purpose only
     
      ndgvn1= given(3) 
      if(ndgvn1.lt.zero) then 
         ndgvn2= -ndgvn1 
         sign= -1.d+00
      else
         ndgvn2= +ndgvn1  
         sign= +1.d+00
      end if
      
ccc   ###########################################################      
      if(phsflg.eq.2.and.gf.eq.1) then 
         call locate(bnq1,mbin1qe,ndgvn2,m1)
         if(m1.eq.0) then
            ioutfl=1 
            j1=1
            j2=2
         else if(m1.eq.mbin1qe) then
            j1=mbin1qe-1
            j2=mbin1qe
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 101 jj=j1,j2  
            n1=n1+1
            xnb(n1)= bnq1(jj) 
            do m2=1,mbin2qe
               xx0(m2)= enq(jj,m2)
            end do
            call locate(xx0,mbin2qe,given(gf),m2)
            if(m2.eq.0) then 
               k1=1
               k2=2
            else if(m2.eq.mbin2qe) then
               k1=mbin2qe-1
               k2=mbin2qe
            else
               k1=m2
               k2=m2+1
            end if            
            
            n2=0 
            do 111 kk=k1,k2
               n2=n2+1 
               xx1(n2)= enq(jj,kk)
               yyt(n2)= Tmq1(jj,kk) 
               yym(n2)= ubq1(jj,kk)
CCC   to incorporate strangeness 
               yys(n2)= usq1(jj,kk)
CCC   to incorporate strangeness
 111        continue
            pp=(given(gf)-xx1(1))/(xx1(2)-xx1(1))
            ttin(n1)=(1.d0-pp)*yyt(1)+pp*yyt(2)
            muin(n1)=(1.d0-pp)*yym(1)+pp*yym(2)
CCC   to incorporate strangeness
            msin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
CCC   to incorporate strangeness
c            call polint11(xx1,yyt,5,2,given(gf),ttin(n1),error)
c            call polint11(xx1,yym,5,2,given(gf),muin(n1),error)
 101     continue
ccc   ###########################################################
      else if(phsflg.eq.2.and.gf.eq.2) then 
         call locate(bnq2,mbin1qs,ndgvn2,m1)      
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
         else if(m1.eq.mbin1qs) then
            j1=mbin1qs-1
            j2=mbin1qs
         else
            j1=m1
            j2=m1+1
         end if

         n1=0 
         do 201 jj=j1,j2  
            n1=n1+1
            xnb(n1)= bnq2(jj) 
            do m2=1,mbin2qs
               xx0(m2)= sdq(jj,m2)
            end do
            call locate(xx0,mbin2qs,given(gf),m2)
            if(m2.eq.0) then 
               k1=1
               k2=2
            else if(m2.eq.mbin2qs) then
               k1=mbin2qs-1
               k2=mbin2qs
            else
               k1=m2
               k2=m2+1
            end if            

            n2=0 
            do 211 kk=k1,k2
               n2=n2+1 
               xx1(n2)= sdq(jj,kk)
               yyt(n2)= Tmq2(jj,kk)
               yym(n2)= ubq2(jj,kk)
CCC   to incorporate strangeness 
               yys(n2)= usq2(jj,kk)
CCC   to incorporate strangeness
 211        continue
            pp=(given(gf)-xx1(1))/(xx1(2)-xx1(1))
            ttin(n1)=(1.d0-pp)*yyt(1)+pp*yyt(2)
            muin(n1)=(1.d0-pp)*yym(1)+pp*yym(2)
CCC   to incorporate strangeness
            msin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
CCC   to incorporate strangeness
c            call polint11(xx1,yyt,5,2,given(gf),ttin(n1),error)
c            call polint11(xx1,yym,5,2,given(gf),muin(n1),error)
 201     continue

ccc   ###########################################################
      else if(phsflg.eq.0.and.gf.eq.1) then 
         call locate(bnr1,mbin1re,ndgvn2,m1)      
         if(m1.eq.0) then
            ioutfl=1          
            j1=1
            j2=2
         else if(m1.eq.mbin1re) then
            j1=mbin1re-1
            j2=mbin1re
         else
            j1=m1
            j2=m1+1
         end if         
         n1=0 
         do 301 jj=j1,j2  
            n1=n1+1
            xnb(n1)= bnr1(jj) 
            do m2=1,mbin2re
               xx0(m2)= enr(jj,m2)
            end do
            call locate(xx0,mbin2re,given(gf),m2)
            if(m2.eq.0) then 
               if(given(gf).lt.xx0(1)/5d0)then
                  Tm=0d0
                  ub=0d0
                  return
               else
                  k1=1
                  k2=2
               endif
            else if(m2.eq.mbin2re) then
               k1=mbin2re-1
               k2=mbin2re
            else
               k1=m2
               k2=m2+1
            end if            

            n2=0 
            do 311 kk=k1,k2
               n2=n2+1 
               xx1(n2)= enr(jj,kk)
               yyt(n2)= Tmr1(jj,kk) 
               yym(n2)= ubr1(jj,kk)
CCC   to incorporate strangeness 
               yys(n2)= usr1(jj,kk)
CCC   to incorporate strangeness
 311        continue
            pp=(given(gf)-xx1(1))/(xx1(2)-xx1(1))
            ttin(n1)=(1.d0-pp)*yyt(1)+pp*yyt(2)
            muin(n1)=(1.d0-pp)*yym(1)+pp*yym(2)
CCC   to incorporate strangeness
            msin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
CCC   to incorporate strangeness
c            call polint11(xx1,yyt,5,2,given(gf),ttin(n1),error)
c            call polint11(xx1,yym,5,2,given(gf),muin(n1),error)
 301     continue       
ccc   ###########################################################
      else if(phsflg.eq.0.and.gf.eq.2) then 
         call locate(bnr2,mbin1rs,ndgvn2,m1)
         if(m1.eq.0) then
            ioutfl=1  
            j1=1
            j2=2
         else if(m1.eq.mbin1rs) then
            j1=mbin1rs-1
            j2=mbin1rs
         else
            j1=m1
            j2=m1+1
         end if
         
         n1=0 
         do 401 jj=j1,j2  
            n1=n1+1
            xnb(n1)= bnr2(jj) 
            do m2=1,mbin2rs
               xx0(m2)= sdr(jj,m2)
            end do
            call locate(xx0,mbin2rs,given(gf),m2)            
            if(m2.eq.0) then 
               if(given(gf).lt.xx0(1)/5d0)then
                  Tm=0d0
                  ub=0d0
                  return
               else
                  k1=1
                  k2=2
               endif
            else if(m2.eq.mbin2rs) then
               k1=mbin2rs-1
               k2=mbin2rs
            else
               k1=m2
               k2=m2+1
            end if            
            n2=0 
            do 411 kk=k1,k2
               n2=n2+1 
               xx1(n2)= sdr(jj,kk)
               yyt(n2)= Tmr2(jj,kk)
               yym(n2)= ubr2(jj,kk)  
CCC   to incorporate strangeness 
               yys(n2)= usr2(jj,kk)
CCC   to incorporate strangeness			              
 411        continue
            pp=(log(given(gf))-log(xx1(1)))/(log(xx1(2))-log(xx1(1)))
            ttin(n1)=(1.d0-pp)*yyt(1)+pp*yyt(2)
            muin(n1)=(1.d0-pp)*yym(1)+pp*yym(2)
CCC   to incorporate strangeness
            msin(n1)=(1.d0-pp)*yys(1)+pp*yys(2)
CCC   to incorporate strangeness
c            call polint11(xx1,yyt,5,2,given(gf),ttin(n1),error)
c            call polint11(xx1,yym,5,2,given(gf),muin(n1),error)
 401     continue
      end if
ccc   #############################################################
      pp=(ndgvn2-xnb(1))/(xnb(2)-xnb(1))
      if( (gf.eq.2) .and. (phsflg.eq.0) .and. 
     &    ( given(gf).lt.yyy(ndgvn2) ) )then
        pp=(log(ndgvn2+1.d-50)-log(xnb(1)))/(log(xnb(2))-log(xnb(1)))
      endif
      Tm=(1.d0-pp)*ttin(1)+pp*ttin(2)
      if(ioutfl.eq.1)then
         ub=ndgvn2/xnb(1)*muin(1)
CCC   to incorporate strangeness
         us=ndgvn2/xnb(1)*msin(1)
CCC   to incorporate strangeness
      else
         ub=(1.d0-pp)*muin(1)+pp*muin(2)
CCC   to incorporate strangeness
         us=(1.d0-pp)*msin(1)+pp*msin(2)
CCC   to incorporate strangeness
      endif
c      call polint11(xnb,ttin,5,2,ndgvn2,Tm,error)
c      call polint11(xnb,muin,5,2,ndgvn2,ub,error)
      ub=ub*sign 
CCC   to incorporate strangeness
      us=us*sign
CCC   to incorporate strangeness
ccc   #############################################################
      RETURN 
      END 


      



C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   for finding Tm and ub from data table and interpolation
CCC   #################################################################
CCC   last updated at 05062006
CCC   adopted Otavio's version
CCC   #################################################################
      subroutine tmintp_crossover(gf,given,Tm,ub)
      implicit none
      include 'spherio.crossover.inc'
      integer gf
      double precision given(3),Tm,ub
      double precision nb,anb,egy,etr
      integer k,i,k1,k2
      double precision yy1(500),yy2(500),p1,p2,z1,z2,p
      double precision sinal

      nb=given(3)
      if(nb.lt.0.)then
         anb=-nb
         sinal=-1.
      else
         anb=nb
         sinal=1.
      endif

      if(gf.eq.1)then
        egy=given(gf)
        call intp2d(bn1,en,Tm1,nwe1,nwe2,mbin1e,mbin2e,anb,egy,0,Tm)
        call intp2d(bn1,en,ub1,nwe1,nwe2,mbin1e,mbin2e,anb,egy,1,ub)
        ub=sinal*ub
      else if(gf.eq.2)then
        etr=given(gf)
        call intp2d(bn2,sn,Tm2,nws1,nws2,mbin1s,mbin2s,anb,etr,0,Tm)
        call intp2d(bn2,sn,ub2,nws1,nws2,mbin1s,mbin2s,anb,etr,1,ub)
        ub=sinal*ub
      endif

      return
      end


C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@



CCC   #################################################################
CCC   for reading data table of the e(s)nb->Tm/mu in SPheRIO \(^^) 
CCC   #################################################################
CCC   last updated at 04302006
CCC   to incorporate the strangeness
CCC   as a first step, the strangeness chemical potential is defined
CCC   they are usq1, usr1, usq2, usr2
CCC   but they are not input from the data file
CCC   they are assigned to be zero at this point   
CCC   spherio.tmu.inc, spherio.const.inc and spherio.fnames.inc are included                 
CCC   #################################################################
      SUBROUTINE tmuread() 
      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.tmu.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'

      INTEGER m1,m2
      CHARACTER filename1*108, filename2*108
c     ------------------------------------------------------

CCC   for energy density... 
      filename1= fneos(1:nfneos)//eosdatapath1//tmuef1
      filename2= fneos(1:nfneos)//eosdatapath1//tmuef2

CCC   == DATA READING == //////////////////////////////////////
      OPEN(10,file=filename1,status='unknown') 
      READ(10,'(2i8)') mbin1qe,mbin2qe 
      do m1=1,mbin1qe            !! for baryon number density 
         do m2=1,mbin2qe         !! for energy density 
            READ(10,'(4d16.8)') 
     &           bnq1(m1),enq(m1,m2),Tmq1(m1,m2),ubq1(m1,m2)

CCC   temporary setting for debug purpose only
                 usq1(m1,m2)=zero
CCC   temporary setting for debug purpose only

         end do
      end do
      CLOSE(10)
CCC   /////////////////////////////////////////////////////////
      OPEN(10,file=filename2,status='unknown') 
      READ(10,'(2i8)') mbin1re,mbin2re 
      do m1=1,mbin1re            !! for baryon number density 
         do m2=1,mbin2re         !! for energy density 
            READ(10,'(4d16.8)') 
     &           bnr1(m1),enr(m1,m2),Tmr1(m1,m2),ubr1(m1,m2)

CCC   temporary setting for debug purpose only
                 usr1(m1,m2)=zero
CCC   temporary setting for debug purpose only

         end do
      end do
      CLOSE(10)
CCC   ///////////////////////////== DATA READING END == //////

CCC   for entropy density... 
      filename1= fneos(1:nfneos)//eosdatapath1//tmusf1
      filename2= fneos(1:nfneos)//eosdatapath1//tmusf2

CCC   == DATA READING == //////////////////////////////////////
      OPEN(10,file=filename1,status='unknown') 
      READ(10,'(2i8)') mbin1qs,mbin2qs 
      do m1=1,mbin1qs            !! for baryon number density 
         do m2=1,mbin2qs         !! for entropy density 
            READ(10,'(4d16.8)') 
     &           bnq2(m1),sdq(m1,m2),Tmq2(m1,m2),ubq2(m1,m2)

CCC   temporary setting for debug purpose only
                 usq2(m1,m2)=zero
CCC   temporary setting for debug purpose only

         end do
      end do
      CLOSE(10)
CCC   /////////////////////////////////////////////////////////
      OPEN(10,file=filename2,status='unknown') 
      READ(10,'(2i8)') mbin1rs,mbin2rs 
      do m1=1,mbin1rs            !! for baryon number density 
         do m2=1,mbin2rs         !! for entropy density 
            READ(10,'(4d16.8)') 
     &           bnr2(m1),sdr(m1,m2),Tmr2(m1,m2),ubr2(m1,m2)

CCC   temporary setting for debug purpose only
                 usr2(m1,m2)=zero
CCC   temporary setting for debug purpose only

         end do
      end do
      CLOSE(10)
CCC   ///////////////////////////== DATA READING END == ///////
      RETURN
      STOP 
      END 





CCC   #################################################################
CCC   for reading data table of the e(s)nb->Tm/mu in SPheRIO \(^^) 
CCC   #################################################################
CCC   last updated 05072011
CCC   adopted Otavio's version
CCC   #################################################################
      SUBROUTINE tmuread_crossover()
      IMPLICIT NONE 
      include 'epos.incsf'
      include 'spherio.crossover.inc'
      include 'spherio.fnames.inc'
      include 'spherio.const.inc'
      INTEGER m1,m2
      CHARACTER filename1*108, filename2*108
c     ------------------------------------------------------
      filename1= fneos(1:nfneos)//eosdatapath4//tmuefco1
      filename2= fneos(1:nfneos)//eosdatapath4//tmuefco2

CCC   for energy density... 
CCC   == DATA READING == //////////////////////////////////////
      OPEN(10,file=filename1,status='unknown') 
      READ(10,*) mbin1e,mbin2e 
      do m1=1,mbin1e            !! for baryon number density 
         do m2=1,mbin2e         !! for energy density 
            READ(10,*) bn1(m1),en(m1,m2),Tm1(m1,m2),ub1(m1,m2)
         end do
      end do
      CLOSE(10)
CCC   /////////////////////////////////////////////////////////

CCC   for entropy density... 
CCC   == DATA READING == //////////////////////////////////////
      OPEN(10,file=filename2,status='unknown') 
      READ(10,*) mbin1s,mbin2s 
      do m1=1,mbin1s            !! for baryon number density 
         do m2=1,mbin2s         !! for entropy density 
            READ(10,*) 
     &           bn2(m1),sn(m1,m2),Tm2(m1,m2),ub2(m1,m2)
         end do
      end do
      CLOSE(10)
CCC   /////////////////////////////////////////////////////////

      RETURN
      END 






CCC   #################################################################
CCC   usrfun()
CCC   #################################################################
CCC   last updated at 05072006
CCC   es, es1, es2 is expend from (1:4,0:2) --> (1:5,0:2) to adopt
CCC   the modification in thintp()
CCC   although, the output esqr(5,0) has not actually been used here
CCC   #################################################################
      subroutine usrfun(x,n,fvec,fjac,given,gf,phsflg)

      implicit none
      double precision x(2),fvec(2),fjac(2,2),given(3)
      double precision T,ub,ht,hu,temp,EPS
      double precision es(1:5,0:2),es1(1:5,0:2),es2(1:5,0:2)
      parameter (EPS=1.d-4)
      integer n,phsflg,gf

      T=x(1)
      ub=x(2)

      ht=EPS*abs(T)
      if(ht.eq.0.d0)ht=EPS
      temp=T+ht
      ht=temp-T
      
      hu=EPS*abs(ub)
      if(hu.eq.0.d0)hu=EPS
      temp=ub+hu
      hu=temp-ub
      
      call thintp(phsflg,T,ub,es)

      fvec(1)=es(gf,0)-given(gf)
      fvec(2)=es(3,0)-given(3)
 
      call thintp(phsflg,T+ht,ub   ,es1)
      call thintp(phsflg,T   ,ub+hu,es2)     

      fjac(1,1)=(es1(gf,0)-es(gf,0))/ht
      fjac(1,2)=(es2(gf,0)-es(gf,0))/hu
      fjac(2,1)=(es1(3,0)-es(3,0))/ht
      fjac(2,2)=(es2(3,0)-es(3,0))/hu

      return
      end



